// A Bison parser, made by GNU Bison 3.0.2.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2013 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// Take the name prefix into account.
#define yylex   Dynarelex

// First part of user declarations.
#line 30 "DynareBison.yy" // lalr1.cc:399

class ParsingDriver;

#include "ExprNode.hh"
#include "CodeInterpreter.hh"

/* Little hack: we redefine the macro which computes the locations, because
   we need to access the location from within the parsing driver for error
   and warning messages. */
#define YYLLOC_DEFAULT(Current, Rhs, N)                         \
  do {                                                          \
    if (N)                                                      \
      {                                                         \
        (Current).begin = YYRHSLOC(Rhs, 1).begin;               \
        (Current).end   = YYRHSLOC(Rhs, N).end;                 \
      }                                                         \
    else                                                        \
      {                                                         \
        (Current).begin = (Current).end = YYRHSLOC(Rhs, 0).end;	\
      }                                                         \
    driver.location = (Current);                                \
  } while(false)


#line 63 "DynareBison.cc" // lalr1.cc:399

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

#include "DynareBison.hh"

// User implementation prologue.
#line 80 "DynareBison.yy" // lalr1.cc:407

#include "ParsingDriver.hh"

/* this "connects" the bison parser in the driver to the flex scanner class
 * object. it defines the yylex() function call to pull the next token from the
 * current lexer object of the driver context. */
#undef yylex
#define yylex driver.lexer->lex

#line 86 "DynareBison.cc" // lalr1.cc:407


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (/*CONSTCOND*/ false)
# endif


// Suppress unused-variable warnings by "using" E.
#define YYUSE(E) ((void) (E))

// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << std::endl;                  \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yystack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE(Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void>(0)
# define YY_STACK_PRINT()                static_cast<void>(0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyempty = true)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)


namespace Dynare {
#line 172 "DynareBison.cc" // lalr1.cc:474

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr = "";
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              // Fall through.
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }


  /// Build a parser object.
  parser::parser (ParsingDriver &driver_yyarg)
    :
#if YYDEBUG
      yydebug_ (false),
      yycdebug_ (&std::cerr),
#endif
      driver (driver_yyarg)
  {}

  parser::~parser ()
  {}


  /*---------------.
  | Symbol types.  |
  `---------------*/

  inline
  parser::syntax_error::syntax_error (const location_type& l, const std::string& m)
    : std::runtime_error (m)
    , location (l)
  {}

  // basic_symbol.
  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol ()
    : value ()
  {}

  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& other)
    : Base (other)
    , value ()
    , location (other.location)
  {
    value = other.value;
  }


  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const semantic_type& v, const location_type& l)
    : Base (t)
    , value (v)
    , location (l)
  {}


  /// Constructor for valueless symbols.
  template <typename Base>
  inline
  parser::basic_symbol<Base>::basic_symbol (typename Base::kind_type t, const location_type& l)
    : Base (t)
    , value ()
    , location (l)
  {}

  template <typename Base>
  inline
  parser::basic_symbol<Base>::~basic_symbol ()
  {
  }

  template <typename Base>
  inline
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move(s);
    value = s.value;
    location = s.location;
  }

  // by_type.
  inline
  parser::by_type::by_type ()
     : type (empty)
  {}

  inline
  parser::by_type::by_type (const by_type& other)
    : type (other.type)
  {}

  inline
  parser::by_type::by_type (token_type t)
    : type (yytranslate_ (t))
  {}

  inline
  void
  parser::by_type::move (by_type& that)
  {
    type = that.type;
    that.type = empty;
  }

  inline
  int
  parser::by_type::type_get () const
  {
    return type;
  }


  // by_state.
  inline
  parser::by_state::by_state ()
    : state (empty)
  {}

  inline
  parser::by_state::by_state (const by_state& other)
    : state (other.state)
  {}

  inline
  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.state = empty;
  }

  inline
  parser::by_state::by_state (state_type s)
    : state (s)
  {}

  inline
  parser::symbol_number_type
  parser::by_state::type_get () const
  {
    return state == empty ? 0 : yystos_[state];
  }

  inline
  parser::stack_symbol_type::stack_symbol_type ()
  {}


  inline
  parser::stack_symbol_type::stack_symbol_type (state_type s, symbol_type& that)
    : super_type (s, that.location)
  {
    value = that.value;
    // that is emptied.
    that.type = empty;
  }

  inline
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    value = that.value;
    location = that.location;
    return *this;
  }


  template <typename Base>
  inline
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);

    // User destructor.
    YYUSE (yysym.type_get ());
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo,
                                     const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    symbol_number_type yytype = yysym.type_get ();
    yyo << (yytype < yyntokens_ ? "token" : "nterm")
        << ' ' << yytname_[yytype] << " ("
        << yysym.location << ": ";
    YYUSE (yytype);
    yyo << ')';
  }
#endif

  inline
  void
  parser::yypush_ (const char* m, state_type s, symbol_type& sym)
  {
    stack_symbol_type t (s, sym);
    yypush_ (m, t);
  }

  inline
  void
  parser::yypush_ (const char* m, stack_symbol_type& s)
  {
    if (m)
      YY_SYMBOL_PRINT (m, s);
    yystack_.push (s);
  }

  inline
  void
  parser::yypop_ (unsigned int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  inline parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - yyntokens_] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - yyntokens_];
  }

  inline bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  inline bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::parse ()
  {
    /// Whether yyla contains a lookahead.
    bool yyempty = true;

    // State.
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

    // FIXME: This shoud be completely indented.  It is not yet to
    // avoid gratuitous conflicts when merging into the master branch.
    try
      {
    YYCDEBUG << "Starting parse" << std::endl;


    // User initialization code.
    #line 62 "DynareBison.yy" // lalr1.cc:725
{
  // Initialize the locations' filenames to the filename maintained by the lexer
  yyla.location.begin.filename = yyla.location.end.filename = &(driver.lexer->filename);
}

#line 516 "DynareBison.cc" // lalr1.cc:725

    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, yyla);

    // A new symbol was pushed on the stack.
  yynewstate:
    YYCDEBUG << "Entering state " << yystack_[0].state << std::endl;

    // Accept?
    if (yystack_[0].state == yyfinal_)
      goto yyacceptlab;

    goto yybackup;

    // Backup.
  yybackup:

    // Try to take a decision without lookahead.
    yyn = yypact_[yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyempty)
      {
        YYCDEBUG << "Reading a token: ";
        try
          {
            yyla.type = yytranslate_ (yylex (&yyla.value, &yyla.location, driver));
          }
        catch (const syntax_error& yyexc)
          {
            error (yyexc);
            goto yyerrlab1;
          }
        yyempty = false;
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.type_get ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.type_get ())
      goto yydefault;

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Discard the token being shifted.
    yyempty = true;

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", yyn, yyla);
    goto yynewstate;

  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;

  /*-----------------------------.
  | yyreduce -- Do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_(yystack_[yylen].state, yyr1_[yyn]);
      /* If YYLEN is nonzero, implement the default value of the
         action: '$$ = $1'.  Otherwise, use the top of the stack.

         Otherwise, the following line sets YYLHS.VALUE to garbage.
         This behavior is undocumented and Bison users should not rely
         upon it.  */
      if (yylen)
        yylhs.value = yystack_[yylen - 1].value;
      else
        yylhs.value = yystack_[0].value;

      // Compute the default @$.
      {
        slice<stack_symbol_type, stack_type> slice (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, slice, yylen);
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
      try
        {
          switch (yyn)
            {
  case 83:
#line 276 "DynareBison.yy" // lalr1.cc:847
    { driver.dsample((yystack_[1].value.string_val)); }
#line 630 "DynareBison.cc" // lalr1.cc:847
    break;

  case 84:
#line 278 "DynareBison.yy" // lalr1.cc:847
    { driver.dsample((yystack_[2].value.string_val), (yystack_[1].value.string_val)); }
#line 636 "DynareBison.cc" // lalr1.cc:847
    break;

  case 85:
#line 281 "DynareBison.yy" // lalr1.cc:847
    { driver.rplot(); }
#line 642 "DynareBison.cc" // lalr1.cc:847
    break;

  case 86:
#line 283 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_trend(); }
#line 648 "DynareBison.cc" // lalr1.cc:847
    break;

  case 87:
#line 284 "DynareBison.yy" // lalr1.cc:847
    { driver.end_trend_var((yystack_[3].value.node_val)); }
#line 654 "DynareBison.cc" // lalr1.cc:847
    break;

  case 88:
#line 288 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[0].value.string_val)); }
#line 660 "DynareBison.cc" // lalr1.cc:847
    break;

  case 89:
#line 290 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[0].value.string_val)); }
#line 666 "DynareBison.cc" // lalr1.cc:847
    break;

  case 90:
#line 292 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[0].value.string_val)); }
#line 672 "DynareBison.cc" // lalr1.cc:847
    break;

  case 91:
#line 294 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 678 "DynareBison.cc" // lalr1.cc:847
    break;

  case 92:
#line 296 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 684 "DynareBison.cc" // lalr1.cc:847
    break;

  case 93:
#line 298 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(false, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 690 "DynareBison.cc" // lalr1.cc:847
    break;

  case 94:
#line 301 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_trend(); }
#line 696 "DynareBison.cc" // lalr1.cc:847
    break;

  case 95:
#line 302 "DynareBison.yy" // lalr1.cc:847
    { driver.end_trend_var((yystack_[3].value.node_val)); }
#line 702 "DynareBison.cc" // lalr1.cc:847
    break;

  case 96:
#line 306 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[0].value.string_val)); }
#line 708 "DynareBison.cc" // lalr1.cc:847
    break;

  case 97:
#line 308 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[0].value.string_val)); }
#line 714 "DynareBison.cc" // lalr1.cc:847
    break;

  case 98:
#line 310 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[0].value.string_val)); }
#line 720 "DynareBison.cc" // lalr1.cc:847
    break;

  case 99:
#line 312 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 726 "DynareBison.cc" // lalr1.cc:847
    break;

  case 100:
#line 314 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 732 "DynareBison.cc" // lalr1.cc:847
    break;

  case 101:
#line 316 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_trend_var(true, (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 738 "DynareBison.cc" // lalr1.cc:847
    break;

  case 103:
#line 320 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_trend(); }
#line 744 "DynareBison.cc" // lalr1.cc:847
    break;

  case 104:
#line 321 "DynareBison.yy" // lalr1.cc:847
    { driver.end_nonstationary_var(false, (yystack_[3].value.node_val)); }
#line 750 "DynareBison.cc" // lalr1.cc:847
    break;

  case 105:
#line 322 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_trend(); }
#line 756 "DynareBison.cc" // lalr1.cc:847
    break;

  case 106:
#line 323 "DynareBison.yy" // lalr1.cc:847
    { driver.end_nonstationary_var(true, (yystack_[3].value.node_val)); }
#line 762 "DynareBison.cc" // lalr1.cc:847
    break;

  case 107:
#line 327 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[0].value.string_val)); }
#line 768 "DynareBison.cc" // lalr1.cc:847
    break;

  case 108:
#line 329 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[0].value.string_val)); }
#line 774 "DynareBison.cc" // lalr1.cc:847
    break;

  case 109:
#line 331 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[0].value.string_val)); }
#line 780 "DynareBison.cc" // lalr1.cc:847
    break;

  case 110:
#line 333 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 786 "DynareBison.cc" // lalr1.cc:847
    break;

  case 111:
#line 335 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 792 "DynareBison.cc" // lalr1.cc:847
    break;

  case 112:
#line 337 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 798 "DynareBison.cc" // lalr1.cc:847
    break;

  case 113:
#line 339 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 804 "DynareBison.cc" // lalr1.cc:847
    break;

  case 114:
#line 341 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 810 "DynareBison.cc" // lalr1.cc:847
    break;

  case 115:
#line 343 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 816 "DynareBison.cc" // lalr1.cc:847
    break;

  case 116:
#line 345 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 822 "DynareBison.cc" // lalr1.cc:847
    break;

  case 117:
#line 347 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 828 "DynareBison.cc" // lalr1.cc:847
    break;

  case 118:
#line 349 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_nonstationary_var((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 834 "DynareBison.cc" // lalr1.cc:847
    break;

  case 123:
#line 361 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 840 "DynareBison.cc" // lalr1.cc:847
    break;

  case 124:
#line 365 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[0].value.string_val)); }
#line 846 "DynareBison.cc" // lalr1.cc:847
    break;

  case 125:
#line 367 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[0].value.string_val)); }
#line 852 "DynareBison.cc" // lalr1.cc:847
    break;

  case 126:
#line 369 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[0].value.string_val)); }
#line 858 "DynareBison.cc" // lalr1.cc:847
    break;

  case 127:
#line 371 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 864 "DynareBison.cc" // lalr1.cc:847
    break;

  case 128:
#line 373 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 870 "DynareBison.cc" // lalr1.cc:847
    break;

  case 129:
#line 375 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 876 "DynareBison.cc" // lalr1.cc:847
    break;

  case 130:
#line 377 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 882 "DynareBison.cc" // lalr1.cc:847
    break;

  case 131:
#line 379 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 888 "DynareBison.cc" // lalr1.cc:847
    break;

  case 132:
#line 381 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 894 "DynareBison.cc" // lalr1.cc:847
    break;

  case 133:
#line 383 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 900 "DynareBison.cc" // lalr1.cc:847
    break;

  case 134:
#line 385 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 906 "DynareBison.cc" // lalr1.cc:847
    break;

  case 135:
#line 387 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_endogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 912 "DynareBison.cc" // lalr1.cc:847
    break;

  case 136:
#line 391 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[0].value.string_val)); }
#line 918 "DynareBison.cc" // lalr1.cc:847
    break;

  case 137:
#line 393 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[0].value.string_val)); }
#line 924 "DynareBison.cc" // lalr1.cc:847
    break;

  case 138:
#line 395 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[0].value.string_val)); }
#line 930 "DynareBison.cc" // lalr1.cc:847
    break;

  case 139:
#line 397 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 936 "DynareBison.cc" // lalr1.cc:847
    break;

  case 140:
#line 399 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 942 "DynareBison.cc" // lalr1.cc:847
    break;

  case 141:
#line 401 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 948 "DynareBison.cc" // lalr1.cc:847
    break;

  case 142:
#line 403 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 954 "DynareBison.cc" // lalr1.cc:847
    break;

  case 143:
#line 405 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 960 "DynareBison.cc" // lalr1.cc:847
    break;

  case 144:
#line 407 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 966 "DynareBison.cc" // lalr1.cc:847
    break;

  case 145:
#line 409 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 972 "DynareBison.cc" // lalr1.cc:847
    break;

  case 146:
#line 411 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 978 "DynareBison.cc" // lalr1.cc:847
    break;

  case 147:
#line 413 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 984 "DynareBison.cc" // lalr1.cc:847
    break;

  case 148:
#line 417 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[0].value.string_val)); }
#line 990 "DynareBison.cc" // lalr1.cc:847
    break;

  case 149:
#line 419 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[0].value.string_val)); }
#line 996 "DynareBison.cc" // lalr1.cc:847
    break;

  case 150:
#line 421 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[0].value.string_val)); }
#line 1002 "DynareBison.cc" // lalr1.cc:847
    break;

  case 151:
#line 423 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1008 "DynareBison.cc" // lalr1.cc:847
    break;

  case 152:
#line 425 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1014 "DynareBison.cc" // lalr1.cc:847
    break;

  case 153:
#line 427 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1020 "DynareBison.cc" // lalr1.cc:847
    break;

  case 154:
#line 429 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1026 "DynareBison.cc" // lalr1.cc:847
    break;

  case 155:
#line 431 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1032 "DynareBison.cc" // lalr1.cc:847
    break;

  case 156:
#line 433 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1038 "DynareBison.cc" // lalr1.cc:847
    break;

  case 157:
#line 435 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1044 "DynareBison.cc" // lalr1.cc:847
    break;

  case 158:
#line 437 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1050 "DynareBison.cc" // lalr1.cc:847
    break;

  case 159:
#line 439 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_exogenous_det((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1056 "DynareBison.cc" // lalr1.cc:847
    break;

  case 160:
#line 443 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[0].value.string_val)); }
#line 1062 "DynareBison.cc" // lalr1.cc:847
    break;

  case 161:
#line 445 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[0].value.string_val)); }
#line 1068 "DynareBison.cc" // lalr1.cc:847
    break;

  case 162:
#line 447 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[0].value.string_val)); }
#line 1074 "DynareBison.cc" // lalr1.cc:847
    break;

  case 163:
#line 449 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1080 "DynareBison.cc" // lalr1.cc:847
    break;

  case 164:
#line 451 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1086 "DynareBison.cc" // lalr1.cc:847
    break;

  case 165:
#line 453 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), NULL, (yystack_[0].value.string_val)); }
#line 1092 "DynareBison.cc" // lalr1.cc:847
    break;

  case 166:
#line 455 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1098 "DynareBison.cc" // lalr1.cc:847
    break;

  case 167:
#line 457 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1104 "DynareBison.cc" // lalr1.cc:847
    break;

  case 168:
#line 459 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1110 "DynareBison.cc" // lalr1.cc:847
    break;

  case 169:
#line 461 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1116 "DynareBison.cc" // lalr1.cc:847
    break;

  case 170:
#line 463 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1122 "DynareBison.cc" // lalr1.cc:847
    break;

  case 171:
#line 465 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_parameter((yystack_[2].value.string_val), (yystack_[1].value.string_val), (yystack_[0].value.string_val)); }
#line 1128 "DynareBison.cc" // lalr1.cc:847
    break;

  case 172:
#line 469 "DynareBison.yy" // lalr1.cc:847
    { driver.add_predetermined_variable((yystack_[0].value.string_val)); }
#line 1134 "DynareBison.cc" // lalr1.cc:847
    break;

  case 173:
#line 471 "DynareBison.yy" // lalr1.cc:847
    { driver.add_predetermined_variable((yystack_[0].value.string_val)); }
#line 1140 "DynareBison.cc" // lalr1.cc:847
    break;

  case 174:
#line 473 "DynareBison.yy" // lalr1.cc:847
    { driver.add_predetermined_variable((yystack_[0].value.string_val)); }
#line 1146 "DynareBison.cc" // lalr1.cc:847
    break;

  case 175:
#line 477 "DynareBison.yy" // lalr1.cc:847
    { driver.change_type((yystack_[3].value.symbol_type_val), (yystack_[1].value.vector_string_val)); }
#line 1152 "DynareBison.cc" // lalr1.cc:847
    break;

  case 176:
#line 481 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.symbol_type_val) = eParameter; }
#line 1158 "DynareBison.cc" // lalr1.cc:847
    break;

  case 177:
#line 483 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.symbol_type_val) = eEndogenous; }
#line 1164 "DynareBison.cc" // lalr1.cc:847
    break;

  case 178:
#line 485 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.symbol_type_val) = eExogenous; }
#line 1170 "DynareBison.cc" // lalr1.cc:847
    break;

  case 179:
#line 487 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.symbol_type_val) = eExogenousDet; }
#line 1176 "DynareBison.cc" // lalr1.cc:847
    break;

  case 180:
#line 491 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_string_val) = new vector<string *>(); (yylhs.value.vector_string_val)->push_back((yystack_[0].value.string_val)); }
#line 1182 "DynareBison.cc" // lalr1.cc:847
    break;

  case 181:
#line 493 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_string_val) = (yystack_[1].value.vector_string_val); (yystack_[1].value.vector_string_val)->push_back((yystack_[0].value.string_val)); }
#line 1188 "DynareBison.cc" // lalr1.cc:847
    break;

  case 182:
#line 495 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_string_val) = (yystack_[2].value.vector_string_val); (yystack_[2].value.vector_string_val)->push_back((yystack_[0].value.string_val)); }
#line 1194 "DynareBison.cc" // lalr1.cc:847
    break;

  case 183:
#line 499 "DynareBison.yy" // lalr1.cc:847
    { driver.periods((yystack_[1].value.string_val)); }
#line 1200 "DynareBison.cc" // lalr1.cc:847
    break;

  case 184:
#line 501 "DynareBison.yy" // lalr1.cc:847
    { driver.periods((yystack_[1].value.string_val)); }
#line 1206 "DynareBison.cc" // lalr1.cc:847
    break;

  case 185:
#line 504 "DynareBison.yy" // lalr1.cc:847
    { driver.init_param((yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1212 "DynareBison.cc" // lalr1.cc:847
    break;

  case 186:
#line 507 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = (yystack_[1].value.node_val);}
#line 1218 "DynareBison.cc" // lalr1.cc:847
    break;

  case 187:
#line 509 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_expression_variable((yystack_[0].value.string_val)); }
#line 1224 "DynareBison.cc" // lalr1.cc:847
    break;

  case 188:
#line 511 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_non_negative_constant((yystack_[0].value.string_val)); }
#line 1230 "DynareBison.cc" // lalr1.cc:847
    break;

  case 189:
#line 513 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_plus((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1236 "DynareBison.cc" // lalr1.cc:847
    break;

  case 190:
#line 515 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_minus((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1242 "DynareBison.cc" // lalr1.cc:847
    break;

  case 191:
#line 517 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_divide((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1248 "DynareBison.cc" // lalr1.cc:847
    break;

  case 192:
#line 519 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_times((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1254 "DynareBison.cc" // lalr1.cc:847
    break;

  case 193:
#line 521 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_power((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1260 "DynareBison.cc" // lalr1.cc:847
    break;

  case 194:
#line 523 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_less((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1266 "DynareBison.cc" // lalr1.cc:847
    break;

  case 195:
#line 525 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_greater((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1272 "DynareBison.cc" // lalr1.cc:847
    break;

  case 196:
#line 527 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_less_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1278 "DynareBison.cc" // lalr1.cc:847
    break;

  case 197:
#line 529 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_greater_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1284 "DynareBison.cc" // lalr1.cc:847
    break;

  case 198:
#line 531 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_equal_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1290 "DynareBison.cc" // lalr1.cc:847
    break;

  case 199:
#line 533 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_different((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1296 "DynareBison.cc" // lalr1.cc:847
    break;

  case 200:
#line 535 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_uminus((yystack_[0].value.node_val)); }
#line 1302 "DynareBison.cc" // lalr1.cc:847
    break;

  case 201:
#line 537 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = (yystack_[0].value.node_val); }
#line 1308 "DynareBison.cc" // lalr1.cc:847
    break;

  case 202:
#line 539 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_exp((yystack_[1].value.node_val)); }
#line 1314 "DynareBison.cc" // lalr1.cc:847
    break;

  case 203:
#line 541 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log((yystack_[1].value.node_val)); }
#line 1320 "DynareBison.cc" // lalr1.cc:847
    break;

  case 204:
#line 543 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log((yystack_[1].value.node_val)); }
#line 1326 "DynareBison.cc" // lalr1.cc:847
    break;

  case 205:
#line 545 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log10((yystack_[1].value.node_val)); }
#line 1332 "DynareBison.cc" // lalr1.cc:847
    break;

  case 206:
#line 547 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sin((yystack_[1].value.node_val)); }
#line 1338 "DynareBison.cc" // lalr1.cc:847
    break;

  case 207:
#line 549 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_cos((yystack_[1].value.node_val)); }
#line 1344 "DynareBison.cc" // lalr1.cc:847
    break;

  case 208:
#line 551 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_tan((yystack_[1].value.node_val)); }
#line 1350 "DynareBison.cc" // lalr1.cc:847
    break;

  case 209:
#line 553 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_asin((yystack_[1].value.node_val)); }
#line 1356 "DynareBison.cc" // lalr1.cc:847
    break;

  case 210:
#line 555 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_acos((yystack_[1].value.node_val)); }
#line 1362 "DynareBison.cc" // lalr1.cc:847
    break;

  case 211:
#line 557 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_atan((yystack_[1].value.node_val)); }
#line 1368 "DynareBison.cc" // lalr1.cc:847
    break;

  case 212:
#line 559 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sqrt((yystack_[1].value.node_val)); }
#line 1374 "DynareBison.cc" // lalr1.cc:847
    break;

  case 213:
#line 561 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_abs((yystack_[1].value.node_val)); }
#line 1380 "DynareBison.cc" // lalr1.cc:847
    break;

  case 214:
#line 563 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sign((yystack_[1].value.node_val)); }
#line 1386 "DynareBison.cc" // lalr1.cc:847
    break;

  case 215:
#line 565 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_max((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1392 "DynareBison.cc" // lalr1.cc:847
    break;

  case 216:
#line 567 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_min((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1398 "DynareBison.cc" // lalr1.cc:847
    break;

  case 217:
#line 568 "DynareBison.yy" // lalr1.cc:847
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 1404 "DynareBison.cc" // lalr1.cc:847
    break;

  case 218:
#line 569 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_var_or_external_function((yystack_[4].value.string_val), false); }
#line 1410 "DynareBison.cc" // lalr1.cc:847
    break;

  case 219:
#line 571 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normcdf((yystack_[5].value.node_val), (yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1416 "DynareBison.cc" // lalr1.cc:847
    break;

  case 220:
#line 573 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normcdf((yystack_[1].value.node_val)); }
#line 1422 "DynareBison.cc" // lalr1.cc:847
    break;

  case 221:
#line 575 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normpdf((yystack_[5].value.node_val), (yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1428 "DynareBison.cc" // lalr1.cc:847
    break;

  case 222:
#line 577 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normpdf((yystack_[1].value.node_val)); }
#line 1434 "DynareBison.cc" // lalr1.cc:847
    break;

  case 223:
#line 579 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_erf((yystack_[1].value.node_val)); }
#line 1440 "DynareBison.cc" // lalr1.cc:847
    break;

  case 224:
#line 581 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_nan_constant(); }
#line 1446 "DynareBison.cc" // lalr1.cc:847
    break;

  case 225:
#line 583 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_inf_constant(); }
#line 1452 "DynareBison.cc" // lalr1.cc:847
    break;

  case 226:
#line 587 "DynareBison.yy" // lalr1.cc:847
    { driver.add_external_function_arg((yystack_[0].value.node_val)); }
#line 1458 "DynareBison.cc" // lalr1.cc:847
    break;

  case 227:
#line 589 "DynareBison.yy" // lalr1.cc:847
    { driver.add_external_function_arg((yystack_[0].value.node_val)); }
#line 1464 "DynareBison.cc" // lalr1.cc:847
    break;

  case 228:
#line 592 "DynareBison.yy" // lalr1.cc:847
    {(yylhs.value.node_val) = driver.add_nan_constant();}
#line 1470 "DynareBison.cc" // lalr1.cc:847
    break;

  case 230:
#line 597 "DynareBison.yy" // lalr1.cc:847
    { driver.end_initval(false); }
#line 1476 "DynareBison.cc" // lalr1.cc:847
    break;

  case 231:
#line 599 "DynareBison.yy" // lalr1.cc:847
    { driver.end_initval(true); }
#line 1482 "DynareBison.cc" // lalr1.cc:847
    break;

  case 232:
#line 603 "DynareBison.yy" // lalr1.cc:847
    { driver.initval_file((yystack_[2].value.string_val)); }
#line 1488 "DynareBison.cc" // lalr1.cc:847
    break;

  case 233:
#line 607 "DynareBison.yy" // lalr1.cc:847
    { driver.end_endval(false); }
#line 1494 "DynareBison.cc" // lalr1.cc:847
    break;

  case 234:
#line 609 "DynareBison.yy" // lalr1.cc:847
    { driver.end_endval(true); }
#line 1500 "DynareBison.cc" // lalr1.cc:847
    break;

  case 237:
#line 616 "DynareBison.yy" // lalr1.cc:847
    { driver.init_val((yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1506 "DynareBison.cc" // lalr1.cc:847
    break;

  case 238:
#line 618 "DynareBison.yy" // lalr1.cc:847
    { driver.end_histval(); }
#line 1512 "DynareBison.cc" // lalr1.cc:847
    break;

  case 241:
#line 624 "DynareBison.yy" // lalr1.cc:847
    { driver.hist_val((yystack_[6].value.string_val), (yystack_[4].value.string_val), (yystack_[1].value.node_val)); }
#line 1518 "DynareBison.cc" // lalr1.cc:847
    break;

  case 242:
#line 626 "DynareBison.yy" // lalr1.cc:847
    { driver.block(); }
#line 1524 "DynareBison.cc" // lalr1.cc:847
    break;

  case 245:
#line 629 "DynareBison.yy" // lalr1.cc:847
    { driver.byte_code(); }
#line 1530 "DynareBison.cc" // lalr1.cc:847
    break;

  case 246:
#line 630 "DynareBison.yy" // lalr1.cc:847
    { driver.use_dll(); }
#line 1536 "DynareBison.cc" // lalr1.cc:847
    break;

  case 247:
#line 631 "DynareBison.yy" // lalr1.cc:847
    { driver.no_static();}
#line 1542 "DynareBison.cc" // lalr1.cc:847
    break;

  case 248:
#line 632 "DynareBison.yy" // lalr1.cc:847
    { driver.differentiate_forward_vars_all(); }
#line 1548 "DynareBison.cc" // lalr1.cc:847
    break;

  case 249:
#line 633 "DynareBison.yy" // lalr1.cc:847
    { driver.differentiate_forward_vars_some(); }
#line 1554 "DynareBison.cc" // lalr1.cc:847
    break;

  case 254:
#line 642 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_model(); }
#line 1560 "DynareBison.cc" // lalr1.cc:847
    break;

  case 255:
#line 643 "DynareBison.yy" // lalr1.cc:847
    { driver.reset_data_tree(); }
#line 1566 "DynareBison.cc" // lalr1.cc:847
    break;

  case 256:
#line 644 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_model(); }
#line 1572 "DynareBison.cc" // lalr1.cc:847
    break;

  case 257:
#line 645 "DynareBison.yy" // lalr1.cc:847
    { driver.reset_data_tree(); }
#line 1578 "DynareBison.cc" // lalr1.cc:847
    break;

  case 262:
#line 655 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_equal((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1584 "DynareBison.cc" // lalr1.cc:847
    break;

  case 263:
#line 657 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_equal_with_zero_rhs((yystack_[1].value.node_val)); }
#line 1590 "DynareBison.cc" // lalr1.cc:847
    break;

  case 264:
#line 659 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_equal((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1596 "DynareBison.cc" // lalr1.cc:847
    break;

  case 265:
#line 661 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_equal_with_zero_rhs((yystack_[1].value.node_val)); }
#line 1602 "DynareBison.cc" // lalr1.cc:847
    break;

  case 268:
#line 669 "DynareBison.yy" // lalr1.cc:847
    { driver.add_equation_tags((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 1608 "DynareBison.cc" // lalr1.cc:847
    break;

  case 269:
#line 671 "DynareBison.yy" // lalr1.cc:847
    { driver.add_equation_tags((yystack_[0].value.string_val), new string()); }
#line 1614 "DynareBison.cc" // lalr1.cc:847
    break;

  case 270:
#line 675 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = (yystack_[1].value.node_val);}
#line 1620 "DynareBison.cc" // lalr1.cc:847
    break;

  case 271:
#line 677 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_variable((yystack_[0].value.string_val)); }
#line 1626 "DynareBison.cc" // lalr1.cc:847
    break;

  case 272:
#line 679 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_non_negative_constant((yystack_[0].value.string_val)); }
#line 1632 "DynareBison.cc" // lalr1.cc:847
    break;

  case 273:
#line 681 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_plus((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1638 "DynareBison.cc" // lalr1.cc:847
    break;

  case 274:
#line 683 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_minus((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1644 "DynareBison.cc" // lalr1.cc:847
    break;

  case 275:
#line 685 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_divide((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1650 "DynareBison.cc" // lalr1.cc:847
    break;

  case 276:
#line 687 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_times((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1656 "DynareBison.cc" // lalr1.cc:847
    break;

  case 277:
#line 689 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_less((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1662 "DynareBison.cc" // lalr1.cc:847
    break;

  case 278:
#line 691 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_greater((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1668 "DynareBison.cc" // lalr1.cc:847
    break;

  case 279:
#line 693 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_less_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1674 "DynareBison.cc" // lalr1.cc:847
    break;

  case 280:
#line 695 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_greater_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1680 "DynareBison.cc" // lalr1.cc:847
    break;

  case 281:
#line 697 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_equal_equal((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1686 "DynareBison.cc" // lalr1.cc:847
    break;

  case 282:
#line 699 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_different((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1692 "DynareBison.cc" // lalr1.cc:847
    break;

  case 283:
#line 701 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_power((yystack_[2].value.node_val), (yystack_[0].value.node_val)); }
#line 1698 "DynareBison.cc" // lalr1.cc:847
    break;

  case 284:
#line 703 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_expectation((yystack_[4].value.string_val), (yystack_[1].value.node_val)); }
#line 1704 "DynareBison.cc" // lalr1.cc:847
    break;

  case 285:
#line 705 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_uminus((yystack_[0].value.node_val)); }
#line 1710 "DynareBison.cc" // lalr1.cc:847
    break;

  case 286:
#line 707 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = (yystack_[0].value.node_val); }
#line 1716 "DynareBison.cc" // lalr1.cc:847
    break;

  case 287:
#line 709 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_exp((yystack_[1].value.node_val)); }
#line 1722 "DynareBison.cc" // lalr1.cc:847
    break;

  case 288:
#line 711 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log((yystack_[1].value.node_val)); }
#line 1728 "DynareBison.cc" // lalr1.cc:847
    break;

  case 289:
#line 713 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log((yystack_[1].value.node_val)); }
#line 1734 "DynareBison.cc" // lalr1.cc:847
    break;

  case 290:
#line 715 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_log10((yystack_[1].value.node_val)); }
#line 1740 "DynareBison.cc" // lalr1.cc:847
    break;

  case 291:
#line 717 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sin((yystack_[1].value.node_val)); }
#line 1746 "DynareBison.cc" // lalr1.cc:847
    break;

  case 292:
#line 719 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_cos((yystack_[1].value.node_val)); }
#line 1752 "DynareBison.cc" // lalr1.cc:847
    break;

  case 293:
#line 721 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_tan((yystack_[1].value.node_val)); }
#line 1758 "DynareBison.cc" // lalr1.cc:847
    break;

  case 294:
#line 723 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_asin((yystack_[1].value.node_val)); }
#line 1764 "DynareBison.cc" // lalr1.cc:847
    break;

  case 295:
#line 725 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_acos((yystack_[1].value.node_val)); }
#line 1770 "DynareBison.cc" // lalr1.cc:847
    break;

  case 296:
#line 727 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_atan((yystack_[1].value.node_val)); }
#line 1776 "DynareBison.cc" // lalr1.cc:847
    break;

  case 297:
#line 729 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sqrt((yystack_[1].value.node_val)); }
#line 1782 "DynareBison.cc" // lalr1.cc:847
    break;

  case 298:
#line 731 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_abs((yystack_[1].value.node_val)); }
#line 1788 "DynareBison.cc" // lalr1.cc:847
    break;

  case 299:
#line 733 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_sign((yystack_[1].value.node_val)); }
#line 1794 "DynareBison.cc" // lalr1.cc:847
    break;

  case 300:
#line 735 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_max((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1800 "DynareBison.cc" // lalr1.cc:847
    break;

  case 301:
#line 737 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_min((yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1806 "DynareBison.cc" // lalr1.cc:847
    break;

  case 302:
#line 738 "DynareBison.yy" // lalr1.cc:847
    { driver.push_external_function_arg_vector_onto_stack(); }
#line 1812 "DynareBison.cc" // lalr1.cc:847
    break;

  case 303:
#line 739 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_model_var_or_external_function((yystack_[4].value.string_val), true); }
#line 1818 "DynareBison.cc" // lalr1.cc:847
    break;

  case 304:
#line 741 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normcdf((yystack_[5].value.node_val), (yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1824 "DynareBison.cc" // lalr1.cc:847
    break;

  case 305:
#line 743 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normcdf((yystack_[1].value.node_val)); }
#line 1830 "DynareBison.cc" // lalr1.cc:847
    break;

  case 306:
#line 745 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normpdf((yystack_[5].value.node_val), (yystack_[3].value.node_val), (yystack_[1].value.node_val)); }
#line 1836 "DynareBison.cc" // lalr1.cc:847
    break;

  case 307:
#line 747 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_normpdf((yystack_[1].value.node_val)); }
#line 1842 "DynareBison.cc" // lalr1.cc:847
    break;

  case 308:
#line 749 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_erf((yystack_[1].value.node_val)); }
#line 1848 "DynareBison.cc" // lalr1.cc:847
    break;

  case 309:
#line 751 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.node_val) = driver.add_steady_state((yystack_[1].value.node_val)); }
#line 1854 "DynareBison.cc" // lalr1.cc:847
    break;

  case 310:
#line 755 "DynareBison.yy" // lalr1.cc:847
    { driver.add_external_function_arg((yystack_[0].value.node_val)); }
#line 1860 "DynareBison.cc" // lalr1.cc:847
    break;

  case 311:
#line 757 "DynareBison.yy" // lalr1.cc:847
    { driver.add_external_function_arg((yystack_[0].value.node_val)); }
#line 1866 "DynareBison.cc" // lalr1.cc:847
    break;

  case 312:
#line 761 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_and_init_model_local_variable((yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1872 "DynareBison.cc" // lalr1.cc:847
    break;

  case 313:
#line 763 "DynareBison.yy" // lalr1.cc:847
    { driver.end_shocks(); }
#line 1878 "DynareBison.cc" // lalr1.cc:847
    break;

  case 317:
#line 771 "DynareBison.yy" // lalr1.cc:847
    { driver.add_stderr_shock((yystack_[4].value.string_val), (yystack_[1].value.node_val)); }
#line 1884 "DynareBison.cc" // lalr1.cc:847
    break;

  case 318:
#line 773 "DynareBison.yy" // lalr1.cc:847
    { driver.add_var_shock((yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1890 "DynareBison.cc" // lalr1.cc:847
    break;

  case 319:
#line 775 "DynareBison.yy" // lalr1.cc:847
    { driver.add_covar_shock((yystack_[5].value.string_val), (yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1896 "DynareBison.cc" // lalr1.cc:847
    break;

  case 320:
#line 777 "DynareBison.yy" // lalr1.cc:847
    { driver.add_correl_shock((yystack_[5].value.string_val), (yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 1902 "DynareBison.cc" // lalr1.cc:847
    break;

  case 321:
#line 781 "DynareBison.yy" // lalr1.cc:847
    { driver.add_det_shock((yystack_[7].value.string_val), false); }
#line 1908 "DynareBison.cc" // lalr1.cc:847
    break;

  case 322:
#line 784 "DynareBison.yy" // lalr1.cc:847
    {driver.begin_svar_identification();}
#line 1914 "DynareBison.cc" // lalr1.cc:847
    break;

  case 323:
#line 785 "DynareBison.yy" // lalr1.cc:847
    { driver.end_svar_identification(); }
#line 1920 "DynareBison.cc" // lalr1.cc:847
    break;

  case 326:
#line 793 "DynareBison.yy" // lalr1.cc:847
    { driver.combine_lag_and_restriction((yystack_[2].value.string_val)); }
#line 1926 "DynareBison.cc" // lalr1.cc:847
    break;

  case 327:
#line 795 "DynareBison.yy" // lalr1.cc:847
    { driver.add_constants_exclusion(); }
#line 1932 "DynareBison.cc" // lalr1.cc:847
    break;

  case 328:
#line 797 "DynareBison.yy" // lalr1.cc:847
    { driver.add_restriction_equation_nbr((yystack_[1].value.string_val));}
#line 1938 "DynareBison.cc" // lalr1.cc:847
    break;

  case 329:
#line 799 "DynareBison.yy" // lalr1.cc:847
    {driver.add_restriction_equal();}
#line 1944 "DynareBison.cc" // lalr1.cc:847
    break;

  case 331:
#line 802 "DynareBison.yy" // lalr1.cc:847
    { driver.add_upper_cholesky(); }
#line 1950 "DynareBison.cc" // lalr1.cc:847
    break;

  case 332:
#line 804 "DynareBison.yy" // lalr1.cc:847
    { driver.add_lower_cholesky(); }
#line 1956 "DynareBison.cc" // lalr1.cc:847
    break;

  case 333:
#line 808 "DynareBison.yy" // lalr1.cc:847
    { driver.add_restriction_in_equation((yystack_[3].value.string_val)); }
#line 1962 "DynareBison.cc" // lalr1.cc:847
    break;

  case 334:
#line 810 "DynareBison.yy" // lalr1.cc:847
    { driver.add_restriction_in_equation((yystack_[3].value.string_val)); }
#line 1968 "DynareBison.cc" // lalr1.cc:847
    break;

  case 335:
#line 814 "DynareBison.yy" // lalr1.cc:847
    { driver.add_in_svar_restriction_symbols((yystack_[0].value.string_val)); }
#line 1974 "DynareBison.cc" // lalr1.cc:847
    break;

  case 336:
#line 816 "DynareBison.yy" // lalr1.cc:847
    { driver.add_in_svar_restriction_symbols((yystack_[0].value.string_val)); }
#line 1980 "DynareBison.cc" // lalr1.cc:847
    break;

  case 337:
#line 819 "DynareBison.yy" // lalr1.cc:847
    {driver.check_restriction_expression_constant((yystack_[0].value.node_val));}
#line 1986 "DynareBison.cc" // lalr1.cc:847
    break;

  case 341:
#line 828 "DynareBison.yy" // lalr1.cc:847
    { driver.add_positive_restriction_element((yystack_[3].value.string_val),(yystack_[1].value.string_val));}
#line 1992 "DynareBison.cc" // lalr1.cc:847
    break;

  case 342:
#line 830 "DynareBison.yy" // lalr1.cc:847
    { driver.add_positive_restriction_element((yystack_[3].value.string_val),(yystack_[1].value.string_val));}
#line 1998 "DynareBison.cc" // lalr1.cc:847
    break;

  case 343:
#line 832 "DynareBison.yy" // lalr1.cc:847
    { driver.add_negative_restriction_element((yystack_[3].value.string_val),(yystack_[1].value.string_val));}
#line 2004 "DynareBison.cc" // lalr1.cc:847
    break;

  case 344:
#line 834 "DynareBison.yy" // lalr1.cc:847
    { driver.add_positive_restriction_element((yystack_[7].value.node_val),(yystack_[3].value.string_val),(yystack_[1].value.string_val));}
#line 2010 "DynareBison.cc" // lalr1.cc:847
    break;

  case 345:
#line 838 "DynareBison.yy" // lalr1.cc:847
    { driver.markov_switching(); }
#line 2016 "DynareBison.cc" // lalr1.cc:847
    break;

  case 352:
#line 852 "DynareBison.yy" // lalr1.cc:847
    { driver.svar(); }
#line 2022 "DynareBison.cc" // lalr1.cc:847
    break;

  case 359:
#line 865 "DynareBison.yy" // lalr1.cc:847
    { driver.end_mshocks(); }
#line 2028 "DynareBison.cc" // lalr1.cc:847
    break;

  case 362:
#line 872 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[0].value.string_val)); }
#line 2034 "DynareBison.cc" // lalr1.cc:847
    break;

  case 363:
#line 874 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[0].value.string_val)); }
#line 2040 "DynareBison.cc" // lalr1.cc:847
    break;

  case 364:
#line 876 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 2046 "DynareBison.cc" // lalr1.cc:847
    break;

  case 365:
#line 878 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 2052 "DynareBison.cc" // lalr1.cc:847
    break;

  case 366:
#line 880 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 2058 "DynareBison.cc" // lalr1.cc:847
    break;

  case 367:
#line 882 "DynareBison.yy" // lalr1.cc:847
    { driver.add_period((yystack_[0].value.string_val)); }
#line 2064 "DynareBison.cc" // lalr1.cc:847
    break;

  case 368:
#line 885 "DynareBison.yy" // lalr1.cc:847
    { driver.do_sigma_e(); }
#line 2070 "DynareBison.cc" // lalr1.cc:847
    break;

  case 369:
#line 888 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[1].value.node_val)); }
#line 2076 "DynareBison.cc" // lalr1.cc:847
    break;

  case 370:
#line 890 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[1].value.node_val)); }
#line 2082 "DynareBison.cc" // lalr1.cc:847
    break;

  case 371:
#line 892 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[1].value.node_val)); }
#line 2088 "DynareBison.cc" // lalr1.cc:847
    break;

  case 372:
#line 894 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[0].value.string_val)); }
#line 2094 "DynareBison.cc" // lalr1.cc:847
    break;

  case 373:
#line 896 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[0].value.string_val)); }
#line 2100 "DynareBison.cc" // lalr1.cc:847
    break;

  case 374:
#line 898 "DynareBison.yy" // lalr1.cc:847
    { driver.add_value((yystack_[0].value.string_val)); }
#line 2106 "DynareBison.cc" // lalr1.cc:847
    break;

  case 375:
#line 902 "DynareBison.yy" // lalr1.cc:847
    { driver.end_of_row(); }
#line 2112 "DynareBison.cc" // lalr1.cc:847
    break;

  case 376:
#line 904 "DynareBison.yy" // lalr1.cc:847
    { driver.end_of_row(); }
#line 2118 "DynareBison.cc" // lalr1.cc:847
    break;

  case 377:
#line 908 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row((yystack_[1].value.node_val)); }
#line 2124 "DynareBison.cc" // lalr1.cc:847
    break;

  case 378:
#line 910 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row_const((yystack_[0].value.string_val)); }
#line 2130 "DynareBison.cc" // lalr1.cc:847
    break;

  case 379:
#line 912 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row((yystack_[1].value.node_val)); }
#line 2136 "DynareBison.cc" // lalr1.cc:847
    break;

  case 380:
#line 914 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row_const((yystack_[0].value.string_val)); }
#line 2142 "DynareBison.cc" // lalr1.cc:847
    break;

  case 381:
#line 916 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row((yystack_[1].value.node_val)); }
#line 2148 "DynareBison.cc" // lalr1.cc:847
    break;

  case 382:
#line 918 "DynareBison.yy" // lalr1.cc:847
    { driver.add_to_row_const((yystack_[0].value.string_val)); }
#line 2154 "DynareBison.cc" // lalr1.cc:847
    break;

  case 383:
#line 922 "DynareBison.yy" // lalr1.cc:847
    { driver.steady(); }
#line 2160 "DynareBison.cc" // lalr1.cc:847
    break;

  case 384:
#line 924 "DynareBison.yy" // lalr1.cc:847
    { driver.steady(); }
#line 2166 "DynareBison.cc" // lalr1.cc:847
    break;

  case 394:
#line 941 "DynareBison.yy" // lalr1.cc:847
    { driver.check(); }
#line 2172 "DynareBison.cc" // lalr1.cc:847
    break;

  case 395:
#line 943 "DynareBison.yy" // lalr1.cc:847
    { driver.check(); }
#line 2178 "DynareBison.cc" // lalr1.cc:847
    break;

  case 400:
#line 955 "DynareBison.yy" // lalr1.cc:847
    { driver.model_info(); }
#line 2184 "DynareBison.cc" // lalr1.cc:847
    break;

  case 401:
#line 957 "DynareBison.yy" // lalr1.cc:847
    { driver.model_info(); }
#line 2190 "DynareBison.cc" // lalr1.cc:847
    break;

  case 405:
#line 966 "DynareBison.yy" // lalr1.cc:847
    { driver.simul(); }
#line 2196 "DynareBison.cc" // lalr1.cc:847
    break;

  case 406:
#line 968 "DynareBison.yy" // lalr1.cc:847
    { driver.simul(); }
#line 2202 "DynareBison.cc" // lalr1.cc:847
    break;

  case 415:
#line 984 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function(); }
#line 2208 "DynareBison.cc" // lalr1.cc:847
    break;

  case 422:
#line 998 "DynareBison.yy" // lalr1.cc:847
    { driver.stoch_simul(); }
#line 2214 "DynareBison.cc" // lalr1.cc:847
    break;

  case 423:
#line 1000 "DynareBison.yy" // lalr1.cc:847
    { driver.stoch_simul(); }
#line 2220 "DynareBison.cc" // lalr1.cc:847
    break;

  case 424:
#line 1002 "DynareBison.yy" // lalr1.cc:847
    { driver.stoch_simul(); }
#line 2226 "DynareBison.cc" // lalr1.cc:847
    break;

  case 425:
#line 1004 "DynareBison.yy" // lalr1.cc:847
    { driver.stoch_simul(); }
#line 2232 "DynareBison.cc" // lalr1.cc:847
    break;

  case 469:
#line 1057 "DynareBison.yy" // lalr1.cc:847
    { driver.add_in_symbol_list((yystack_[0].value.string_val)); }
#line 2238 "DynareBison.cc" // lalr1.cc:847
    break;

  case 470:
#line 1059 "DynareBison.yy" // lalr1.cc:847
    { driver.add_in_symbol_list((yystack_[0].value.string_val)); }
#line 2244 "DynareBison.cc" // lalr1.cc:847
    break;

  case 471:
#line 1061 "DynareBison.yy" // lalr1.cc:847
    { driver.add_in_symbol_list((yystack_[0].value.string_val)); }
#line 2250 "DynareBison.cc" // lalr1.cc:847
    break;

  case 473:
#line 1066 "DynareBison.yy" // lalr1.cc:847
    {
                    string *colon = new string(":");
                    driver.add_in_symbol_list(colon);
                  }
#line 2259 "DynareBison.cc" // lalr1.cc:847
    break;

  case 474:
#line 1073 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2265 "DynareBison.cc" // lalr1.cc:847
    break;

  case 475:
#line 1075 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[0].value.string_val)->insert(0, "-"); (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2271 "DynareBison.cc" // lalr1.cc:847
    break;

  case 479:
#line 1084 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2277 "DynareBison.cc" // lalr1.cc:847
    break;

  case 480:
#line 1086 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[0].value.string_val)->insert(0, "-"); (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2283 "DynareBison.cc" // lalr1.cc:847
    break;

  case 482:
#line 1091 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = new string ("Inf"); }
#line 2289 "DynareBison.cc" // lalr1.cc:847
    break;

  case 483:
#line 1093 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = new string ("-Inf"); }
#line 2295 "DynareBison.cc" // lalr1.cc:847
    break;

  case 484:
#line 1095 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = new string ("Inf"); }
#line 2301 "DynareBison.cc" // lalr1.cc:847
    break;

  case 487:
#line 1102 "DynareBison.yy" // lalr1.cc:847
    { driver.estimated_params(); }
#line 2307 "DynareBison.cc" // lalr1.cc:847
    break;

  case 488:
#line 1105 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2313 "DynareBison.cc" // lalr1.cc:847
    break;

  case 489:
#line 1107 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2319 "DynareBison.cc" // lalr1.cc:847
    break;

  case 491:
#line 1113 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.type = 1;
                    driver.estim_params.name = *(yystack_[0].value.string_val);
                    delete (yystack_[0].value.string_val);
                  }
#line 2329 "DynareBison.cc" // lalr1.cc:847
    break;

  case 492:
#line 1119 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = *(yystack_[0].value.string_val);
                    delete (yystack_[0].value.string_val);
                  }
#line 2339 "DynareBison.cc" // lalr1.cc:847
    break;

  case 493:
#line 1125 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.type = 3;
                    driver.estim_params.name = *(yystack_[2].value.string_val);
                    driver.estim_params.name2 = *(yystack_[0].value.string_val);
                    delete (yystack_[2].value.string_val);
                    delete (yystack_[0].value.string_val);
                  }
#line 2351 "DynareBison.cc" // lalr1.cc:847
    break;

  case 494:
#line 1133 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.type = 2;
                    driver.estim_params.name = "dsge_prior_weight";
                  }
#line 2360 "DynareBison.cc" // lalr1.cc:847
    break;

  case 495:
#line 1140 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.prior = (yystack_[2].value.prior_distributions_val);
                  }
#line 2368 "DynareBison.cc" // lalr1.cc:847
    break;

  case 496:
#line 1144 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.init_val = (yystack_[4].value.node_val);
                    driver.estim_params.prior = (yystack_[2].value.prior_distributions_val);
                  }
#line 2377 "DynareBison.cc" // lalr1.cc:847
    break;

  case 497:
#line 1149 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.init_val = (yystack_[8].value.node_val);
                    driver.estim_params.low_bound = (yystack_[6].value.node_val);
                    driver.estim_params.up_bound = (yystack_[4].value.node_val);
                    driver.estim_params.prior = (yystack_[2].value.prior_distributions_val);
                  }
#line 2388 "DynareBison.cc" // lalr1.cc:847
    break;

  case 498:
#line 1156 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.init_val = (yystack_[0].value.node_val);
                  }
#line 2396 "DynareBison.cc" // lalr1.cc:847
    break;

  case 499:
#line 1160 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.init_val = (yystack_[4].value.node_val);
                    driver.estim_params.low_bound = (yystack_[2].value.node_val);
                    driver.estim_params.up_bound = (yystack_[0].value.node_val);
                  }
#line 2406 "DynareBison.cc" // lalr1.cc:847
    break;

  case 500:
#line 1168 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.mean = (yystack_[2].value.node_val);
                    driver.estim_params.std = (yystack_[0].value.node_val);
                  }
#line 2415 "DynareBison.cc" // lalr1.cc:847
    break;

  case 501:
#line 1173 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.mean = (yystack_[4].value.node_val);
                    driver.estim_params.std = (yystack_[2].value.node_val);
                    driver.estim_params.p3 = (yystack_[0].value.node_val);
                  }
#line 2425 "DynareBison.cc" // lalr1.cc:847
    break;

  case 502:
#line 1179 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.mean = (yystack_[6].value.node_val);
                    driver.estim_params.std = (yystack_[4].value.node_val);
                    driver.estim_params.p3 = (yystack_[2].value.node_val);
                    driver.estim_params.p4 = (yystack_[0].value.node_val);
                  }
#line 2436 "DynareBison.cc" // lalr1.cc:847
    break;

  case 503:
#line 1186 "DynareBison.yy" // lalr1.cc:847
    {
                    driver.estim_params.mean = (yystack_[8].value.node_val);
                    driver.estim_params.std = (yystack_[6].value.node_val);
                    driver.estim_params.p3 = (yystack_[4].value.node_val);
                    driver.estim_params.p4 = (yystack_[2].value.node_val);
                    driver.estim_params.jscale = (yystack_[0].value.node_val);
                  }
#line 2448 "DynareBison.cc" // lalr1.cc:847
    break;

  case 504:
#line 1196 "DynareBison.yy" // lalr1.cc:847
    { driver.estimated_params_init(); }
#line 2454 "DynareBison.cc" // lalr1.cc:847
    break;

  case 505:
#line 1198 "DynareBison.yy" // lalr1.cc:847
    { driver.estimated_params_init(true); }
#line 2460 "DynareBison.cc" // lalr1.cc:847
    break;

  case 506:
#line 1200 "DynareBison.yy" // lalr1.cc:847
    { driver.estimated_params_init(true); }
#line 2466 "DynareBison.cc" // lalr1.cc:847
    break;

  case 507:
#line 1204 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2472 "DynareBison.cc" // lalr1.cc:847
    break;

  case 508:
#line 1206 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2478 "DynareBison.cc" // lalr1.cc:847
    break;

  case 509:
#line 1210 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.estim_params.type = 1;
                        driver.estim_params.name = *(yystack_[3].value.string_val);
                        driver.estim_params.init_val = (yystack_[1].value.node_val);
                        delete (yystack_[3].value.string_val);
                      }
#line 2489 "DynareBison.cc" // lalr1.cc:847
    break;

  case 510:
#line 1217 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.estim_params.type = 3;
                        driver.estim_params.name = *(yystack_[5].value.string_val);
                        driver.estim_params.name2 = *(yystack_[3].value.string_val);
                        driver.estim_params.init_val = (yystack_[1].value.node_val);
                        delete (yystack_[5].value.string_val);
                        delete (yystack_[3].value.string_val);
                      }
#line 2502 "DynareBison.cc" // lalr1.cc:847
    break;

  case 511:
#line 1226 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.estim_params.type = 2;
                        driver.estim_params.name = *(yystack_[3].value.string_val);
                        driver.estim_params.init_val = (yystack_[1].value.node_val);
                        delete (yystack_[3].value.string_val);
                      }
#line 2513 "DynareBison.cc" // lalr1.cc:847
    break;

  case 512:
#line 1235 "DynareBison.yy" // lalr1.cc:847
    { driver.estimated_params_bounds(); }
#line 2519 "DynareBison.cc" // lalr1.cc:847
    break;

  case 513:
#line 1238 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2525 "DynareBison.cc" // lalr1.cc:847
    break;

  case 514:
#line 1240 "DynareBison.yy" // lalr1.cc:847
    { driver.add_estimated_params_element(); }
#line 2531 "DynareBison.cc" // lalr1.cc:847
    break;

  case 515:
#line 1244 "DynareBison.yy" // lalr1.cc:847
    {
                          driver.estim_params.type = 1;
                          driver.estim_params.name = *(yystack_[5].value.string_val);
                          driver.estim_params.low_bound = (yystack_[3].value.node_val);
                          driver.estim_params.up_bound = (yystack_[1].value.node_val);
                          delete (yystack_[5].value.string_val);
                        }
#line 2543 "DynareBison.cc" // lalr1.cc:847
    break;

  case 516:
#line 1252 "DynareBison.yy" // lalr1.cc:847
    {
                          driver.estim_params.type = 3;
                          driver.estim_params.name = *(yystack_[7].value.string_val);
                          driver.estim_params.name2 = *(yystack_[5].value.string_val);
                          driver.estim_params.low_bound = (yystack_[3].value.node_val);
                          driver.estim_params.up_bound = (yystack_[1].value.node_val);
                          delete (yystack_[7].value.string_val);
                          delete (yystack_[5].value.string_val);
                        }
#line 2557 "DynareBison.cc" // lalr1.cc:847
    break;

  case 517:
#line 1262 "DynareBison.yy" // lalr1.cc:847
    {
                          driver.estim_params.type = 2;
                          driver.estim_params.name = *(yystack_[5].value.string_val);
                          driver.estim_params.low_bound = (yystack_[3].value.node_val);
                          driver.estim_params.up_bound = (yystack_[1].value.node_val);
                          delete (yystack_[5].value.string_val);
                        }
#line 2569 "DynareBison.cc" // lalr1.cc:847
    break;

  case 518:
#line 1272 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eBeta; }
#line 2575 "DynareBison.cc" // lalr1.cc:847
    break;

  case 519:
#line 1274 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eGamma; }
#line 2581 "DynareBison.cc" // lalr1.cc:847
    break;

  case 520:
#line 1276 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eNormal; }
#line 2587 "DynareBison.cc" // lalr1.cc:847
    break;

  case 521:
#line 1278 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma; }
#line 2593 "DynareBison.cc" // lalr1.cc:847
    break;

  case 522:
#line 1280 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma1; }
#line 2599 "DynareBison.cc" // lalr1.cc:847
    break;

  case 523:
#line 1282 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eUniform; }
#line 2605 "DynareBison.cc" // lalr1.cc:847
    break;

  case 524:
#line 1284 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma2; }
#line 2611 "DynareBison.cc" // lalr1.cc:847
    break;

  case 525:
#line 1288 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eBeta; }
#line 2617 "DynareBison.cc" // lalr1.cc:847
    break;

  case 526:
#line 1290 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eGamma; }
#line 2623 "DynareBison.cc" // lalr1.cc:847
    break;

  case 527:
#line 1292 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eNormal; }
#line 2629 "DynareBison.cc" // lalr1.cc:847
    break;

  case 528:
#line 1294 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma; }
#line 2635 "DynareBison.cc" // lalr1.cc:847
    break;

  case 529:
#line 1296 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma1; }
#line 2641 "DynareBison.cc" // lalr1.cc:847
    break;

  case 530:
#line 1298 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eUniform; }
#line 2647 "DynareBison.cc" // lalr1.cc:847
    break;

  case 531:
#line 1300 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.prior_distributions_val) = eInvGamma2; }
#line 2653 "DynareBison.cc" // lalr1.cc:847
    break;

  case 532:
#line 1303 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2659 "DynareBison.cc" // lalr1.cc:847
    break;

  case 533:
#line 1306 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 2665 "DynareBison.cc" // lalr1.cc:847
    break;

  case 534:
#line 1308 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[2].value.string_val); (yylhs.value.string_val)->append("+").append(*(yystack_[0].value.string_val)); }
#line 2671 "DynareBison.cc" // lalr1.cc:847
    break;

  case 535:
#line 1312 "DynareBison.yy" // lalr1.cc:847
    { driver.set_time((yystack_[2].value.string_val)); }
#line 2677 "DynareBison.cc" // lalr1.cc:847
    break;

  case 536:
#line 1316 "DynareBison.yy" // lalr1.cc:847
    { driver.estimation_data(); }
#line 2683 "DynareBison.cc" // lalr1.cc:847
    break;

  case 545:
#line 1332 "DynareBison.yy" // lalr1.cc:847
    { driver.set_subsamples((yystack_[4].value.vector_string_val)->at(0), (yystack_[4].value.vector_string_val)->at(1)); }
#line 2689 "DynareBison.cc" // lalr1.cc:847
    break;

  case 546:
#line 1336 "DynareBison.yy" // lalr1.cc:847
    {
                  driver.copy_subsamples((yystack_[3].value.vector_string_val)->at(0), (yystack_[3].value.vector_string_val)->at(1), (yystack_[1].value.vector_string_val)->at(0), (yystack_[1].value.vector_string_val)->at(1));
                  delete (yystack_[3].value.vector_string_val);
                  delete (yystack_[1].value.vector_string_val);
                }
#line 2699 "DynareBison.cc" // lalr1.cc:847
    break;

  case 547:
#line 1344 "DynareBison.yy" // lalr1.cc:847
    {
                      (yylhs.value.vector_string_val) = new vector<string *>();
                      (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                      (yylhs.value.vector_string_val)->push_back(new string (""));
                    }
#line 2709 "DynareBison.cc" // lalr1.cc:847
    break;

  case 548:
#line 1350 "DynareBison.yy" // lalr1.cc:847
    {
                      (yylhs.value.vector_string_val) = new vector<string *>();
                      (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                      (yylhs.value.vector_string_val)->push_back(new string (""));
                    }
#line 2719 "DynareBison.cc" // lalr1.cc:847
    break;

  case 549:
#line 1356 "DynareBison.yy" // lalr1.cc:847
    {
                      (yylhs.value.vector_string_val) = new vector<string *>();
                      (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                      (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                    }
#line 2729 "DynareBison.cc" // lalr1.cc:847
    break;

  case 552:
#line 1367 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2735 "DynareBison.cc" // lalr1.cc:847
    break;

  case 553:
#line 1368 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior((yystack_[7].value.string_val), new string ("")); }
#line 2741 "DynareBison.cc" // lalr1.cc:847
    break;

  case 554:
#line 1369 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2747 "DynareBison.cc" // lalr1.cc:847
    break;

  case 555:
#line 1370 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior((yystack_[9].value.string_val), (yystack_[7].value.string_val)); }
#line 2753 "DynareBison.cc" // lalr1.cc:847
    break;

  case 556:
#line 1371 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2759 "DynareBison.cc" // lalr1.cc:847
    break;

  case 557:
#line 1372 "DynareBison.yy" // lalr1.cc:847
    { driver.set_std_prior((yystack_[8].value.string_val), new string ("")); }
#line 2765 "DynareBison.cc" // lalr1.cc:847
    break;

  case 558:
#line 1373 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2771 "DynareBison.cc" // lalr1.cc:847
    break;

  case 559:
#line 1374 "DynareBison.yy" // lalr1.cc:847
    { driver.set_std_prior((yystack_[10].value.string_val), (yystack_[7].value.string_val)); }
#line 2777 "DynareBison.cc" // lalr1.cc:847
    break;

  case 560:
#line 1375 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2783 "DynareBison.cc" // lalr1.cc:847
    break;

  case 561:
#line 1376 "DynareBison.yy" // lalr1.cc:847
    { driver.set_corr_prior((yystack_[10].value.string_val), (yystack_[8].value.string_val), new string ("")); }
#line 2789 "DynareBison.cc" // lalr1.cc:847
    break;

  case 562:
#line 1377 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance(); driver.prior_shape = eNoShape; }
#line 2795 "DynareBison.cc" // lalr1.cc:847
    break;

  case 563:
#line 1378 "DynareBison.yy" // lalr1.cc:847
    { driver.set_corr_prior((yystack_[12].value.string_val), (yystack_[10].value.string_val), (yystack_[7].value.string_val)); }
#line 2801 "DynareBison.cc" // lalr1.cc:847
    break;

  case 576:
#line 1398 "DynareBison.yy" // lalr1.cc:847
    {
             driver.copy_prior((yystack_[3].value.vector_string_val)->at(0), (yystack_[3].value.vector_string_val)->at(1), (yystack_[3].value.vector_string_val)->at(2), (yystack_[3].value.vector_string_val)->at(3),
                               (yystack_[1].value.vector_string_val)->at(0), (yystack_[1].value.vector_string_val)->at(1), (yystack_[1].value.vector_string_val)->at(2), (yystack_[1].value.vector_string_val)->at(3));
             delete (yystack_[3].value.vector_string_val);
             delete (yystack_[1].value.vector_string_val);
           }
#line 2812 "DynareBison.cc" // lalr1.cc:847
    break;

  case 577:
#line 1407 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("par"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
               }
#line 2824 "DynareBison.cc" // lalr1.cc:847
    break;

  case 578:
#line 1415 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("par"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[4].value.string_val));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
                 (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
               }
#line 2836 "DynareBison.cc" // lalr1.cc:847
    break;

  case 579:
#line 1423 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("std"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
               }
#line 2848 "DynareBison.cc" // lalr1.cc:847
    break;

  case 580:
#line 1431 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("std"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
                 (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
               }
#line 2860 "DynareBison.cc" // lalr1.cc:847
    break;

  case 581:
#line 1439 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("corr"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                 (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                 (yylhs.value.vector_string_val)->push_back(new string (""));
               }
#line 2872 "DynareBison.cc" // lalr1.cc:847
    break;

  case 582:
#line 1447 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_string_val) = new vector<string *>();
                 (yylhs.value.vector_string_val)->push_back(new string ("corr"));
                 (yylhs.value.vector_string_val)->push_back((yystack_[7].value.string_val));
                 (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                 (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
               }
#line 2884 "DynareBison.cc" // lalr1.cc:847
    break;

  case 583:
#line 1457 "DynareBison.yy" // lalr1.cc:847
    { driver.set_options((yystack_[6].value.string_val), new string ("")); }
#line 2890 "DynareBison.cc" // lalr1.cc:847
    break;

  case 584:
#line 1459 "DynareBison.yy" // lalr1.cc:847
    { driver.set_options((yystack_[8].value.string_val), (yystack_[6].value.string_val)); }
#line 2896 "DynareBison.cc" // lalr1.cc:847
    break;

  case 585:
#line 1461 "DynareBison.yy" // lalr1.cc:847
    { driver.set_std_options((yystack_[7].value.string_val), new string ("")); }
#line 2902 "DynareBison.cc" // lalr1.cc:847
    break;

  case 586:
#line 1463 "DynareBison.yy" // lalr1.cc:847
    { driver.set_std_options((yystack_[9].value.string_val), (yystack_[6].value.string_val)); }
#line 2908 "DynareBison.cc" // lalr1.cc:847
    break;

  case 587:
#line 1465 "DynareBison.yy" // lalr1.cc:847
    { driver.set_corr_options((yystack_[9].value.string_val), (yystack_[7].value.string_val), new string ("")); }
#line 2914 "DynareBison.cc" // lalr1.cc:847
    break;

  case 588:
#line 1467 "DynareBison.yy" // lalr1.cc:847
    { driver.set_corr_options((yystack_[11].value.string_val), (yystack_[9].value.string_val), (yystack_[6].value.string_val)); }
#line 2920 "DynareBison.cc" // lalr1.cc:847
    break;

  case 594:
#line 1480 "DynareBison.yy" // lalr1.cc:847
    {
               driver.copy_options((yystack_[3].value.vector_string_val)->at(0), (yystack_[3].value.vector_string_val)->at(1), (yystack_[3].value.vector_string_val)->at(2), (yystack_[3].value.vector_string_val)->at(3),
                                   (yystack_[1].value.vector_string_val)->at(0), (yystack_[1].value.vector_string_val)->at(1), (yystack_[1].value.vector_string_val)->at(2), (yystack_[1].value.vector_string_val)->at(3));
               delete (yystack_[3].value.vector_string_val);
               delete (yystack_[1].value.vector_string_val);
             }
#line 2931 "DynareBison.cc" // lalr1.cc:847
    break;

  case 595:
#line 1489 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("par"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                 }
#line 2943 "DynareBison.cc" // lalr1.cc:847
    break;

  case 596:
#line 1497 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("par"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[4].value.string_val));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                   (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                 }
#line 2955 "DynareBison.cc" // lalr1.cc:847
    break;

  case 597:
#line 1505 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("std"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                 }
#line 2967 "DynareBison.cc" // lalr1.cc:847
    break;

  case 598:
#line 1513 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("std"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                   (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                 }
#line 2979 "DynareBison.cc" // lalr1.cc:847
    break;

  case 599:
#line 1521 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("corr"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                   (yylhs.value.vector_string_val)->push_back((yystack_[3].value.string_val));
                   (yylhs.value.vector_string_val)->push_back(new string (""));
                 }
#line 2991 "DynareBison.cc" // lalr1.cc:847
    break;

  case 600:
#line 1529 "DynareBison.yy" // lalr1.cc:847
    {
                   (yylhs.value.vector_string_val) = new vector<string *>();
                   (yylhs.value.vector_string_val)->push_back(new string ("corr"));
                   (yylhs.value.vector_string_val)->push_back((yystack_[7].value.string_val));
                   (yylhs.value.vector_string_val)->push_back((yystack_[5].value.string_val));
                   (yylhs.value.vector_string_val)->push_back((yystack_[2].value.string_val));
                 }
#line 3003 "DynareBison.cc" // lalr1.cc:847
    break;

  case 601:
#line 1539 "DynareBison.yy" // lalr1.cc:847
    { driver.run_estimation(); }
#line 3009 "DynareBison.cc" // lalr1.cc:847
    break;

  case 602:
#line 1541 "DynareBison.yy" // lalr1.cc:847
    { driver.run_estimation(); }
#line 3015 "DynareBison.cc" // lalr1.cc:847
    break;

  case 603:
#line 1543 "DynareBison.yy" // lalr1.cc:847
    { driver.run_estimation(); }
#line 3021 "DynareBison.cc" // lalr1.cc:847
    break;

  case 604:
#line 1545 "DynareBison.yy" // lalr1.cc:847
    { driver.run_estimation(); }
#line 3027 "DynareBison.cc" // lalr1.cc:847
    break;

  case 684:
#line 1632 "DynareBison.yy" // lalr1.cc:847
    { driver.optim_options_string((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 3033 "DynareBison.cc" // lalr1.cc:847
    break;

  case 685:
#line 1634 "DynareBison.yy" // lalr1.cc:847
    { driver.optim_options_num((yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 3039 "DynareBison.cc" // lalr1.cc:847
    break;

  case 688:
#line 1641 "DynareBison.yy" // lalr1.cc:847
    { driver.check_varobs(); }
#line 3045 "DynareBison.cc" // lalr1.cc:847
    break;

  case 690:
#line 1644 "DynareBison.yy" // lalr1.cc:847
    { driver.add_varobs((yystack_[0].value.string_val)); }
#line 3051 "DynareBison.cc" // lalr1.cc:847
    break;

  case 691:
#line 1646 "DynareBison.yy" // lalr1.cc:847
    { driver.add_varobs((yystack_[0].value.string_val)); }
#line 3057 "DynareBison.cc" // lalr1.cc:847
    break;

  case 692:
#line 1648 "DynareBison.yy" // lalr1.cc:847
    { driver.add_varobs((yystack_[0].value.string_val)); }
#line 3063 "DynareBison.cc" // lalr1.cc:847
    break;

  case 693:
#line 1651 "DynareBison.yy" // lalr1.cc:847
    { driver.set_trends(); }
#line 3069 "DynareBison.cc" // lalr1.cc:847
    break;

  case 696:
#line 1657 "DynareBison.yy" // lalr1.cc:847
    { driver.set_trend_element((yystack_[4].value.string_val), (yystack_[2].value.node_val)); }
#line 3075 "DynareBison.cc" // lalr1.cc:847
    break;

  case 697:
#line 1659 "DynareBison.yy" // lalr1.cc:847
    { driver.set_unit_root_vars(); }
#line 3081 "DynareBison.cc" // lalr1.cc:847
    break;

  case 698:
#line 1661 "DynareBison.yy" // lalr1.cc:847
    { driver.optim_weights(); }
#line 3087 "DynareBison.cc" // lalr1.cc:847
    break;

  case 699:
#line 1664 "DynareBison.yy" // lalr1.cc:847
    { driver.set_optim_weights((yystack_[2].value.string_val), (yystack_[1].value.node_val)); }
#line 3093 "DynareBison.cc" // lalr1.cc:847
    break;

  case 700:
#line 1666 "DynareBison.yy" // lalr1.cc:847
    { driver.set_optim_weights((yystack_[4].value.string_val), (yystack_[2].value.string_val), (yystack_[1].value.node_val)); }
#line 3099 "DynareBison.cc" // lalr1.cc:847
    break;

  case 701:
#line 1668 "DynareBison.yy" // lalr1.cc:847
    { driver.set_optim_weights((yystack_[2].value.string_val), (yystack_[1].value.node_val)); }
#line 3105 "DynareBison.cc" // lalr1.cc:847
    break;

  case 702:
#line 1670 "DynareBison.yy" // lalr1.cc:847
    { driver.set_optim_weights((yystack_[4].value.string_val), (yystack_[2].value.string_val), (yystack_[1].value.node_val)); }
#line 3111 "DynareBison.cc" // lalr1.cc:847
    break;

  case 703:
#line 1673 "DynareBison.yy" // lalr1.cc:847
    { driver.set_osr_params(); }
#line 3117 "DynareBison.cc" // lalr1.cc:847
    break;

  case 709:
#line 1686 "DynareBison.yy" // lalr1.cc:847
    { driver.run_osr(); }
#line 3123 "DynareBison.cc" // lalr1.cc:847
    break;

  case 710:
#line 1688 "DynareBison.yy" // lalr1.cc:847
    { driver.run_osr(); }
#line 3129 "DynareBison.cc" // lalr1.cc:847
    break;

  case 711:
#line 1690 "DynareBison.yy" // lalr1.cc:847
    { driver.run_osr(); }
#line 3135 "DynareBison.cc" // lalr1.cc:847
    break;

  case 712:
#line 1692 "DynareBison.yy" // lalr1.cc:847
    {driver.run_osr(); }
#line 3141 "DynareBison.cc" // lalr1.cc:847
    break;

  case 713:
#line 1696 "DynareBison.yy" // lalr1.cc:847
    { driver.run_dynatype((yystack_[2].value.string_val)); }
#line 3147 "DynareBison.cc" // lalr1.cc:847
    break;

  case 714:
#line 1698 "DynareBison.yy" // lalr1.cc:847
    { driver.run_dynatype((yystack_[3].value.string_val)); }
#line 3153 "DynareBison.cc" // lalr1.cc:847
    break;

  case 715:
#line 1702 "DynareBison.yy" // lalr1.cc:847
    { driver.run_dynasave((yystack_[2].value.string_val)); }
#line 3159 "DynareBison.cc" // lalr1.cc:847
    break;

  case 716:
#line 1704 "DynareBison.yy" // lalr1.cc:847
    { driver.run_dynasave((yystack_[3].value.string_val)); }
#line 3165 "DynareBison.cc" // lalr1.cc:847
    break;

  case 717:
#line 1708 "DynareBison.yy" // lalr1.cc:847
    { driver.run_load_params_and_steady_state((yystack_[2].value.string_val)); }
#line 3171 "DynareBison.cc" // lalr1.cc:847
    break;

  case 718:
#line 1712 "DynareBison.yy" // lalr1.cc:847
    { driver.run_save_params_and_steady_state((yystack_[2].value.string_val)); }
#line 3177 "DynareBison.cc" // lalr1.cc:847
    break;

  case 719:
#line 1716 "DynareBison.yy" // lalr1.cc:847
    { driver.run_identification(); }
#line 3183 "DynareBison.cc" // lalr1.cc:847
    break;

  case 720:
#line 1718 "DynareBison.yy" // lalr1.cc:847
    { driver.run_identification(); }
#line 3189 "DynareBison.cc" // lalr1.cc:847
    break;

  case 739:
#line 1744 "DynareBison.yy" // lalr1.cc:847
    { driver.run_model_comparison(); }
#line 3195 "DynareBison.cc" // lalr1.cc:847
    break;

  case 740:
#line 1746 "DynareBison.yy" // lalr1.cc:847
    { driver.run_model_comparison(); }
#line 3201 "DynareBison.cc" // lalr1.cc:847
    break;

  case 743:
#line 1754 "DynareBison.yy" // lalr1.cc:847
    { driver.add_parallel_local_file((yystack_[0].value.string_val)); }
#line 3207 "DynareBison.cc" // lalr1.cc:847
    break;

  case 744:
#line 1756 "DynareBison.yy" // lalr1.cc:847
    { driver.add_parallel_local_file((yystack_[0].value.string_val)); }
#line 3213 "DynareBison.cc" // lalr1.cc:847
    break;

  case 745:
#line 1760 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[0].value.string_val)); }
#line 3219 "DynareBison.cc" // lalr1.cc:847
    break;

  case 746:
#line 1762 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[3].value.string_val), (yystack_[1].value.string_val)); }
#line 3225 "DynareBison.cc" // lalr1.cc:847
    break;

  case 747:
#line 1764 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[0].value.string_val)); }
#line 3231 "DynareBison.cc" // lalr1.cc:847
    break;

  case 748:
#line 1766 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[3].value.string_val), (yystack_[1].value.string_val)); }
#line 3237 "DynareBison.cc" // lalr1.cc:847
    break;

  case 749:
#line 1768 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[0].value.string_val)); }
#line 3243 "DynareBison.cc" // lalr1.cc:847
    break;

  case 750:
#line 1770 "DynareBison.yy" // lalr1.cc:847
    { driver.add_mc_filename((yystack_[3].value.string_val), (yystack_[1].value.string_val)); }
#line 3249 "DynareBison.cc" // lalr1.cc:847
    break;

  case 751:
#line 1773 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_planner_objective(); }
#line 3255 "DynareBison.cc" // lalr1.cc:847
    break;

  case 752:
#line 1774 "DynareBison.yy" // lalr1.cc:847
    { driver.end_planner_objective((yystack_[0].value.node_val)); }
#line 3261 "DynareBison.cc" // lalr1.cc:847
    break;

  case 754:
#line 1777 "DynareBison.yy" // lalr1.cc:847
    { driver.ramsey_policy(); }
#line 3267 "DynareBison.cc" // lalr1.cc:847
    break;

  case 755:
#line 1779 "DynareBison.yy" // lalr1.cc:847
    { driver.ramsey_policy(); }
#line 3273 "DynareBison.cc" // lalr1.cc:847
    break;

  case 756:
#line 1781 "DynareBison.yy" // lalr1.cc:847
    { driver.ramsey_policy(); }
#line 3279 "DynareBison.cc" // lalr1.cc:847
    break;

  case 757:
#line 1783 "DynareBison.yy" // lalr1.cc:847
    { driver.ramsey_policy(); }
#line 3285 "DynareBison.cc" // lalr1.cc:847
    break;

  case 758:
#line 1787 "DynareBison.yy" // lalr1.cc:847
    { driver.discretionary_policy(); }
#line 3291 "DynareBison.cc" // lalr1.cc:847
    break;

  case 759:
#line 1789 "DynareBison.yy" // lalr1.cc:847
    { driver.discretionary_policy(); }
#line 3297 "DynareBison.cc" // lalr1.cc:847
    break;

  case 760:
#line 1791 "DynareBison.yy" // lalr1.cc:847
    { driver.discretionary_policy(); }
#line 3303 "DynareBison.cc" // lalr1.cc:847
    break;

  case 761:
#line 1793 "DynareBison.yy" // lalr1.cc:847
    { driver.discretionary_policy(); }
#line 3309 "DynareBison.cc" // lalr1.cc:847
    break;

  case 772:
#line 1815 "DynareBison.yy" // lalr1.cc:847
    { driver.write_latex_dynamic_model(); }
#line 3315 "DynareBison.cc" // lalr1.cc:847
    break;

  case 773:
#line 1819 "DynareBison.yy" // lalr1.cc:847
    { driver.write_latex_static_model(); }
#line 3321 "DynareBison.cc" // lalr1.cc:847
    break;

  case 774:
#line 1823 "DynareBison.yy" // lalr1.cc:847
    {driver.shock_decomposition(); }
#line 3327 "DynareBison.cc" // lalr1.cc:847
    break;

  case 775:
#line 1825 "DynareBison.yy" // lalr1.cc:847
    { driver.shock_decomposition(); }
#line 3333 "DynareBison.cc" // lalr1.cc:847
    break;

  case 776:
#line 1827 "DynareBison.yy" // lalr1.cc:847
    { driver.shock_decomposition(); }
#line 3339 "DynareBison.cc" // lalr1.cc:847
    break;

  case 777:
#line 1829 "DynareBison.yy" // lalr1.cc:847
    { driver.shock_decomposition(); }
#line 3345 "DynareBison.cc" // lalr1.cc:847
    break;

  case 797:
#line 1858 "DynareBison.yy" // lalr1.cc:847
    { driver.bvar_density((yystack_[1].value.string_val)); }
#line 3351 "DynareBison.cc" // lalr1.cc:847
    break;

  case 798:
#line 1860 "DynareBison.yy" // lalr1.cc:847
    { driver.bvar_density((yystack_[1].value.string_val)); }
#line 3357 "DynareBison.cc" // lalr1.cc:847
    break;

  case 805:
#line 1874 "DynareBison.yy" // lalr1.cc:847
    { driver.bvar_forecast((yystack_[1].value.string_val)); }
#line 3363 "DynareBison.cc" // lalr1.cc:847
    break;

  case 806:
#line 1876 "DynareBison.yy" // lalr1.cc:847
    { driver.bvar_forecast((yystack_[1].value.string_val)); }
#line 3369 "DynareBison.cc" // lalr1.cc:847
    break;

  case 857:
#line 1934 "DynareBison.yy" // lalr1.cc:847
    { driver.sbvar(); }
#line 3375 "DynareBison.cc" // lalr1.cc:847
    break;

  case 858:
#line 1936 "DynareBison.yy" // lalr1.cc:847
    { driver.sbvar(); }
#line 3381 "DynareBison.cc" // lalr1.cc:847
    break;

  case 875:
#line 1960 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_variance_decomposition(); }
#line 3387 "DynareBison.cc" // lalr1.cc:847
    break;

  case 876:
#line 1962 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_variance_decomposition(); }
#line 3393 "DynareBison.cc" // lalr1.cc:847
    break;

  case 892:
#line 1985 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_forecast(); }
#line 3399 "DynareBison.cc" // lalr1.cc:847
    break;

  case 893:
#line 1987 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_forecast(); }
#line 3405 "DynareBison.cc" // lalr1.cc:847
    break;

  case 910:
#line 2011 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_irf(); }
#line 3411 "DynareBison.cc" // lalr1.cc:847
    break;

  case 911:
#line 2013 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_irf(); }
#line 3417 "DynareBison.cc" // lalr1.cc:847
    break;

  case 912:
#line 2015 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_irf(); }
#line 3423 "DynareBison.cc" // lalr1.cc:847
    break;

  case 913:
#line 2017 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_irf(); }
#line 3429 "DynareBison.cc" // lalr1.cc:847
    break;

  case 920:
#line 2031 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_compute_probabilities(); }
#line 3435 "DynareBison.cc" // lalr1.cc:847
    break;

  case 921:
#line 2033 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_compute_probabilities(); }
#line 3441 "DynareBison.cc" // lalr1.cc:847
    break;

  case 932:
#line 2051 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_compute_mdd(); }
#line 3447 "DynareBison.cc" // lalr1.cc:847
    break;

  case 933:
#line 2053 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_compute_mdd(); }
#line 3453 "DynareBison.cc" // lalr1.cc:847
    break;

  case 943:
#line 2070 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_simulation(); }
#line 3459 "DynareBison.cc" // lalr1.cc:847
    break;

  case 944:
#line 2072 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_simulation(); }
#line 3465 "DynareBison.cc" // lalr1.cc:847
    break;

  case 982:
#line 2117 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_estimation(); }
#line 3471 "DynareBison.cc" // lalr1.cc:847
    break;

  case 983:
#line 2119 "DynareBison.yy" // lalr1.cc:847
    { driver.ms_estimation(); }
#line 3477 "DynareBison.cc" // lalr1.cc:847
    break;

  case 984:
#line 2123 "DynareBison.yy" // lalr1.cc:847
    { driver.dynare_sensitivity(); }
#line 3483 "DynareBison.cc" // lalr1.cc:847
    break;

  case 985:
#line 2125 "DynareBison.yy" // lalr1.cc:847
    { driver.dynare_sensitivity(); }
#line 3489 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1042:
#line 2193 "DynareBison.yy" // lalr1.cc:847
    { driver.end_homotopy();}
#line 3495 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1045:
#line 2200 "DynareBison.yy" // lalr1.cc:847
    { driver.homotopy_val((yystack_[5].value.string_val), (yystack_[3].value.node_val), (yystack_[1].value.node_val));}
#line 3501 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1046:
#line 2202 "DynareBison.yy" // lalr1.cc:847
    { driver.homotopy_val((yystack_[3].value.string_val), NULL, (yystack_[1].value.node_val));}
#line 3507 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1047:
#line 2205 "DynareBison.yy" // lalr1.cc:847
    {driver.forecast();}
#line 3513 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1048:
#line 2206 "DynareBison.yy" // lalr1.cc:847
    {driver.forecast();}
#line 3519 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1049:
#line 2207 "DynareBison.yy" // lalr1.cc:847
    {driver.forecast();}
#line 3525 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1050:
#line 2208 "DynareBison.yy" // lalr1.cc:847
    {driver.forecast();}
#line 3531 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1058:
#line 2223 "DynareBison.yy" // lalr1.cc:847
    { driver.conditional_forecast(); }
#line 3537 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1066:
#line 2238 "DynareBison.yy" // lalr1.cc:847
    { driver.plot_conditional_forecast(); }
#line 3543 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1067:
#line 2240 "DynareBison.yy" // lalr1.cc:847
    { driver.plot_conditional_forecast((yystack_[3].value.string_val)); }
#line 3549 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1068:
#line 2244 "DynareBison.yy" // lalr1.cc:847
    { driver.conditional_forecast_paths(); }
#line 3555 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1071:
#line 2252 "DynareBison.yy" // lalr1.cc:847
    { driver.add_det_shock((yystack_[7].value.string_val), true); }
#line 3561 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1072:
#line 2255 "DynareBison.yy" // lalr1.cc:847
    { driver.begin_steady_state_model(); }
#line 3567 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1073:
#line 2256 "DynareBison.yy" // lalr1.cc:847
    { driver.reset_data_tree(); }
#line 3573 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1076:
#line 2264 "DynareBison.yy" // lalr1.cc:847
    { driver.add_steady_state_model_equal((yystack_[3].value.string_val), (yystack_[1].value.node_val)); }
#line 3579 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1077:
#line 2266 "DynareBison.yy" // lalr1.cc:847
    { driver.add_steady_state_model_equal_multiple((yystack_[1].value.node_val)); }
#line 3585 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1078:
#line 2270 "DynareBison.yy" // lalr1.cc:847
    { driver.calib_smoother(); }
#line 3591 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1079:
#line 2272 "DynareBison.yy" // lalr1.cc:847
    { driver.calib_smoother(); }
#line 3597 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1080:
#line 2274 "DynareBison.yy" // lalr1.cc:847
    { driver.calib_smoother(); }
#line 3603 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1081:
#line 2276 "DynareBison.yy" // lalr1.cc:847
    { driver.calib_smoother(); }
#line 3609 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1087:
#line 2289 "DynareBison.yy" // lalr1.cc:847
    { driver.extended_path(); }
#line 3615 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1088:
#line 2291 "DynareBison.yy" // lalr1.cc:847
    { driver.extended_path(); }
#line 3621 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1095:
#line 2305 "DynareBison.yy" // lalr1.cc:847
    { driver.model_diagnostics(); }
#line 3627 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1096:
#line 2308 "DynareBison.yy" // lalr1.cc:847
    {
                                       if (*(yystack_[0].value.string_val) == string("0"))
                                         driver.warning("dr_algo option is now deprecated, and may be removed in a future version of Dynare");
                                       else
                                         driver.error("dr_algo=1 option is no longer supported");
                                     }
#line 3638 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1097:
#line 2314 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("solve_algo", (yystack_[0].value.string_val)); }
#line 3644 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1098:
#line 2315 "DynareBison.yy" // lalr1.cc:847
    {
                                             if (*(yystack_[0].value.string_val) == string("0"))
                                               driver.warning("simul_algo option is now deprecated, and may be removed in a future version of Dynare");
                                             else
                                               driver.error("simul_algo=1 option is no longer supported");
                                           }
#line 3655 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1099:
#line 2321 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("stack_solve_algo", (yystack_[0].value.string_val)); }
#line 3661 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1100:
#line 2322 "DynareBison.yy" // lalr1.cc:847
    { driver.linear(); }
#line 3667 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1101:
#line 2323 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("order", (yystack_[0].value.string_val)); }
#line 3673 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1102:
#line 2324 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("replic", (yystack_[0].value.string_val)); }
#line 3679 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1103:
#line 2325 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("drop", (yystack_[0].value.string_val)); }
#line 3685 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1104:
#line 2326 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ar", (yystack_[0].value.string_val)); }
#line 3691 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1105:
#line 2327 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nocorr", "1"); }
#line 3697 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1106:
#line 2328 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nofunctions", "1"); }
#line 3703 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1107:
#line 2329 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nomoments", "1"); }
#line 3709 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1108:
#line 2330 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("irf", (yystack_[0].value.string_val)); }
#line 3715 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1109:
#line 2331 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("irf_shocks"); }
#line 3721 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1110:
#line 2332 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("hp_filter", (yystack_[0].value.string_val)); }
#line 3727 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1111:
#line 2333 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("hp_ngrid", (yystack_[0].value.string_val)); }
#line 3733 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1112:
#line 2334 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("periods", (yystack_[0].value.string_val)); }
#line 3739 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1113:
#line 2335 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ep.periods", (yystack_[0].value.string_val)); }
#line 3745 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1114:
#line 2336 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ep.stochastic.order", (yystack_[0].value.string_val)); }
#line 3751 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1115:
#line 2337 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ep.stochastic.hybrid_order", "2"); }
#line 3757 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1116:
#line 2338 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("steady.maxit", (yystack_[0].value.string_val)); }
#line 3763 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1117:
#line 2339 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("simul.maxit", (yystack_[0].value.string_val)); }
#line 3769 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1118:
#line 2340 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("dp.maxit", (yystack_[0].value.string_val)); }
#line 3775 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1119:
#line 2341 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("osr.maxit", (yystack_[0].value.string_val)); }
#line 3781 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1120:
#line 2342 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("osr.tolf", (yystack_[0].value.string_val)); }
#line 3787 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1121:
#line 2343 "DynareBison.yy" // lalr1.cc:847
    { driver.cutoff((yystack_[0].value.string_val)); }
#line 3793 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1122:
#line 2344 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("markowitz", (yystack_[0].value.string_val)); }
#line 3799 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1123:
#line 2345 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("minimal_solving_periods", (yystack_[0].value.string_val)); }
#line 3805 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1124:
#line 2346 "DynareBison.yy" // lalr1.cc:847
    { driver.mfs((yystack_[0].value.string_val)); }
#line 3811 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1126:
#line 2348 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("simul_replic", (yystack_[0].value.string_val)); }
#line 3817 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1127:
#line 2349 "DynareBison.yy" // lalr1.cc:847
    { driver.error("'simul_seed' option is no longer supported; use 'set_dynare_seed' command instead"); }
#line 3823 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1128:
#line 2350 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("qz_criterium", (yystack_[0].value.string_val)); }
#line 3829 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1129:
#line 2351 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("qz_zero_threshold", (yystack_[0].value.string_val)); }
#line 3835 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1130:
#line 2352 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("file", (yystack_[0].value.string_val)); }
#line 3841 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1131:
#line 2353 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("datafile", (yystack_[0].value.string_val)); }
#line 3847 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1132:
#line 2355 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("nobs", (yystack_[0].value.vector_int_val)); }
#line 3853 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1133:
#line 2357 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("nobs", (yystack_[0].value.vector_int_val)); }
#line 3859 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1134:
#line 2360 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("conditional_variance_decomposition", (yystack_[0].value.vector_int_val)); }
#line 3865 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1135:
#line 2362 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("conditional_variance_decomposition", (yystack_[0].value.vector_int_val)); }
#line 3871 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1136:
#line 2364 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("first_obs", (yystack_[0].value.string_val)); }
#line 3877 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1137:
#line 2366 "DynareBison.yy" // lalr1.cc:847
    { driver.option_date("first_obs", (yystack_[0].value.string_val)); }
#line 3883 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1138:
#line 2369 "DynareBison.yy" // lalr1.cc:847
    { driver.option_date("last_obs", (yystack_[0].value.string_val)); }
#line 3889 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1139:
#line 2371 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("shift", (yystack_[0].value.string_val)); }
#line 3895 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1140:
#line 2372 "DynareBison.yy" // lalr1.cc:847
    { driver.prior_shape = (yystack_[0].value.prior_distributions_val); }
#line 3901 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1141:
#line 2373 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode", (yystack_[0].value.string_val)); }
#line 3907 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1142:
#line 2374 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mean", (yystack_[0].value.string_val)); }
#line 3913 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1143:
#line 2375 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("truncate", (yystack_[0].value.string_val)); }
#line 3919 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1144:
#line 2376 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("stdev", (yystack_[0].value.string_val)); }
#line 3925 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1145:
#line 2377 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("jscale", (yystack_[0].value.string_val)); }
#line 3931 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1146:
#line 2378 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("init", (yystack_[0].value.string_val)); }
#line 3937 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1147:
#line 2379 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bounds", (yystack_[0].value.string_val)); }
#line 3943 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1148:
#line 2380 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("domain", (yystack_[0].value.string_val)); }
#line 3949 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1149:
#line 2381 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("interval", (yystack_[0].value.string_val)); }
#line 3955 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1150:
#line 2382 "DynareBison.yy" // lalr1.cc:847
    { driver.set_prior_variance((yystack_[0].value.node_val)); }
#line 3961 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1151:
#line 2383 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nobs", (yystack_[0].value.string_val)); }
#line 3967 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1152:
#line 2384 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("prefilter", (yystack_[0].value.string_val)); }
#line 3973 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1153:
#line 2385 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("presample", (yystack_[0].value.string_val)); }
#line 3979 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1154:
#line 2386 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("lik_algo", (yystack_[0].value.string_val)); }
#line 3985 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1155:
#line 2387 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("lik_init", (yystack_[0].value.string_val)); }
#line 3991 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1156:
#line 2389 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nograph","1"); }
#line 3997 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1157:
#line 2391 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nograph", "0"); }
#line 4003 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1158:
#line 2393 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nodisplay","1"); }
#line 4009 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1159:
#line 2395 "DynareBison.yy" // lalr1.cc:847
    { driver.process_graph_format_option(); }
#line 4015 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1160:
#line 2397 "DynareBison.yy" // lalr1.cc:847
    { driver.process_graph_format_option(); }
#line 4021 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1161:
#line 2400 "DynareBison.yy" // lalr1.cc:847
    { driver.add_graph_format("eps"); }
#line 4027 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1162:
#line 2402 "DynareBison.yy" // lalr1.cc:847
    { driver.add_graph_format("fig"); }
#line 4033 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1163:
#line 2404 "DynareBison.yy" // lalr1.cc:847
    { driver.add_graph_format("pdf"); }
#line 4039 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1164:
#line 2406 "DynareBison.yy" // lalr1.cc:847
    { driver.add_graph_format("none"); }
#line 4045 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1167:
#line 2413 "DynareBison.yy" // lalr1.cc:847
    { driver.set_subsample_name_equal_to_date_range((yystack_[4].value.string_val), (yystack_[2].value.string_val), (yystack_[0].value.string_val)); }
#line 4051 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1168:
#line 2415 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("conf_sig", (yystack_[0].value.string_val)); }
#line 4057 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1169:
#line 2416 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_conf_sig", (yystack_[0].value.string_val)); }
#line 4063 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1170:
#line 2417 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_replic", (yystack_[0].value.string_val)); }
#line 4069 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1171:
#line 2418 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_drop", (yystack_[0].value.string_val)); }
#line 4075 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1172:
#line 2419 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_jscale", (yystack_[0].value.string_val)); }
#line 4081 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1174:
#line 2421 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_init_scale", (yystack_[0].value.string_val)); }
#line 4087 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1175:
#line 2422 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("mode_file", (yystack_[0].value.string_val)); }
#line 4093 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1176:
#line 2423 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode_compute", (yystack_[0].value.string_val)); }
#line 4099 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1177:
#line 2424 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("mode_compute", (yystack_[0].value.string_val)); }
#line 4105 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1178:
#line 2425 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode_check.status", "1"); }
#line 4111 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1179:
#line 2426 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode_check.neighbourhood_size", (yystack_[0].value.string_val)); }
#line 4117 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1180:
#line 2427 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode_check.number_of_points", (yystack_[0].value.string_val)); }
#line 4123 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1181:
#line 2428 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mode_check.symmetric_plots", (yystack_[0].value.string_val)); }
#line 4129 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1182:
#line 2429 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("prior_trunc", (yystack_[0].value.string_val)); }
#line 4135 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1183:
#line 2430 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_mode", (yystack_[0].value.string_val)); }
#line 4141 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1184:
#line 2431 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_nblck", (yystack_[0].value.string_val)); }
#line 4147 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1185:
#line 2432 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("load_mh_file", "1"); }
#line 4153 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1186:
#line 2433 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("loglinear", "1"); }
#line 4159 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1187:
#line 2434 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("nodiagnostic", "1"); }
#line 4165 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1188:
#line 2435 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bayesian_irf", "1"); }
#line 4171 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1189:
#line 2437 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("dsge_var", (yystack_[0].value.string_val)); }
#line 4177 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1190:
#line 2439 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("dsge_var", "Inf"); }
#line 4183 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1191:
#line 2441 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("dsge_var", "NaN"); }
#line 4189 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1192:
#line 2443 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("dsge_varlag", (yystack_[0].value.string_val)); }
#line 4195 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1193:
#line 2444 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("TeX", "1"); }
#line 4201 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1194:
#line 2445 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("forecast", (yystack_[0].value.string_val)); }
#line 4207 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1195:
#line 2446 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("smoother", "1"); }
#line 4213 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1196:
#line 2447 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("moments_varendo", "1"); }
#line 4219 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1197:
#line 2448 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("filtered_vars", "1"); }
#line 4225 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1198:
#line 2449 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("relative_irf", "1"); }
#line 4231 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1199:
#line 2450 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("kalman_algo", (yystack_[0].value.string_val)); }
#line 4237 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1200:
#line 2451 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("kalman_tol", (yystack_[0].value.string_val)); }
#line 4243 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1201:
#line 2453 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("mc_marginal_density", "laplace"); }
#line 4249 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1202:
#line 2455 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("mc_marginal_density", "modifiedharmonicmean"); }
#line 4255 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1203:
#line 2457 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("noprint", "0"); }
#line 4261 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1204:
#line 2458 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("noprint", "1"); }
#line 4267 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1205:
#line 2459 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("xls_sheet", (yystack_[0].value.string_val)); }
#line 4273 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1206:
#line 2460 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("xls_range", (yystack_[0].value.string_val)); }
#line 4279 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1207:
#line 2461 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("filter_step_ahead", (yystack_[0].value.vector_int_val)); }
#line 4285 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1208:
#line 2462 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("taper_steps", (yystack_[0].value.vector_int_val)); }
#line 4291 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1209:
#line 2463 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("geweke_interval",(yystack_[0].value.string_val)); }
#line 4297 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1210:
#line 2464 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("noconstant", "0"); }
#line 4303 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1211:
#line 2465 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("noconstant", "1"); }
#line 4309 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1212:
#line 2466 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("mh_recover", "1"); }
#line 4315 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1213:
#line 2467 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("diffuse_filter", "1"); }
#line 4321 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1214:
#line 2468 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("plot_priors", (yystack_[0].value.string_val)); }
#line 4327 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1215:
#line 2469 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("aim_solver", "1"); }
#line 4333 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1216:
#line 2470 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("partial_information", "1"); }
#line 4339 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1217:
#line 2471 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("sub_draws",(yystack_[0].value.string_val));}
#line 4345 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1218:
#line 2472 "DynareBison.yy" // lalr1.cc:847
    { driver.declare_optimal_policy_discount_factor_parameter((yystack_[0].value.node_val)); }
#line 4351 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1219:
#line 2473 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("sylvester_fp", "1"); }
#line 4357 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1220:
#line 2474 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("sylvester_fp", "0"); }
#line 4363 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1221:
#line 2475 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("sylvester_fixed_point_tol",(yystack_[0].value.string_val));}
#line 4369 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1222:
#line 2476 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_fp", "1"); }
#line 4375 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1223:
#line 2477 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_db", "1"); }
#line 4381 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1224:
#line 2478 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_srs", "1"); }
#line 4387 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1225:
#line 2479 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_fp", "0");driver.option_num("lyapunov_db", "0"); driver.option_num("lyapunov_srs", "0");}
#line 4393 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1226:
#line 2480 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_fixed_point_tol",(yystack_[0].value.string_val));}
#line 4399 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1227:
#line 2481 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("lyapunov_doubling_tol",(yystack_[0].value.string_val));}
#line 4405 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1228:
#line 2482 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_cycle_reduction", "1"); }
#line 4411 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1229:
#line 2483 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_logarithmic_reduction", "1"); }
#line 4417 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1230:
#line 2484 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_cycle_reduction", "0"); driver.option_num("dr_logarithmic_reduction", "0");}
#line 4423 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1231:
#line 2485 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_cycle_reduction_tol",(yystack_[0].value.string_val));}
#line 4429 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1232:
#line 2486 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_logarithmic_reduction_tol",(yystack_[0].value.string_val));}
#line 4435 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1233:
#line 2487 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("dr_logarithmic_reduction_maxiter",(yystack_[0].value.string_val));}
#line 4441 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1234:
#line 2489 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_tau", (yystack_[0].value.string_val)); }
#line 4447 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1235:
#line 2490 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_decay", (yystack_[0].value.string_val)); }
#line 4453 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1236:
#line 2491 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_lambda", (yystack_[0].value.string_val)); }
#line 4459 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1237:
#line 2492 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_mu", (yystack_[0].value.string_val)); }
#line 4465 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1238:
#line 2493 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_omega", (yystack_[0].value.string_val)); }
#line 4471 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1239:
#line 2494 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_flat", "1"); }
#line 4477 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1240:
#line 2495 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_prior_train", (yystack_[0].value.string_val)); }
#line 4483 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1241:
#line 2496 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("bvar_replic", (yystack_[0].value.string_val)); }
#line 4489 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1242:
#line 2498 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("identification", (yystack_[0].value.string_val)); }
#line 4495 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1243:
#line 2499 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("morris", (yystack_[0].value.string_val)); }
#line 4501 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1244:
#line 2500 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("stab", (yystack_[0].value.string_val)); }
#line 4507 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1245:
#line 2501 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("redform", (yystack_[0].value.string_val)); }
#line 4513 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1246:
#line 2502 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("pprior", (yystack_[0].value.string_val)); }
#line 4519 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1247:
#line 2503 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("prior_range", (yystack_[0].value.string_val)); }
#line 4525 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1248:
#line 2504 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ppost", (yystack_[0].value.string_val)); }
#line 4531 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1249:
#line 2505 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ilptau", (yystack_[0].value.string_val)); }
#line 4537 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1250:
#line 2506 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("morris_nliv", (yystack_[0].value.string_val)); }
#line 4543 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1251:
#line 2507 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("morris_ntra", (yystack_[0].value.string_val)); }
#line 4549 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1252:
#line 2508 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("Nsam", (yystack_[0].value.string_val)); }
#line 4555 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1253:
#line 2509 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("load_redform", (yystack_[0].value.string_val)); }
#line 4561 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1254:
#line 2510 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("load_rmse", (yystack_[0].value.string_val)); }
#line 4567 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1255:
#line 2511 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("load_stab", (yystack_[0].value.string_val)); }
#line 4573 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1256:
#line 2512 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("alpha2_stab", (yystack_[0].value.string_val)); }
#line 4579 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1257:
#line 2513 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ksstat", (yystack_[0].value.string_val)); }
#line 4585 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1258:
#line 2514 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("logtrans_redform", (yystack_[0].value.string_val)); }
#line 4591 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1259:
#line 2515 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("threshold_redform",(yystack_[0].value.string_val)); }
#line 4597 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1260:
#line 2516 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ksstat_redform", (yystack_[0].value.string_val)); }
#line 4603 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1261:
#line 2517 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("alpha2_redform", (yystack_[0].value.string_val)); }
#line 4609 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1262:
#line 2518 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("namendo"); }
#line 4615 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1263:
#line 2519 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("namlagendo"); }
#line 4621 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1264:
#line 2520 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("namexo"); }
#line 4627 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1265:
#line 2521 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("rmse", (yystack_[0].value.string_val)); }
#line 4633 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1266:
#line 2522 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("lik_only", (yystack_[0].value.string_val)); }
#line 4639 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1267:
#line 2523 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("var_rmse"); }
#line 4645 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1268:
#line 2524 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("pfilt_rmse", (yystack_[0].value.string_val)); }
#line 4651 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1269:
#line 2525 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("istart_rmse", (yystack_[0].value.string_val)); }
#line 4657 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1270:
#line 2526 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("alpha_rmse", (yystack_[0].value.string_val)); }
#line 4663 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1271:
#line 2527 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("alpha2_rmse", (yystack_[0].value.string_val)); }
#line 4669 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1272:
#line 2529 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("gsa_sample_file", (yystack_[0].value.string_val)); }
#line 4675 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1273:
#line 2531 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("gsa_sample_file", (yystack_[0].value.string_val)); }
#line 4681 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1274:
#line 2533 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("neighborhood_width", (yystack_[0].value.string_val)); }
#line 4687 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1275:
#line 2534 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("pvalue_ks", (yystack_[0].value.string_val)); }
#line 4693 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1276:
#line 2535 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("pvalue_corr", (yystack_[0].value.string_val)); }
#line 4699 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1277:
#line 2536 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("load_ident_files", (yystack_[0].value.string_val)); }
#line 4705 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1278:
#line 2537 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("useautocorr", (yystack_[0].value.string_val)); }
#line 4711 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1279:
#line 2538 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("prior_mc", (yystack_[0].value.string_val)); }
#line 4717 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1280:
#line 2539 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("advanced", (yystack_[0].value.string_val)); }
#line 4723 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1281:
#line 2540 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("max_dim_cova_group", (yystack_[0].value.string_val)); }
#line 4729 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1282:
#line 2542 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("homotopy_mode",(yystack_[0].value.string_val)); }
#line 4735 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1283:
#line 2543 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("homotopy_steps",(yystack_[0].value.string_val)); }
#line 4741 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1284:
#line 2544 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("homotopy_force_continue",(yystack_[0].value.string_val)); }
#line 4747 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1285:
#line 2545 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("steadystate.nocheck","1"); }
#line 4753 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1286:
#line 2547 "DynareBison.yy" // lalr1.cc:847
    { driver.option_symbol_list("controlled_varexo"); }
#line 4759 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1287:
#line 2549 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "prior_mode"); }
#line 4765 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1288:
#line 2551 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "prior_mean"); }
#line 4771 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1289:
#line 2553 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "posterior_mean"); }
#line 4777 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1290:
#line 2555 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "posterior_mode"); }
#line 4783 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1291:
#line 2557 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "posterior_median"); }
#line 4789 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1292:
#line 2559 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("parameter_set", "calibration"); }
#line 4795 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1293:
#line 2561 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.drop", (yystack_[0].value.string_val)); }
#line 4801 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1294:
#line 2562 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.mh_replic", (yystack_[0].value.string_val)); }
#line 4807 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1295:
#line 2564 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.freq",(yystack_[0].value.string_val)); }
#line 4813 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1296:
#line 2566 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.freq","12"); }
#line 4819 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1297:
#line 2568 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.freq","4"); }
#line 4825 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1298:
#line 2570 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.initial_year",(yystack_[0].value.string_val)); }
#line 4831 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1299:
#line 2571 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.initial_subperiod",(yystack_[0].value.string_val)); }
#line 4837 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1300:
#line 2572 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.final_year",(yystack_[0].value.string_val)); }
#line 4843 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1301:
#line 2573 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.final_subperiod",(yystack_[0].value.string_val)); }
#line 4849 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1302:
#line 2574 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("ms.data", (yystack_[0].value.string_val)); }
#line 4855 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1303:
#line 2575 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.vlist",(yystack_[0].value.string_val)); }
#line 4861 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1304:
#line 2576 "DynareBison.yy" // lalr1.cc:847
    {driver.option_symbol_list("ms.vlistlog"); }
#line 4867 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1305:
#line 2577 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.vlistper",(yystack_[0].value.string_val)); }
#line 4873 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1306:
#line 2579 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname",(yystack_[0].value.string_val));
                      }
#line 4882 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1307:
#line 2584 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","upper_cholesky");
                      }
#line 4891 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1308:
#line 2589 "DynareBison.yy" // lalr1.cc:847
    {
                        driver.warning("restriction_fname is now deprecated, and may be removed in a future version of Dynare. Use svar_identification instead.");
                        driver.option_str("ms.restriction_fname","lower_cholesky");
                      }
#line 4900 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1309:
#line 2594 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.nlags",(yystack_[0].value.string_val)); }
#line 4906 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1310:
#line 2595 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.cross_restrictions","1"); }
#line 4912 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1311:
#line 2596 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.contemp_reduced_form","1"); }
#line 4918 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1312:
#line 2597 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.real_pseudo_forecast",(yystack_[0].value.string_val)); }
#line 4924 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1313:
#line 2598 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.bayesian_prior","0"); }
#line 4930 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1314:
#line 2599 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.dummy_obs",(yystack_[0].value.string_val)); }
#line 4936 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1315:
#line 2600 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.nstates",(yystack_[0].value.string_val)); }
#line 4942 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1316:
#line 2601 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxscalesstates",(yystack_[0].value.string_val)); }
#line 4948 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1317:
#line 2602 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.alpha",(yystack_[0].value.string_val)); }
#line 4954 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1318:
#line 2603 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.beta",(yystack_[0].value.string_val)); }
#line 4960 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1319:
#line 2604 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.gsig2_lmdm",(yystack_[0].value.string_val)); }
#line 4966 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1320:
#line 2606 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.specification","1"); }
#line 4972 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1321:
#line 2608 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.specification","0"); }
#line 4978 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1322:
#line 2610 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.q_diag",(yystack_[0].value.string_val)); }
#line 4984 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1323:
#line 2611 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.flat_prior",(yystack_[0].value.string_val)); }
#line 4990 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1324:
#line 2612 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.ncsk",(yystack_[0].value.string_val)); }
#line 4996 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1325:
#line 2613 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.nstd",(yystack_[0].value.string_val)); }
#line 5002 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1326:
#line 2614 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.ninv",(yystack_[0].value.string_val)); }
#line 5008 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1327:
#line 2615 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxparr",(yystack_[0].value.string_val)); }
#line 5014 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1328:
#line 2616 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxovr",(yystack_[0].value.string_val)); }
#line 5020 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1329:
#line 2617 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.aband",(yystack_[0].value.string_val)); }
#line 5026 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1330:
#line 2618 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxap",(yystack_[0].value.string_val)); }
#line 5032 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1331:
#line 2619 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.apband",(yystack_[0].value.string_val)); }
#line 5038 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1332:
#line 2620 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indximf",(yystack_[0].value.string_val)); }
#line 5044 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1333:
#line 2621 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxfore",(yystack_[0].value.string_val)); }
#line 5050 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1334:
#line 2622 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.foreband",(yystack_[0].value.string_val)); }
#line 5056 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1335:
#line 2623 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxgforehat",(yystack_[0].value.string_val)); }
#line 5062 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1336:
#line 2624 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxgimfhat",(yystack_[0].value.string_val)); }
#line 5068 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1337:
#line 2625 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxestima",(yystack_[0].value.string_val)); }
#line 5074 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1338:
#line 2626 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.indxgdls",(yystack_[0].value.string_val)); }
#line 5080 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1339:
#line 2627 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.eq_ms",(yystack_[0].value.string_val)); }
#line 5086 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1340:
#line 2628 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.cms",(yystack_[0].value.string_val)); }
#line 5092 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1341:
#line 2629 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.ncms",(yystack_[0].value.string_val)); }
#line 5098 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1342:
#line 2630 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.eq_cms",(yystack_[0].value.string_val)); }
#line 5104 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1343:
#line 2631 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.tlindx",(yystack_[0].value.string_val)); }
#line 5110 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1344:
#line 2632 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.tlnumber",(yystack_[0].value.string_val)); }
#line 5116 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1345:
#line 2633 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("ms.cnum",(yystack_[0].value.string_val)); }
#line 5122 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1346:
#line 2634 "DynareBison.yy" // lalr1.cc:847
    {driver.option_num("k_order_solver","1"); }
#line 5128 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1347:
#line 2635 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("pruning", "1"); }
#line 5134 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1348:
#line 2636 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.chain",(yystack_[0].value.string_val)); }
#line 5140 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1349:
#line 2638 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.restrictions",(yystack_[0].value.string_val)); }
#line 5146 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1350:
#line 2641 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.duration",(yystack_[0].value.string_val)); }
#line 5152 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1351:
#line 2643 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.duration",(yystack_[0].value.string_val)); }
#line 5158 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1352:
#line 2645 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.number_of_regimes",(yystack_[0].value.string_val)); }
#line 5164 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1353:
#line 2646 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("ms.coefficients","svar_coefficients"); }
#line 5170 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1354:
#line 2647 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("ms.variances","svar_variances"); }
#line 5176 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1355:
#line 2649 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("ms.equations",(yystack_[0].value.vector_int_val)); }
#line 5182 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1356:
#line 2651 "DynareBison.yy" // lalr1.cc:847
    { driver.option_vec_int("ms.equations",(yystack_[0].value.vector_int_val)); }
#line 5188 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1357:
#line 2654 "DynareBison.yy" // lalr1.cc:847
    {driver.option_symbol_list("instruments"); }
#line 5194 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1358:
#line 2656 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("name", (yystack_[0].value.string_val)); }
#line 5200 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1359:
#line 2657 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("nargs",(yystack_[0].value.string_val)); }
#line 5206 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1360:
#line 2659 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("first_deriv_provided", (yystack_[0].value.string_val)); }
#line 5212 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1361:
#line 2661 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("first_deriv_provided", ""); }
#line 5218 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1362:
#line 2664 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("second_deriv_provided", (yystack_[0].value.string_val)); }
#line 5224 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1363:
#line 2666 "DynareBison.yy" // lalr1.cc:847
    { driver.external_function_option("second_deriv_provided", ""); }
#line 5230 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1364:
#line 2669 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("filter_covariance","1");}
#line 5236 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1365:
#line 2672 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("filter_decomposition","1");}
#line 5242 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1366:
#line 2675 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("selected_variables_only","1");}
#line 5248 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1367:
#line 2678 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("cova_compute",(yystack_[0].value.string_val));}
#line 5254 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1368:
#line 2680 "DynareBison.yy" // lalr1.cc:847
    {driver.option_str("ms.output_file_tag", (yystack_[0].value.string_val)); }
#line 5260 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1369:
#line 2681 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("ms.file_tag", (yystack_[0].value.string_val)); }
#line 5266 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1370:
#line 2682 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.create_init", "0"); }
#line 5272 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1371:
#line 2683 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("ms.simulation_file_tag", (yystack_[0].value.string_val)); }
#line 5278 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1372:
#line 2685 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.coefficients_prior_hyperparameters",(yystack_[0].value.string_val)); }
#line 5284 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1373:
#line 2687 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.convergence_starting_value",(yystack_[0].value.string_val)); }
#line 5290 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1374:
#line 2689 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.convergence_ending_value",(yystack_[0].value.string_val)); }
#line 5296 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1375:
#line 2691 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.convergence_increment_value",(yystack_[0].value.string_val)); }
#line 5302 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1376:
#line 2693 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.max_iterations_starting_value",(yystack_[0].value.string_val)); }
#line 5308 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1377:
#line 2695 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.max_iterations_increment_value",(yystack_[0].value.string_val)); }
#line 5314 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1378:
#line 2697 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.max_block_iterations",(yystack_[0].value.string_val)); }
#line 5320 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1379:
#line 2699 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.max_repeated_optimization_runs",(yystack_[0].value.string_val)); }
#line 5326 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1380:
#line 2701 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.function_convergence_criterion",(yystack_[0].value.string_val)); }
#line 5332 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1381:
#line 2703 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.parameter_convergence_criterion",(yystack_[0].value.string_val)); }
#line 5338 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1382:
#line 2705 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.number_of_large_perturbations",(yystack_[0].value.string_val)); }
#line 5344 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1383:
#line 2707 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.number_of_small_perturbations",(yystack_[0].value.string_val)); }
#line 5350 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1384:
#line 2709 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.number_of_posterior_draws_after_perturbation",(yystack_[0].value.string_val)); }
#line 5356 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1385:
#line 2711 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.max_number_of_stages",(yystack_[0].value.string_val)); }
#line 5362 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1386:
#line 2713 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.random_function_convergence_criterion",(yystack_[0].value.string_val)); }
#line 5368 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1387:
#line 2715 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.random_parameter_convergence_criterion",(yystack_[0].value.string_val)); }
#line 5374 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1388:
#line 2716 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.thinning_factor",(yystack_[0].value.string_val)); }
#line 5380 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1389:
#line 2717 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.adaptive_mh_draws",(yystack_[0].value.string_val)); }
#line 5386 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1390:
#line 2718 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.save_draws","1"); }
#line 5392 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1391:
#line 2719 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.proposal_draws",(yystack_[0].value.string_val)); }
#line 5398 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1392:
#line 2720 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.use_mean_center","1"); }
#line 5404 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1393:
#line 2721 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.proposal_type",(yystack_[0].value.string_val)); }
#line 5410 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1394:
#line 2722 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.proposal_lower_bound",(yystack_[0].value.string_val)); }
#line 5416 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1395:
#line 2723 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.proposal_upper_bound",(yystack_[0].value.string_val)); }
#line 5422 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1396:
#line 2724 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.parameter_uncertainty","1"); }
#line 5428 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1397:
#line 2725 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.horizon",(yystack_[0].value.string_val)); }
#line 5434 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1398:
#line 2726 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.filtered_probabilities","1"); }
#line 5440 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1399:
#line 2727 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.real_time_smoothed_probabilities","1"); }
#line 5446 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1400:
#line 2728 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.error_bands","0"); }
#line 5452 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1401:
#line 2729 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.percentiles",(yystack_[0].value.string_val)); }
#line 5458 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1402:
#line 2730 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.shock_draws",(yystack_[0].value.string_val)); }
#line 5464 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1403:
#line 2731 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.shocks_per_parameter",(yystack_[0].value.string_val)); }
#line 5470 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1404:
#line 2732 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.free_parameters",(yystack_[0].value.string_val)); }
#line 5476 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1405:
#line 2733 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.median","1"); }
#line 5482 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1406:
#line 2734 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("median", (yystack_[0].value.string_val)); }
#line 5488 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1407:
#line 2735 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.regimes","1"); }
#line 5494 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1408:
#line 2736 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.regime",(yystack_[0].value.string_val)); }
#line 5500 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1409:
#line 2737 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("ms.forecast_data_obs",(yystack_[0].value.string_val)); }
#line 5506 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1410:
#line 2738 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("discretionary_tol",(yystack_[0].value.string_val)); }
#line 5512 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1411:
#line 2739 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("analytic_derivation", "1"); }
#line 5518 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1412:
#line 2740 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("endogenous_prior", "1"); }
#line 5524 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1413:
#line 2741 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("use_univariate_filters_if_singularity_is_detected", (yystack_[0].value.string_val)); }
#line 5530 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1414:
#line 2743 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("MCMC_jumping_covariance", (yystack_[0].value.string_val)); }
#line 5536 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1415:
#line 2744 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("MCMC_jumping_covariance", (yystack_[0].value.string_val)); }
#line 5542 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1416:
#line 2746 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("MCMC_jumping_covariance", (yystack_[0].value.string_val)); }
#line 5548 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1417:
#line 2748 "DynareBison.yy" // lalr1.cc:847
    { driver.option_str("MCMC_jumping_covariance", (yystack_[0].value.string_val)); }
#line 5554 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1418:
#line 2750 "DynareBison.yy" // lalr1.cc:847
    { driver.option_num("impulse_responses.plot_threshold", (yystack_[0].value.string_val)); }
#line 5560 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1419:
#line 2753 "DynareBison.yy" // lalr1.cc:847
    {
          (yystack_[2].value.string_val)->append(":");
          (yystack_[2].value.string_val)->append(*(yystack_[0].value.string_val));
          delete (yystack_[0].value.string_val);
          (yylhs.value.string_val) = (yystack_[2].value.string_val);
        }
#line 5571 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1420:
#line 2760 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_int_val) = new vector<int>(); (yylhs.value.vector_int_val)->push_back(atoi((*(yystack_[0].value.string_val)).c_str())); delete (yystack_[0].value.string_val); }
#line 5577 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1422:
#line 2764 "DynareBison.yy" // lalr1.cc:847
    {
                 (yylhs.value.vector_int_val) = new vector<int>();
                 for(int i=atoi((*(yystack_[2].value.string_val)).c_str()); i<=atoi((*(yystack_[0].value.string_val)).c_str()); i++)
                   (yylhs.value.vector_int_val)->push_back(i);
                 delete (yystack_[2].value.string_val);
                 delete (yystack_[0].value.string_val);
               }
#line 5589 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1423:
#line 2774 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_int_val) = (yystack_[0].value.vector_int_val);}
#line 5595 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1424:
#line 2776 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_int_val) = (yystack_[0].value.vector_int_val);}
#line 5601 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1425:
#line 2778 "DynareBison.yy" // lalr1.cc:847
    {
              (yylhs.value.vector_int_val) = (yystack_[1].value.vector_int_val);
              for (vector<int>::const_iterator it=(yystack_[0].value.vector_int_val)->begin();
                   it!=(yystack_[0].value.vector_int_val)->end(); it++)
                (yystack_[1].value.vector_int_val)->push_back(*it);
              delete (yystack_[0].value.vector_int_val);
            }
#line 5613 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1426:
#line 2786 "DynareBison.yy" // lalr1.cc:847
    {
              (yylhs.value.vector_int_val) = (yystack_[2].value.vector_int_val);
              for (vector<int>::const_iterator it=(yystack_[0].value.vector_int_val)->begin();
                   it!=(yystack_[0].value.vector_int_val)->end(); it++)
                (yystack_[2].value.vector_int_val)->push_back(*it);
              delete (yystack_[0].value.vector_int_val);
            }
#line 5625 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1427:
#line 2796 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_int_val) = (yystack_[1].value.vector_int_val); }
#line 5631 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1428:
#line 2798 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.vector_int_val) = (yystack_[2].value.vector_int_val); }
#line 5637 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1429:
#line 2801 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[0].value.string_val)->insert(0,"["); (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 5643 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1430:
#line 2802 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[0].value.string_val)->insert(0,"["); (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 5649 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1431:
#line 2804 "DynareBison.yy" // lalr1.cc:847
    {
                (yystack_[1].value.string_val)->append(" ");
                (yystack_[1].value.string_val)->append(*(yystack_[0].value.string_val));
                delete (yystack_[0].value.string_val);
                (yylhs.value.string_val) = (yystack_[1].value.string_val);
              }
#line 5660 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1432:
#line 2811 "DynareBison.yy" // lalr1.cc:847
    {
                (yystack_[2].value.string_val)->append(" ");
                (yystack_[2].value.string_val)->append(*(yystack_[0].value.string_val));
                delete (yystack_[0].value.string_val);
                (yylhs.value.string_val) = (yystack_[2].value.string_val);
              }
#line 5671 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1433:
#line 2819 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[1].value.string_val)->append("]"); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 5677 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1434:
#line 2820 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[2].value.string_val)->append("]"); (yylhs.value.string_val) = (yystack_[2].value.string_val); }
#line 5683 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1435:
#line 2824 "DynareBison.yy" // lalr1.cc:847
    {
                   (yystack_[2].value.string_val)->append(",");
                   (yystack_[2].value.string_val)->append(*(yystack_[0].value.string_val));
                   delete (yystack_[0].value.string_val);
                   (yylhs.value.string_val) = (yystack_[2].value.string_val);
                 }
#line 5694 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1436:
#line 2831 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 5700 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1437:
#line 2834 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 5706 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1438:
#line 2835 "DynareBison.yy" // lalr1.cc:847
    { (yylhs.value.string_val) = (yystack_[0].value.string_val); }
#line 5712 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1439:
#line 2838 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[0].value.string_val)->insert(0, "["); (yylhs.value.string_val) = (yystack_[0].value.string_val);}
#line 5718 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1440:
#line 2840 "DynareBison.yy" // lalr1.cc:847
    {
                      (yystack_[1].value.string_val)->append(" ");
                      (yystack_[1].value.string_val)->append(*(yystack_[0].value.string_val));
                      delete (yystack_[0].value.string_val);
                      (yylhs.value.string_val) = (yystack_[1].value.string_val);
                    }
#line 5729 "DynareBison.cc" // lalr1.cc:847
    break;

  case 1441:
#line 2848 "DynareBison.yy" // lalr1.cc:847
    { (yystack_[1].value.string_val)->append("]"); (yylhs.value.string_val) = (yystack_[1].value.string_val); }
#line 5735 "DynareBison.cc" // lalr1.cc:847
    break;


#line 5739 "DynareBison.cc" // lalr1.cc:847
            default:
              break;
            }
        }
      catch (const syntax_error& yyexc)
        {
          error (yyexc);
          YYERROR;
        }
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;
      YY_STACK_PRINT ();

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, yylhs);
    }
    goto yynewstate;

  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        error (yyla.location, yysyntax_error_ (yystack_[0].state,
                                           yyempty ? yyempty_ : yyla.type_get ()));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.type_get () == yyeof_)
          YYABORT;
        else if (!yyempty)
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyempty = true;
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:

    /* Pacify compilers like GCC when the user code never invokes
       YYERROR and the label yyerrorlab therefore never appears in user
       code.  */
    if (false)
      goto yyerrorlab;
    yyerror_range[1].location = yystack_[yylen - 1].location;
    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    goto yyerrlab1;

  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    {
      stack_symbol_type error_token;
      for (;;)
        {
          yyn = yypact_[yystack_[0].state];
          if (!yy_pact_value_is_default_ (yyn))
            {
              yyn += yyterror_;
              if (0 <= yyn && yyn <= yylast_ && yycheck_[yyn] == yyterror_)
                {
                  yyn = yytable_[yyn];
                  if (0 < yyn)
                    break;
                }
            }

          // Pop the current state because it cannot handle the error token.
          if (yystack_.size () == 1)
            YYABORT;

          yyerror_range[1].location = yystack_[0].location;
          yy_destroy_ ("Error: popping", yystack_[0]);
          yypop_ ();
          YY_STACK_PRINT ();
        }

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = yyn;
      yypush_ ("Shifting", error_token);
    }
    goto yynewstate;

    // Accept.
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;

    // Abort.
  yyabortlab:
    yyresult = 1;
    goto yyreturn;

  yyreturn:
    if (!yyempty)
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack"
                 << std::endl;
        // Do not try to display the values of the reclaimed symbols,
        // as their printer might throw an exception.
        if (!yyempty)
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what());
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (state_type yystate, symbol_number_type yytoken) const
  {
    std::string yyres;
    // Number of reported tokens (one for the "unexpected", one per
    // "expected").
    size_t yycount = 0;
    // Its maximum.
    enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
    // Arguments of yyformat.
    char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];

    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yytoken) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state
         merging (from LALR or IELR) and default reductions corrupt the
         expected token list.  However, the list is correct for
         canonical LR with one exception: it will still contain any
         token that will not be accepted due to an error action in a
         later state.
    */
    if (yytoken != yyempty_)
      {
        yyarg[yycount++] = yytname_[yytoken];
        int yyn = yypact_[yystate];
        if (!yy_pact_value_is_default_ (yyn))
          {
            /* Start YYX at -YYN if negative to avoid negative indexes in
               YYCHECK.  In other words, skip the first -YYN actions for
               this state because they are default actions.  */
            int yyxbegin = yyn < 0 ? -yyn : 0;
            // Stay within bounds of both yycheck and yytname.
            int yychecklim = yylast_ - yyn + 1;
            int yyxend = yychecklim < yyntokens_ ? yychecklim : yyntokens_;
            for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
              if (yycheck_[yyx + yyn] == yyx && yyx != yyterror_
                  && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
                {
                  if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                    {
                      yycount = 1;
                      break;
                    }
                  else
                    yyarg[yycount++] = yytname_[yyx];
                }
          }
      }

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
        YYCASE_(0, YY_("syntax error"));
        YYCASE_(1, YY_("syntax error, unexpected %s"));
        YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    // Argument number.
    size_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += yytnamerr_ (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short int parser::yypact_ninf_ = -2449;

  const short int parser::yytable_ninf_ = -1462;

  const short int
  parser::yypact_[] =
  {
    4317,    84,    87,  4937,  -248,     3,  -123,  -226,  -114,   213,
    -111,  -102,   101,  5743,  -103,   -94,   195,   203,   -80,  5764,
     -77,   -58,   -51,   247,   299,   -20,    -9,    -1,   365,  5798,
     439,    12,    47, -2449,    56,    80,  5893,  9121,  9121,   252,
   -2449,  6119,  9121,    38,    90,  5950,   273,   495,   112,   610,
    5971,  6020,  6039,  9121,  6178,  9121,  9121, -2449,  9121,   128,
     143,   630,    42, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449,   640,   152,  6100,   690,   696,   704,   708,   710,
     731, -2449,   159,   162,   165,  3944, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,   121, -2449, -2449,   477, -2449, -2449,   600,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,    70,
     174,  1780,   181,  2250, -2449,   196,  6386, -2449,   548, -2449,
    1486,  1052,   453,  9121,    78,  9083,  9083,  9121,   685, -2449,
    3323,  6405,  1852,  2775,  2797,   717, -2449,   561,   644, -2449,
    1496,  6424,  9121,  9121,  9121, -2449,  1667,  9121,   719,   660,
    9083,   622, -2449,   755, -2449,   641,   282,  6343, -2449, -2449,
   -2449,   526, -2449,  9121,  9121, -2449,  5573,  6569,  6631,  6650,
     -62,   672,   304,  3862,   596,  6695,  6714,  9083,   177, -2449,
     164,  6776,   313, -2449,  1048, -2449, -2449,  1069, -2449,  5819,
    6857, -2449,  5668,  6921, -2449,  5416,  6940,  6983,    52,  7002,
     -13,  7066,    -8,  7147,    14,  9121,  7209, -2449, -2449, -2449,
   -2449,  2930,   479, -2449,   715,   383, -2449,  1634,  7228, -2449,
    1696, -2449,   384, -2449,   182, -2449,  1315, -2449,   387, -2449,
    1668,   329,   521,   339,   729, -2449, -2449,  2832,  9121,  2931,
    2950,  5116,  4964, -2449,   757, -2449,   760,   772,   776,   781,
     791, -2449,   825,   834,   837, -2449,   840,   842,   865,   869,
   -2449,   553,   450, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
     887,   889,   951, -2449,   762,   559, -2449, -2449, -2449,   987,
   -2449,   564,   813, -2449, -2449, -2449,  9121, -2449, -2449, -2449,
   -2449, -2449, -2449,   604, -2449,  1026,  1032,  1046,  1077,  1081,
    1084,  1086, -2449,    44, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  1091,  1097,  1100,  1102,    53, -2449, -2449,
   -2449, -2449, -2449, -2449,  9121,   223, -2449,   894,   692, -2449,
     700,   716,   601, -2449,  1122,   723, -2449, -2449,  1130, -2449,
    1157,  1160,  1163, -2449, -2449,  1168,  1169,  1170,  1171,  1174,
    1175,  1176,  1178,  1181, -2449, -2449,  1182,  1183,  1184,  1198,
    1199,  1200,  1210,  1212,  1213,  1225, -2449, -2449,  1228,  1232,
    1241,  1242,  1243, -2449, -2449,  1245,  1247,  1248,  1249, -2449,
   -2449, -2449,  1250,  1257, -2449,  1258,  1262,  1263,  1266, -2449,
    1273,  1274, -2449,  1277,  1278, -2449, -2449, -2449,  1281,    57,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  9121,
   -2449,  9121,  1630, -2449,  1074, -2449,  9121,  9121,  1886, -2449,
    1078,  9121,  9121,  2096, -2449,  1080,   866, -2449,  1294,  1296,
     871,  1088, -2449, -2449, -2449, -2449, -2449, -2449,   -70,    65,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,   873,  2852, -2449,
     875,  3691, -2449,  1092,  1305,  1308,  1310,  1313,  1314,  1318,
    1319,   895,  1105, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  3898,
     899,  1320,   903,  1331,  3556, -2449, -2449,  1332,  1334, -2449,
    1335, -2449,  1337, -2449, -2449,    69, -2449, -2449, -2449,  1348,
     924,   261,  9083, -2449,   931,    97, -2449,  9121, -2449,   286,
    4161, -2449,   932,  4232,  4347,  1358,  1366, -2449,  1370,  1373,
    1374,  1378, -2449, -2449, -2449, -2449, -2449, -2449,  1380, -2449,
    1383, -2449,  1384,  1385, -2449,   103, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
    9121, -2449,    16,   962,  1185, -2449,  1012, -2449, -2449, -2449,
    1013,  1017,  1025,  1034,  3862,  3862,  1037,  1041,  1045,  1047,
    1050,  1051,  1053,  1054,  1055,  1056,  1057,  1095,  1106,  1138,
    1139,  1141,  3862,  2136, -2449,  1142,  1437, -2449, -2449,  1031,
    9121,  9121,   292, -2449, -2449,  1079,  1267, -2449, -2449, -2449,
     204,  1549,  1568,  1569,   106, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449,  4627,   115, -2449,   139, -2449, -2449, -2449, -2449,
    1570,  1571, -2449,   160, -2449, -2449, -2449, -2449,  1578,  1579,
     169, -2449, -2449, -2449, -2449, -2449, -2449,  1580,  1581,  9121,
   -2449,    34,   962, -2449,  9121, -2449,    39,   962, -2449,  9121,
   -2449,    41,   962, -2449,  7273, -2449,  9121, -2449, -2449,  1582,
    1583,  1587,  1588,  1589,  1590,  1591,  1592,  1595,  1596,  1599,
    1600,  1601,  1602,  1603,  1605,  1607,  1608,  1613,  1615,  1617,
    1618,  1619,  1620,  1623,  1624,  1625,  1626,  1627,  1629,  1631,
    1632,  1204,  1423, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  1635,  1636,  1638,  1642,   191, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,  1645,  1648,  1649,  1652,  1656,
    1658,  1659,  1660,  1662,  1664, -2449,  1665, -2449,  1666,  1669,
    1683,  1699, -2449,  1700,  1703,  1705,  1706,  1707,  1710,  1711,
    1712,  1713,  1714,  1726,  1727,  1728,  1729,  1731,  1733,  1734,
    1736,  1739,  1740,  1749,  1751,  1753,  1754,  1756,  1759,  1760,
    1761,  1458,  1336, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449,  1763, -2449, -2449,  1764,  1766,  1767,  1768,  1770,  1772,
    1773,  1774,  1775,  1776, -2449,  1777,  1574,  1353, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,  1575,  1354, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
    1788, -2449,  1791,  1792,  1794,  1795,  1796,  1797,  1801,  1803,
    1804,  1808,  1811,  1814,  1815,  1817,  1818,  1611,  1396, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,  1823,  1824, -2449,  1827,  1621,  1402,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  1830,  1833,  1835,
    1836, -2449,  1628,  1411, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  1639,  1414, -2449, -2449, -2449, -2449,  1841,
    1640,  1416, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,   414,  1844,  1845,  1846,  1848,
     192, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  1855,   198,
   -2449, -2449, -2449, -2449, -2449,  1858,  1859,  1860,  1861,   224,
   -2449, -2449, -2449, -2449, -2449,  1427,  1440,  1443,  1439,   243,
   -2449,  1871,  1448,  1449,  1451,  1446,  1453,  1455,  1459,  1460,
   -2449,  1464,  1468,  1471,  1473, -2449,  5116,  5116,  1474,  1477,
    1479,  1480,  1481,  1482,  1484,  1494,  1500,  1501,  1502,  1503,
    1534,  1535,  5116,  1461, -2449,  1539, -2449,  1541,    76,  1469,
     261,   771,   261,  1837,   771,  1872,  9083,  1919,    79,  1920,
    1921,  9121,  9121,  1780,  1923,  1924,   261,  1925,  2250,  1927,
    1550,  6488,   196, -2449,  9121,  1929,  1930,  1932,   261,  1933,
     261,  1935,  1486,  1561,  1564,  1087,  1941,  1942,  1052,  1576,
    1577,  1584, -2449,  9121, -2449,  7951,  8032,  1586, -2449,  5116,
    1594,  1943,   261,   261,  1944,   747,    79,  1949,  1597,   261,
    1954,   261,  1958,  1963,   662,   261,   261,   261,   261,   261,
     261,  1964,  1966,  1967,   655,  1976,  1980,  8406,  9083,  1981,
    1550,  1609,  9061,  1610,  1983,  1988,   261,   311,  1995,  1124,
     261,  1997,   712,  1998,  3323,  8115,  1838, -2449,  1643, -2449,
     331,  1839,  1842,  1646, -2449,  5116,  1849,  1854,  1647, -2449,
    5116,  1650,  2002,  2017,  1653,   561,  2020,  1654,  1496,  8158,
    1641,  1657, -2449,   240,  1672, -2449,  5116,  2024,  2031,   240,
    2041,  2042,  8467,  2044,  1673,  1667,  1674,  1675,  9083,  1676,
   -2449,  1990,  9121,   653, -2449,   120, -2449,   261,  1677,  2055,
    1680,   755,  1682,   183,  9083,  1681,  1685,   261, -2449,  1687,
    1701,  1702, -2449,  1704, -2449,  5116,  1708,  4481,  9121,  2999,
    2078,  2080,   261,  2082,   261,  2084,   261,  2085,  2088,  2089,
    5573,  8177,    43,   962, -2449, -2449,  2139, -2449,  3862,  3862,
    3862,  3862,   546,  1917,  3862,  3862,  3862,  3862,  3862,  3862,
    3862,  3862,  3862,  3862,  3862,  3862,  3862,  3862,  3862,   240,
    2065,  3862,  3862,  3862,  3862,  3862,  3862,  3862,  3862,  3862,
    3862,  3862,  1717,  1719,  2093,  1721,  1936,   155,  1723, -2449,
    8241,   164,   261,   261,  5116,   -66,   227, -2449, -2449,  2100,
     261,  2101,  1048,  1746,  9121,   544, -2449,  2171,  1069,  1748,
    5819,  8260,  1750,  5116,  5668,  8322,  2124,   261,  5416,  8341,
   -2449, -2449,    49,   962, -2449, -2449,    63,   962, -2449, -2449,
      68,   962, -2449, -2449,  9121, -2449, -2449, -2449,  2125,  2127,
    2129,  2130,  2131,  2132,  2134,  2135,  2155,  2156,  2157,  2160,
    2161,   261,   261,  2162,  1793,   261,   261,  1798,  1805,  1806,
    2172,  2173,  1807,   261,  2180,   261,   261,   261,   261,   261,
    1809,  2930,  9083,   644,   644,  2185,   479,  1812,    88,  2188,
    2190,  2192,  2194,  9083,  2196,  1821,  2198,    29,  2200,  2201,
    2202,  2204,  2205,   261,   261,  2207,  2208,  2209,  2210,  2213,
    2214,   261,  2216,  2217,  2219,  2220,  2221,  2222,  2223,  2225,
    2237,  2240,  2241,  2242,  2243,  2244,  2245,  2247,  2248,  2252,
    1609,   715,  1882, -2449,  2259,  9083,  2263,  9083,  9083,  1609,
    2265,  2266,  1609,   771,  2267,  1634,  8386,  1696,  1887,   -16,
     261,   261,   261,  2268,   261,  2269,  2270,   261,   261,  2271,
    2272,  2286,  2292,   261,   261,   384,  1910,  2293,  2295,  2296,
     182,  1934,  2311,   771,   771,  2312,  1315,  1939,   387,  1945,
    2317,  1668,  1946,  1911,   -35,  1948,  1951,   250, -2449,  1868,
    2318,   126,  2319,   521,  1952,    79,   339,  1953,  9083,  2324,
    9083,  9083,   729,  1956,  9121,  9121, -2449,  2320,  9121,  1959,
     644,  9121,  9121, -2449,  9140,  9121,  9121, -2449,  8645,  5116,
    5116,  5116,  5116,  2159,  2159,  5116,  5116,  5116,  5116,  5116,
    5116,  5116,  5116,  5116,  5116,  5116,  5116,  5116,  5116,  2113,
    5116,  5116,  5116,  5116,  5116,  5116,  5116,  5116,  5116,  5116,
    5116, -2449,  1960,   699,  1962,    82, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,   131, -2449,    75, -2449, -2449,
   -2449, -2449, -2449,  1984, -2449,  1965, -2449, -2449, -2449, -2449,
    1992, -2449, -2449,  7292, -2449,  7354, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449,  9121, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  2279, -2449,  1993,
   -2449,  7435, -2449,  7499, -2449,  3498,  9121, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,   782, -2449, -2449, -2449, -2449,
    9121, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
     435,   695, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449,   657,   154, -2449, -2449, -2449, -2449, -2449,  2231,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449,  7518,  9121, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449,  5160,  2211,  1994,  2212,
    9121,  5116, -2449,  1738,  9121,  5116, -2449,  5563,  2246, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  7561,  8548, -2449,
   -2449,  2341,  2371,  2000, -2449,  8085, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  9121,  2001, -2449,
    3862,  2423,   -78, -2449,  2424,  2004, -2449, -2449,  3862, -2449,
   -2449,  9121, -2449,  9083, -2449, -2449, -2449, -2449,  6362, -2449,
     261,  2003, -2449, -2449,  2294, -2449, -2449,  2224, -2449,  9121,
    8310,  5116, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,  7580,   962, -2449, -2449,  2277,
    2659,  3348,  2262,  2285,  2545,  2904,  3069,  3144,  3271,  3364,
    3408,  3458,  3630,  3814,  3847,  4155,   598,   763,  4186,  2005,
   -2449,  1697,  1697,   705,   705,   705,   705,   546,   546,  1917,
    1917,  2226, -2449,  3862,  2019, -2449,  9121,  5116,  9121,    40,
   -2449, -2449,  7644, -2449, -2449, -2449,  4388,   204,  2026,   229,
    5116, -2449, -2449, -2449, -2449, -2449, -2449,  3236,  2027, -2449,
    5116, -2449, -2449, -2449, -2449,  7725,  9121,  2733, -2449, -2449,
    7787, -2449, -2449, -2449, -2449,  7806,  3862,  3862,   962, -2449,
   -2449,   962, -2449, -2449,   962, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,   655,   180, -2449, -2449, -2449,   632,
     632,   632, -2449, -2449,   632, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,  2238,  2238, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  9121,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  3862,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  7851, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449,  2399,  2405,  2037, -2449, -2449,  2038, -2449,   158, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  2253,  2039, -2449,
   -2449,   -83,  2254,  2040,  2036,  2052,  2261,  2043, -2449,  2053,
    3436,  4532,  4624,  5071,  5270,  5288,  5303,  5427,  5549,  5795,
    5872,  5940,  5958,  6021,  6088,  6174,   856,  1475, -2449,  1901,
    1901,   870,   870,   870,   870,   779,   779,  2159,  2159,  2226,
    5116,  2472,  2487,  2490,   259, -2449, -2449, -2449, -2449,   271,
    2069,  2510,  2081,  2463, -2449, -2449,    77, -2449, -2449,  9121,
   -2449, -2449, -2449,  9121, -2449, -2449,  4836,  2464,  2083, -2449,
   -2449, -2449,  4702, -2449,   262,  5365, -2449, -2449,   771, -2449,
     110, -2449, -2449,  2305, -2449,   265, -2449, -2449,   331, -2449,
    5116,  2306,  4996,  5116,  2307,  8372, -2449,  2094,  2588, -2449,
   -2449,  2097,   100,  2090, -2449, -2449,  2525,  5116, -2449,  4779,
    2103,  6344,  2376,  1990,  3862,  3862, -2449,  8600,  5591, -2449,
     266,  3556, -2449,  2104, -2449,  2464,  2107,  5116, -2449,  8614,
   -2449, -2449,  2106,  3862,  3862, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  3862,
   -2449,  3862, -2449, -2449,  2108,  2136,   277,  9121,  2534,  8655,
    2540,  5116, -2449, -2449,   227, -2449,  5116, -2449,  6393,  2541,
   -2449,  8668, -2449,  5615, -2449, -2449,  6406,  6638, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449,  9102,  2116,  2118,  2138,  2140,
    5723,  6677, -2449,  2355,  2143, -2449, -2449, -2449,   -25,  9121,
    2142,   644,  9121,  2144,  2257,  9121,  2145,  2511,  5116,  5116,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,  5116, -2449,  5116, -2449,  2733,   284,
    1793,   261,   771,   699,  2147,  2569,  2577,  2579,  2580,  2581,
    2582,  2583,  2584,  2585,   290, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449,   699,  2163,  2538, -2449,
   -2449, -2449, -2449, -2449, -2449,  2164,   116,  8613,  2165,   782,
   -2449, -2449, -2449, -2449, -2449,   709,  2231, -2449,  2733,  2380,
    2382,  2386, -2449,  5116,  5116,  8681,  5116, -2449, -2449,  2174,
     699,  2175,    89,  5116,  8720,  2177, -2449,  9121, -2449, -2449,
     173,  8800, -2449, -2449,  9083, -2449,  3507, -2449,   190, -2449,
    8814, -2449, -2449,  6702,  6758,  5906,  5925,  3862,  3862, -2449,
    7870,  5116, -2449,  5116,  8828,  6928, -2449,  5116, -2449, -2449,
    9121,  9121, -2449, -2449, -2449, -2449, -2449,  9121, -2449,  2235,
    1609, -2449,  2176,  2548,  2238,  2181,  9159, -2449,  2182,  8674,
   -2449,  6990,  7048,  6288,  6363,  5116, -2449, -2449, -2449, -2449,
   -2449, -2449,   771,   771,   261,  5116,   771,  1609,   522,  1609,
    1609,   271,  2179,   303,   271, -2449,  2550,  2189,  2560,  2411,
   -2449,  2186,   114,  2184, -2449, -2449, -2449, -2449, -2449,  5116,
    5116,  5116,  6533,  8841, -2449,  8854, -2449,   309,   271,  2187,
    2618,  8870, -2449, -2449,  7932,  2429,  3862, -2449, -2449, -2449,
    2199,  2425, -2449, -2449, -2449,  3862,  3862,  7216,  2136, -2449,
    8883,  8896, -2449, -2449,  8909,  8013,    72,  8077,  8096,  2430,
    4652,  2576,  2264, -2449,  2203,  2215,  2036,  2218,  2228, -2449,
    2230, -2449, -2449,  5116,  5116,  2733, -2449, -2449, -2449,  2733,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,  2227,   325, -2449,  2578,  2232,   232,
     699,  2206,   113,  2428, -2449,  2431,  5116, -2449, -2449,  2229,
     333,   699,  2249, -2449,  9121, -2449,  2441, -2449,  8922, -2449,
     232,  7280,  7336, -2449, -2449, -2449, -2449,  9121, -2449,    73,
     962, -2449, -2449,  9121, -2449,  2443, -2449,  4756,  4810,  2251,
    2840,  2639,  4652, -2449,  2432,  2591,  2587,  9178,  2326,  8693,
    2589,  7506,  7568, -2449,  2233, -2449,  2598,  5116,   197, -2449,
     341,   271,  2258,  2652,   410,  5116,  8935, -2449,  2239,   344,
     271,  2462, -2449, -2449,   201, -2449, -2449,    74,   962, -2449,
   -2449,  2473, -2449,  2260,  2275,  9121,  5085, -2449,  2840, -2449,
    9121,  2445,  2036,  2236, -2449, -2449,  2273, -2449, -2449, -2449,
   -2449, -2449,  7626,   234, -2449,  5116, -2449,  2255,   356,   699,
    2276,  2456,  2458, -2449, -2449,  2281,   400, -2449, -2449,   962,
   -2449, -2449, -2449,  9121,  9121,  2459,  2278,  4652,   -67, -2449,
    9121,  2353,  2612, -2449,  5116, -2449,  7794, -2449,  2283,   401,
     271,  5116,  5116, -2449,  2288, -2449,  2465,  2467,  2623,  9121,
    2289,  9121, -2449,   -46, -2449, -2449,  7858, -2449, -2449,  2297,
     413, -2449,  2468, -2449,  2633,  2635,  2284,  2480, -2449, -2449,
   -2449, -2449, -2449,  2298,  5116,  2290,  2291, -2449,  2642, -2449,
    2733, -2449, -2449,  2300, -2449
  };

  const unsigned short int
  parser::yydefact_[] =
  {
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1442,     0,     0,     0,     0,     0,     0,
     751,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   688,     0,     0,
       0,     0,     0,  1443,  1444,  1446,  1445,  1447,  1448,  1449,
    1450,  1451,  1452,  1453,  1454,  1455,  1456,  1457,  1458,  1460,
    1459,  1461,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   322,     0,     0,     0,     0,     2,    39,    40,    71,
      72,     5,     6,     7,     8,     4,     9,    10,    16,    12,
      13,    14,    15,    11,    17,    66,    67,    68,    18,    19,
      20,    21,    47,    22,    69,    23,    25,    27,    26,    28,
      29,    32,    33,     0,    30,    31,     0,    34,    35,     0,
      24,    36,    37,    38,    41,    42,    43,    44,    45,    57,
      58,    59,    46,    48,    49,    50,    60,    61,    62,    51,
      52,    53,    79,    77,    78,    76,    75,    74,    73,    54,
      55,    56,    63,    65,    64,    70,    80,    81,    82,     0,
       0,     0,     0,     0,  1078,     0,     0,   471,     0,   394,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   601,
       0,     0,     0,     0,     0,     0,  1087,     0,     0,  1047,
       0,     0,     0,     0,     0,   719,     0,     0,     0,     0,
       0,     0,   254,     0,   742,     0,   745,     0,   741,   400,
     404,     0,  1095,     0,     0,   709,     0,     0,     0,     0,
     162,     0,     0,     0,     0,     0,     0,     0,     0,   774,
       0,     0,     0,   405,     0,  1072,   383,     0,   422,     0,
       0,   754,     0,     0,   758,     0,     0,     0,     0,     0,
     126,     0,   138,     0,   150,     0,     0,   174,   772,   773,
     984,     0,     0,   857,     0,     0,   910,     0,     0,   875,
       0,   982,     0,   943,     0,   932,     0,   920,     0,   892,
       0,     0,     0,     0,     0,     1,     3,     0,     0,     0,
       0,     0,     0,   797,     0,  1239,     0,     0,     0,     0,
       0,  1210,     0,     0,     0,  1211,     0,     0,     0,     0,
     785,   796,     0,   786,   791,   789,   792,   790,   787,   788,
     793,   794,   778,   779,   780,   781,   782,   783,   784,   805,
       0,     0,     0,   799,   804,     0,   801,   800,   802,     0,
    1197,     0,  1083,  1086,  1084,  1085,     0,  1080,   469,   176,
     177,   178,   179,     0,  1285,     0,     0,     0,     0,     0,
       0,     0,   398,     0,   397,   387,   392,   391,   399,   388,
     389,   390,   393,     0,     0,     0,     0,     0,  1059,  1062,
    1061,  1063,  1064,  1065,     0,     0,  1069,     0,     0,    83,
       0,     0,     0,   236,     0,     0,  1215,  1411,     0,  1188,
       0,     0,     0,  1412,  1157,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1185,  1186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1212,  1178,     0,     0,
       0,     0,     0,  1196,  1213,     0,     0,     0,     0,  1158,
    1187,  1156,     0,     0,  1216,     0,     0,  1191,     0,  1195,
       0,     0,  1193,     0,     0,  1364,  1365,  1366,     0,     0,
     606,   650,   656,   676,   639,   664,   679,   607,   608,   662,
     609,   610,   611,   612,   613,   614,   615,   616,   617,   618,
     619,   620,   621,   622,   623,   624,   625,   626,   627,   629,
     628,   630,   631,   632,   633,   634,   635,   636,   637,   638,
     640,   641,   642,   643,   644,   645,   646,   647,   648,   649,
     680,   681,   651,   652,   653,   654,   655,   657,   658,   665,
     666,   667,   668,   669,   670,   671,   672,   673,   674,   659,
     660,   661,   663,   675,   677,   678,   682,   683,   603,     0,
     494,     0,     0,   489,     0,   492,     0,     0,     0,   514,
       0,     0,     0,     0,   508,     0,     0,  1115,     0,     0,
       0,  1090,  1091,  1092,  1093,  1094,   532,   533,     0,     0,
    1051,  1053,  1055,  1056,  1057,  1054,  1049,     0,     0,   240,
       0,     0,  1043,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   722,   731,   723,   730,   734,   736,   737,   738,
     735,   729,   732,   725,   724,   726,   727,   728,   733,     0,
       0,     0,     0,     0,     0,   242,   245,     0,   248,  1100,
       0,   247,     0,   246,   253,     0,   250,   243,   244,     0,
       0,     0,     0,   739,   747,     0,   403,     0,   361,     0,
       0,   695,     0,     0,     0,     0,     0,  1346,     0,     0,
       0,     0,  1105,  1106,  1107,  1204,  1203,  1347,     0,  1198,
       0,  1125,     0,     0,   706,     0,   705,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,   438,   442,   443,
     445,   446,   447,   707,   708,   448,   450,   449,   451,   452,
     457,   439,   440,   441,   444,   453,   454,   455,   456,   460,
     461,   462,   463,   464,   465,   458,   459,   466,   711,   703,
       0,   122,   160,   168,     0,   165,     0,   183,   478,   477,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   752,   272,   271,     0,  1066,    85,     0,
       0,     0,     0,   315,   316,     0,  1039,  1041,  1040,   776,
       0,     0,     0,     0,     0,   408,   411,   409,   414,   412,
     413,   410,     0,     0,   386,     0,   467,   427,   468,   424,
       0,     0,   769,     0,   768,   770,   771,   756,     0,     0,
       0,   763,   764,   766,   765,   760,   697,     0,     0,     0,
     102,   124,   132,   129,     0,   119,   136,   144,   141,     0,
     120,   148,   156,   153,     0,   692,     0,   121,   172,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   987,  1035,  1021,  1022,  1023,  1024,  1025,  1037,
    1026,  1027,  1028,  1029,  1030,  1032,  1031,  1036,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1013,  1005,  1006,  1014,  1016,
    1015,  1007,  1008,  1017,  1009,  1010,  1011,  1012,  1018,  1019,
    1020,  1033,  1034,     0,     0,     0,     0,     0,   538,   539,
     540,   541,   542,   543,   544,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1310,     0,  1311,     0,     0,
       0,     0,  1313,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   856,     0,   807,   853,   808,   809,   810,   811,   812,
     813,   814,   815,   816,   817,   818,   819,   820,   821,   822,
     823,   824,   825,   826,   827,   828,   829,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   844,   845,   846,   847,   848,   849,   850,   851,   852,
     854,     0,  1396,  1407,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1405,  1398,     0,   909,     0,   894,   895,
     896,   903,   897,   898,   899,   900,   901,   902,   904,   905,
     907,   906,   912,  1400,   874,     0,   859,   860,   861,   867,
     871,   872,   862,   863,   864,   865,   866,   868,   870,   869,
       0,  1370,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   981,     0,   951,
     952,   953,   946,   947,   948,   949,   950,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   945,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,     0,     0,  1390,     0,   942,     0,
     937,   936,   934,   935,   938,   939,   940,     0,     0,     0,
       0,  1392,   931,     0,   922,   923,   924,   928,   929,   925,
     926,   927,  1399,   919,     0,   914,   915,   916,   917,     0,
     891,     0,   877,   878,   879,   884,   889,   881,   882,   883,
     885,   886,   888,   887,   880,     0,     0,     0,     0,     0,
       0,   347,   348,   350,   349,   351,  1353,  1354,     0,     0,
     354,   358,   355,   356,   357,     0,     0,  1361,  1363,     0,
     417,   418,   419,   420,   421,     0,     0,     0,     0,     0,
     551,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     225,     0,     0,     0,     0,   224,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   188,   187,   547,   595,   552,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   470,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1070,     0,    84,     0,     0,     0,   235,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   491,     0,   488,
     228,     0,     0,     0,   513,     0,     0,     0,     0,   507,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   239,     0,     0,  1044,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      94,     0,     0,     0,   260,     0,   261,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   749,     0,   404,     0,
       0,     0,   360,     0,   694,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   161,   166,   163,   171,     0,   184,     0,     0,
       0,     0,   286,   285,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   314,
       0,     0,     0,     0,     0,     0,   376,   481,   382,     0,
       0,     0,     0,     0,     0,     0,  1075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,   103,   125,   130,   127,   135,   137,   142,   139,   147,
     149,   154,   151,   159,     0,   689,   690,   173,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   325,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   546,     0,     0,     0,
       0,     0,     0,   576,     0,     0,     0,   594,     0,     0,
       0,     0,     0,   201,   200,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   185,     0,     0,     0,     0,  1235,  1236,  1237,  1238,
    1234,  1240,  1131,  1136,  1420,     0,  1133,     0,  1132,  1152,
    1153,  1205,  1206,     0,   795,     0,  1241,  1168,  1194,   803,
       0,  1207,  1079,     0,  1082,     0,   180,  1282,  1283,  1284,
    1122,  1116,  1129,  1097,   396,   395,     0,  1292,  1287,  1288,
    1290,  1289,  1291,  1112,  1102,  1060,  1058,     0,  1068,     0,
     715,     0,   713,     0,   233,     0,     0,  1104,  1231,  1232,
    1233,  1161,  1163,  1162,  1164,     0,  1159,  1135,  1134,  1108,
       0,  1418,  1199,  1200,  1154,  1155,  1223,  1225,  1222,  1224,
    1226,  1227,  1169,  1171,  1174,  1172,  1183,  1184,  1170,   484,
       0,     0,   486,   485,  1179,  1181,  1180,  1176,  1177,  1175,
    1217,  1208,     0,     0,  1209,  1415,  1414,  1416,  1417,     0,
    1101,  1214,  1182,  1190,  1189,  1192,  1220,  1219,  1221,  1413,
    1228,  1229,  1230,  1367,   605,   602,     0,     0,   487,   525,
     526,   528,   529,   531,   527,   530,   229,     0,     0,     0,
       0,     0,   512,     0,     0,     0,   504,     0,     0,  1114,
    1113,  1088,  1089,   534,   535,  1052,  1048,     0,     0,   238,
     476,     0,     0,     0,  1042,     0,  1277,  1281,  1280,  1279,
    1278,  1272,  1273,  1247,   720,   721,   230,     0,     0,   717,
       0,   269,     0,   267,     0,     0,   258,   259,     0,   263,
    1121,     0,  1124,     0,   252,   256,  1201,  1202,     0,   746,
       0,     0,   402,   401,     0,   359,   693,     0,   698,     0,
       0,     0,   701,  1096,  1103,  1110,  1111,  1120,  1119,  1128,
    1126,  1098,  1127,   704,   710,     0,   167,   164,   169,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     270,   281,   282,   277,   278,   279,   280,   273,   274,   276,
     275,   283,   753,     0,     0,   718,     0,     0,     0,     0,
     313,   775,     0,  1038,   479,   480,     0,     0,     0,     0,
       0,   380,  1117,  1123,  1099,   407,   406,     0,     0,  1074,
       0,   385,   384,   426,   423,     0,     0,  1218,   767,   755,
       0,  1118,  1410,   762,   759,     0,     0,     0,   131,   128,
     133,   143,   140,   145,   155,   152,   157,   691,  1242,  1243,
    1244,  1245,  1246,  1248,  1249,  1250,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,     0,     0,  1259,  1260,  1261,     0,
       0,     0,  1265,  1266,     0,  1268,  1269,  1270,  1271,  1274,
    1275,  1276,   985,   986,  1130,  1137,  1138,  1151,   537,   536,
    1295,  1296,  1297,  1298,  1299,  1300,  1301,  1302,  1303,     0,
    1305,  1306,  1307,  1308,  1309,  1312,  1314,  1315,  1316,  1317,
    1318,  1329,  1326,  1340,  1341,  1345,  1319,  1322,  1323,  1324,
    1325,  1327,  1328,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,  1338,  1339,  1342,  1343,  1344,  1372,   855,   858,     0,
    1408,  1368,  1397,  1371,  1369,  1401,  1403,  1402,  1404,  1406,
    1388,   908,   911,     0,   873,   876,  1320,  1321,  1373,  1374,
    1375,  1376,  1377,  1378,  1379,  1380,  1381,  1382,  1383,  1384,
    1385,  1386,  1387,   980,   983,  1293,  1294,  1389,   941,   944,
    1393,  1395,  1394,  1391,   930,   933,   918,   921,  1409,   890,
     893,     0,     0,     0,   331,   332,     0,   324,     0,  1438,
    1349,  1348,  1350,  1351,  1352,   346,   345,  1356,  1355,   353,
     352,  1358,  1359,  1360,  1362,   416,   415,     0,     0,   550,
     545,     0,     0,     0,   577,     0,     0,     0,   595,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   186,   198,
     199,   194,   195,   196,   197,   189,   190,   192,   191,   193,
       0,     0,     0,     0,     0,   590,   591,   592,   593,     0,
     596,   554,  1420,     0,  1421,  1423,     0,  1427,  1425,     0,
     798,   806,  1081,     0,   175,   181,     0,     0,     0,   716,
     714,   237,     0,  1165,     0,     0,   482,   483,     0,  1429,
       0,  1433,  1431,     0,   686,     0,   604,   493,   228,   490,
     228,     0,     0,     0,     0,     0,   511,     0,     0,  1050,
     548,   597,   556,     0,   474,   475,     0,     0,  1046,     0,
       0,     0,     0,     0,     0,     0,   255,     0,     0,   743,
       0,     0,   740,     0,   748,     0,     0,     0,   699,     0,
     712,   170,     0,     0,     0,   298,   299,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   308,   297,     0,
     305,     0,   307,   309,     0,   310,     0,     0,     0,     0,
       0,     0,   777,   381,   375,   368,     0,   378,     0,     0,
    1073,     0,   425,     0,   757,   761,     0,     0,   134,   146,
     158,  1439,  1441,  1440,   473,   472,     0,     0,     0,     0,
       0,     0,   913,     0,     0,   327,   323,  1436,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     213,   214,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   223,   212,     0,   220,     0,   222,   226,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   565,   566,   574,   572,   567,
     570,   569,   575,   573,   571,   568,     0,     0,     0,  1424,
    1428,  1426,  1419,   182,  1286,   367,     0,     0,     0,     0,
    1160,  1109,  1430,  1434,  1432,     0,     0,  1173,   229,     0,
       0,     0,   495,     0,     0,     0,     0,   509,   505,     0,
       0,     0,     0,     0,     0,     0,   232,     0,   268,   266,
       0,     0,   262,   249,     0,   251,     0,   750,     0,   696,
       0,   702,   123,     0,     0,     0,     0,     0,     0,   303,
       0,     0,   318,     0,     0,     0,   379,     0,  1076,  1357,
       0,     0,  1262,  1263,  1264,  1267,  1304,     0,   328,     0,
       0,  1437,     0,     0,  1167,     0,     0,   578,     0,     0,
     596,     0,     0,     0,     0,     0,   218,  1147,  1145,  1146,
     589,   583,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1422,     0,   363,     0,     0,
     549,   599,   560,     0,   234,  1166,   684,   685,   687,   228,
     228,   228,     0,     0,   517,     0,   506,     0,     0,   598,
     558,     0,  1045,   231,     0,    98,     0,   265,   312,   744,
       0,     0,   700,   300,   301,     0,     0,     0,   311,  1067,
       0,     0,   317,   377,     0,     0,   109,     0,     0,    90,
       0,     0,   326,  1435,     0,     0,   579,     0,     0,   597,
       0,   215,   216,     0,     0,   227,  1139,  1142,  1144,  1150,
    1141,  1149,   518,   519,   521,   522,   524,   520,   523,  1140,
    1148,  1143,   564,   553,     0,     0,   366,     0,   362,     0,
       0,     0,     0,   499,   496,   500,     0,   515,   510,     0,
       0,     0,     0,   241,     0,    95,    96,   101,     0,   257,
       0,     0,     0,   284,   320,   319,  1077,     0,   106,   107,
     115,   112,   104,     0,    87,    88,    93,     0,     0,     0,
     337,     0,   338,   339,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   584,     0,   365,     0,     0,     0,   374,
       0,     0,   600,   562,     0,   228,     0,   585,     0,     0,
       0,    97,    99,   264,     0,   304,   306,   108,   113,   110,
     118,    89,    91,     0,     0,     0,     0,   329,     0,   340,
       0,     0,   581,     0,   580,   599,     0,   598,   219,   221,
     555,   364,     0,     0,  1071,     0,   373,     0,     0,     0,
       0,     0,   501,   516,   557,     0,     0,   100,   321,   114,
     111,   116,    92,     0,     0,     0,     0,     0,     0,   336,
       0,     0,     0,   371,     0,   372,     0,   587,     0,     0,
       0,   228,   228,   586,     0,   117,     0,     0,     0,     0,
       0,     0,   334,     0,   582,   600,     0,   370,   561,     0,
       0,   497,   502,   559,     0,     0,     0,     0,   330,   335,
     333,   369,   588,     0,     0,     0,     0,   341,     0,   563,
     503,   342,   343,     0,   344
  };

  const short int
  parser::yypgoto_[] =
  {
   -2449, -2449,  2665, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,   199, -2449, -2449, -2449, -2449,  -200,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
    -173, -2449, -2449, -1356, -2449, -2449, -2449,  -194,  -410, -2449,
   -2449,  2183,  1360, -2449, -2449, -2449, -2449,   417, -1370, -2449,
     421,   130, -2449, -2449, -1334, -2449, -2449,  2007,   -90, -2449,
   -2449, -2449,  1098, -2449, -2449, -2449,   -60,   -55, -2449,    31,
   -2449, -2449,  1101, -2449, -2449,  1103, -2449, -2449,   422, -2449,
      58, -2449,   764, -2449, -2449,  -239, -2449, -2449,  1498, -2449,
   -2449,  1375, -2449, -2449,  1290, -2449, -2449,  1104, -2449, -2449,
    -150,  1284,   318, -1018, -1141,  1419,  -683, -2449,  -867, -2449,
   -2449,  2280, -2449, -2449, -2448, -2449,   900,  -572, -2449, -2449,
    2234, -2449, -2189, -2449, -1406, -2449, -2449, -2449,  1221, -2449,
   -2449,  2492, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2374,   193, -2449,  2494, -2449, -2174,   328, -2449,  2495, -2449,
   -2449,  1463,   305, -2449, -2449, -2449, -2449, -2449, -2449,  2167,
   -2449, -2449, -2449, -2449, -2449,  1389, -2449, -2449, -2449, -2449,
   -2449, -2449,  1425, -2449, -2449,  -188, -2449,  1409, -2449, -2449,
   -2449, -2449, -2449, -2449,  1306, -2449,  -246, -2449, -2449, -2449,
   -2449,   -69,  1552, -2449, -2449,  1553, -2449, -2449,  1209, -2449,
   -2449,  1195, -2449, -2449,  1164, -2449, -2449,  1202, -2449, -2449,
    1173, -2449, -2449,  1172, -2449, -2449,  1179, -2449, -2449,  1188,
   -2449, -2449,  1275, -2449,  1356, -2449, -2449, -2449,  2256, -2449,
   -2449,  1466, -2449, -2449,  1547, -2449, -2449, -2449,  2444, -2449,
   -2449, -2449,  1343, -2449,  1572, -2449, -2449,  1483, -2449, -2449,
   -2449,    62, -2449, -2449,  -166,  -152,  -104, -2449,  -156, -2449,
   -2449, -2449,  -110,  -106, -2449, -2449,   270, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449,  -207, -2449, -2449, -2449,
   -2449, -2449, -2449,   -97, -2449,  -139,  -151,   -99,  -138, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449,  -101,   -72, -2449,  -149,  -190,  -118,
     -76, -1697, -2449,  1152,   -74,  -264, -2449, -2449, -2449, -2449,
   -2449,  -204, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449,  -174, -2449, -2449, -2449, -2449, -2449,  -195, -2449, -2449,
     -98, -2449,  -148, -2449, -2449, -2449, -2449,  -186,  -172,   -96,
   -2449, -2449,   -95,   -92, -2449, -2449, -2449,   -87,   -84, -2449,
   -2449,   -44,   -43, -2449, -2449, -2449,   -42,   -39,   -38,   -36,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  -203, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449,  -198,  -193, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449,   -61, -2449, -2449,  -280,  -268,  -261,  -249,  -228,
   -2449, -2449, -2449, -2449, -2449,  -213,  -212,  -170, -2449,  -169,
   -2449, -2449, -2449,  -163,  -161,  -157, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449,  -297, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  -146,
     -11, -2449,  -275,  -143, -2449, -2449, -2449, -2449, -2449, -2449,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449, -2449,  -260,
   -2449, -2449, -2449, -2449, -2449, -2449, -2449,  -227,  -279,  -263,
   -2449, -2449,  -225,  -224,  -219,  -153,  -278,  -131,  -130, -2449,
   -2449, -2449, -2449, -2449, -2449,   -34, -2449, -1095, -1638, -2449,
   -1038, -2449, -1379, -2449, -2449, -2449, -1581,     0
  };

  const short int
  parser::yydefgoto_[] =
  {
      -1,    95,    96,    97,    98,    99,  2159,  2668,   100,  1930,
    2644,   101,  2057,  2056,  2665,   102,   103,   104,   105,   735,
     269,   271,   273,   239,   276,   106,   373,  1775,   107,   108,
    2518,  1742,  2469,  2521,   109,   110,   111,   412,   413,   112,
     598,   599,   644,   645,   113,   634,  2361,  1403,  1404,  1932,
    1933,  1405,  1483,  2396,  1406,   114,   772,   773,   774,   115,
     301,  1677,  1678,  2670,  2837,  2672,  2838,  2751,  2752,  2753,
     116,  1190,  1191,   117,  1199,  1200,   118,   659,  2506,   119,
    2768,  1495,  1496,   120,   793,   382,   121,   383,   384,   122,
     655,   656,   123,   784,   785,   124,  1209,  1210,   125,   795,
     802,   797,  2425,  2426,  1913,  1254,  1842,  1843,  1844,   126,
     562,   563,   564,  1888,  2522,   127,   573,   574,   128,   568,
     569,  2699,  1889,   587,   588,   129,   130,   927,   928,   131,
     132,   133,  1219,   134,  1744,  2497,  2531,  2722,  2711,  2820,
    2484,  2485,   135,   136,   137,  2284,  2285,   138,   139,   140,
     479,   480,  2324,  2325,   141,   275,   834,   142,   660,   661,
     143,   144,   663,   145,   685,   686,   146,   147,   148,   149,
     150,   151,   611,   612,   152,   226,  2360,   227,   153,   243,
    1482,   154,   155,   810,   811,   803,   812,   156,   157,   158,
     330,   331,   332,   159,   354,   355,   160,   981,   982,   161,
    1064,  1065,   162,  1170,  1171,   163,  1046,  1047,   164,  1163,
    1164,   165,  1152,  1153,   166,  1138,  1139,   167,  1097,  1098,
     168,   169,   871,   872,   775,   776,   170,   601,   602,   171,
     589,   590,   172,   397,   398,   173,   174,   405,   406,   175,
     792,  1505,  1506,   176,   361,   362,   177,   580,   581,   178,
     687,   688,   689,   786,   690,   691,   692,   693,   694,   695,
     696,   697,   698,   699,   700,   701,   702,   583,   584,   585,
     386,   788,   813,   703,   704,   647,   387,   790,   648,   705,
     706,   707,   708,   709,   929,   333,   334,   710,   335,   930,
     931,  2486,  2487,  2488,  2489,  2490,  2491,  2286,  2287,  2288,
    2492,  2493,  2494,   932,   336,   337,   493,   494,   711,   712,
     713,  1816,  2314,  1220,   356,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   357,   522,   523,
     364,   714,   525,   526,   650,   715,   716,   338,   339,   365,
     530,   531,   340,   341,   534,   535,   536,   717,   718,   539,
     805,   719,   720,   542,   543,   544,   721,   722,   723,   724,
     342,   343,   344,   345,   346,   347,   348,   358,   888,   889,
     890,   891,   892,   621,   894,   895,   896,   897,   898,   899,
     900,   901,   902,   903,   904,   905,   906,   907,   908,   909,
     910,   911,   912,   913,   914,   915,   916,   917,   622,   918,
     919,   920,   623,   624,   625,   626,   627,   389,   390,   391,
     392,   402,   403,  1140,  1141,   985,   986,   987,   988,   989,
     990,   991,   992,   993,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  1004,  1005,  1114,  1006,  1007,  1008,
    1009,  1010,  1011,  1012,  1013,  1014,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,
    1029,   725,   726,  1192,  1193,  1194,  1195,  1202,  1203,  1204,
     806,  1211,  1212,  1213,  1214,   549,   550,   551,   552,  1048,
    1049,  1117,  1050,  1030,  1119,  1120,  1121,  1122,  1123,  1124,
    1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1051,
    1145,  1146,  1157,  1158,  1159,  1160,  1161,  1052,  1053,  1054,
    1168,  1073,  1055,  1056,  1057,  1058,  2495,  1060,  1061,  1184,
     814,   553,   554,   555,   556,   727,  1762,  2294,  2295,  1757,
    1758,  1853,  1854,  2438,  2220,  2085,  2086,  1255
  };

  const short int
  parser::yytable_[] =
  {
     179,  1369,  1308,   187,  1887,   521,  1201,   410,   411,  1059,
     495,  1071,  1102,   187,   527,  1068,   804,   884,   794,   187,
     592,  1156,  1181,   629,  1103,  1174,   617,  1072,   528,   228,
    1069,  1104,   632,  1936,  1144,  1167,   187,   187,   240,   654,
    1175,   187,   187,  1105,   483,   187,   363,   789,   482,   488,
     187,   187,   187,   187,   270,   272,   274,   646,   277,   769,
     614,   487,   490,  1070,  1106,  1074,  1075,   616,   620,  1937,
     823,  1076,   828,  1176,   833,  1177,  1178,   885,   893,  1107,
    1108,  1179,   496,   921,   187,   798,   684,   399,   922,   984,
     484,   880,   593,   388,   485,   179,   933,  1498,   618,   491,
    2223,   489,   524,   486,   529,   532,  1100,   886,   533,   796,
     934,   777,   613,   537,   353,   791,   538,   401,  2313,  2298,
    1101,   311,  1109,  1110,   497,   873,   498,  -577,   492,  1111,
     875,  1112,   879,   887,   594,  1113,   595,  1077,  1253,  2520,
     619,   658,   874,   876,  1066,   983,  1115,  1180,  1142,  1118,
    1154,  -579,  1165,  1099,  1172,   628,   540,   541,   545,  1078,
    1079,   546,   547,   881,   548,  -581,   557,  2105,  2106,  1182,
    1183,  1938,   307,  1756,   738,  2292,   817,  2292,   408,  1754,
     877,   733,  2714,  2353,   180,  1376,   368,   182,  2110,   778,
     738,  2121,  2290,   407,  2861,   228,   228,   414,  1376,  2639,
     322,   368,   565,   570,   575,   882,  2017,   883,   770,   878,
     739,   368,   597,   600,   603,  2861,  2617,   414,   738,  1308,
     228,  1817,   738,  2772,  2646,  1134,   739,   228,   188,  2365,
     822,  2292,   322,   662,   664,   827,  2580,   368,   368,   732,
    2705,  2156,  1771,   765,   738,   368,   368,   228,  1918,   192,
    2165,   368,   385,  2168,   739,   359,   360,   832,   739,  1443,
     368,   738,   481,   368,  2720,   738,   368,   368,   738,   821,
    2401,   826,  1301,   831,  1839,   835,   838,  1523,  1818,  1067,
     739,  1116,  1527,  1143,  1531,  1155,  1976,  1166,   368,  1173,
    2617,   738,  2058,   738,  2241,  1946,   738,   739,   738,  2216,
    2219,   739,  1851,   241,   739,  1292,  2061,  1218,  1221,  1225,
    1229,  2064,  1259,   194,  1298,  2740,  2788,  2829,  1354,   385,
    1135,   186,  2613,   770,   252,   738,  1378,   739,  1999,   739,
    1411,   201,   739,  2176,   739,  1421,  2296,   211,  1947,  1879,
    1910,  1488,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,
     394,  2177,   242,   191,   237,   238,  2637,  1136,  1418,   245,
     246,   739,   193,   251,  1440,   195,  1283,  1502,   260,   263,
     266,   267,   202,   763,   196,   738,  1508,  2618,  1492,  1493,
    2212,   203,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,  2293,  2213,  1481,   738,   208,  2818,  2441,   212,
    1510,  2354,   288,  2871,  1300,  1863,  2826,  1377,  2862,  2027,
    1880,   739,   414,  2028,   734,  2320,  2018,   213,  1879,  2318,
     322,  1514,  1492,  1493,   214,  1230,  1492,  1493,   771,  2880,
    1518,   739,  1881,  1882,  1883,  1471,  1472,  1473,  1474,  1475,
    1476,  1477,  1478,  1479,  1480,  2122,  2123,  1481,  1840,  1841,
    2291,  2618,  1576,  1683,  2581,   818,   219,  2640,  2813,  1686,
    1231,   400,  2813,   734,  1416,  1492,  1493,   220,   734,  1492,
    1493,  1232,  1492,  1493,   404,   221,  2870,   582,   189,   190,
     591,  2773,  2483,  1233,  1234,  1692,   615,   231,  2029,  1880,
     734,  1429,   734,    33,  1235,  1492,  1493,  1492,  1493,   738,
    1492,  1493,  1492,  1493,  1698,  1884,  2111,  2112,  1911,  1912,
     734,  1881,  1882,  1883,   247,   734,   923,   734,   282,   734,
    2473,  1293,   232,  2509,   787,   734,  2516,  2544,   309,  2316,
    1299,   233,  1444,  1445,  1355,   739,  2770,   657,  2558,   734,
     924,   925,  1379,   771,   734,  2595,  1412,  2779,   734,   734,
     734,  2611,   312,   409,  2297,   234,  2500,  1755, -1461,  1356,
     181,  1357,   565,   183,  2473,   248,  1361,  1362,   570,  1422,
    2473,  1366,  1367,   575,  1419,  1885,   197,   198,  1747,  1035,
    1441,  1750, -1461,  1503,  1884,  2821,  2611,   255,  1673,  2513,
    2227,  2619,  1509,  2038,  2611,  1939, -1461,   308,   600,  1236,
    1237,   603,  2473,   278,  2084,  2473,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,  1511,  2611,   279,  1248,
    1038,  1524,  1525,  1249,  1250,  1251,  1528,  1529,   285,   414,
    2019,  1532,  1533,  2321,   765,   302,  1852,  1515,   303,  1137,
    1045,   304,   328,   329,   926,  2849,  1519,  2228,  2647,   313,
    1307,   310,   228,   577,  1885,  2499,   349,  1420,  2501,  2422,
     662,  2611,  2473,  1427,  1674,  2651,  1675,  1676,  1577,  1684,
     204,   205,  2814,  2815,  2611,  1687,  2828,  2815,   206,   207,
    1494,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    1826,  1693,  1935,  2030,   404,  2406,    33,   415,  2767,   586,
    2844,   935,   936,   937,   938,   939,  1043,   738,   631,   738,
    1699,   738,   215,   216,   945,   946,   947,   576,  1827,  1828,
    1442,   952,  1080,   369,   953,   954,  2474,   328,   329,  2510,
     578,   630,  2517,  2545,   765,   765,  1870,  1871,   633,  1839,
     395,   322,  1673,   739,  2559,   739,   960,   739,   651,   738,
    1187,  2596,   765,    33,   635,  1196,  1197,  2612,  1198,   649,
    1486,  1487,   736,   738,   217,   218,   636,   657,  1872,   737,
    2704,  1035,   740,   352,  1035,   766,  2719,  1031,   637,  2317,
     579,   780,  1507,   741,    33,   739,  2281,  2282,  2283,   370,
     371,   372,  2764,   638,  1185,   742,   743,  1252,  1260,   739,
    2778,  1261,  2625,  2031,  1273,    33,  1479,  1480,  2817,  1522,
    1481,  2825,  1038,  1262,  1526,  1038,  1081,  1263,  1674,  1530,
    1675,  1676,  1264,  2848,  1536,   738,  1537,  1044,  1162,  2437,
     222,   223,  1265,   980,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  2389,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
     639,   739,  1481,  2692,  1452,  1453,  1266,  2854,  2869,  2693,
    2694,  2695,  2696,  2697,  2698,  1267,   640,  1829,  1268,  2597,
    2883,  1269,  1470,  1270,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,  2626,   229,   230,  1271,  1186,  2318,   641,
    1272,   744,   745,  1840,  1841,  1492,  1493,  1274,   746,   747,
     748,   749,   750,   751,   752,   753,   754,   755,  1275,   642,
    1276,   756,  1187,  1188,  1189,   757,   758,   759,   760,   761,
    2169,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
     253,   254,  2519,  1477,  1478,  1479,  1480,  1492,  1493,  1481,
    2201,  2202,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,   643,  1277,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,  1504,  1278,  2391,  1471,  1472,  1473,  1474,  1475,
    1476,  1477,  1478,  1479,  1480,  2584,  1279,  1481,  1280,  1492,
    1493,  1281,   935,   936,   937,   938,   939,   940,   941,  1738,
    1739,   942,   943,  1740,   944,   945,   946,   947,   948,   949,
     950,   951,   952,  1713,  1714,   953,   954,   955,   956,   957,
     958,   959,  2427,  2428,  1282,  2390,  2429,  1285,  1752,  1729,
     351,  1284,   393,  1286,   322,   256,   257,   960,   961,   962,
     963,   964,   965,   966,   967,   968,   969,  1287,   970,   971,
     972,   973,   974,   975,   976,   280,   281,   977,   978,   979,
    1811,  1812,  1813,  2424,  1814,   283,   284,  2464,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1288,   762,
    1740,  1401,  1289,  1402,  1787,  1290,  1805,  1291,  1736,  1737,
    1738,  1739,  1294,   363,  1740,  1811,  1812,  1813,  1295,  1814,
    1849,  1296,   374,  1297,  1858,  1303,   375,   376,   377,   521,
    1205,  1206,  1207,  1208,   495,   289,   290,  1304,   527,  2319,
    2322,   291,   292,  1309,   980,   378,  1936,  1305,   781,   293,
     294,  1311,   528,   295,   296,   297,   298,  1886,   592,   782,
    1866,  1867,  1893,  1306,   399,   388,   378,  1897,   483,   379,
    1310,  2673,   482,   488,  1922,   617,   299,   300,  1312,   353,
    1928,  1313,  1937,  1915,  1314,   487,   490,  2421,  2423,  1315,
    1316,  1317,  1318,  1815,   401,  1319,  1320,  1321,  2691,  1322,
    2700,  2701,  1323,  1324,  1325,  1326,   496,   395,   394,   614,
    2392,   395,  1977,  1978,   484,   646,   616,   620,   485,  1327,
    1328,  1329,  1957,   491,  1960,   489,   524,   486,   529,   532,
     593,  1330,   533,  1331,  1332,   396,   228,   537,  2048,  2041,
     538,  1761,  1763,  2713,   783,  2715,  1333,   618,   497,  1334,
     498,   187,   492,  1335,  1776,  1788,  1789,  1790,  1791,  1792,
     684,   613,  1336,  1337,  1338,   789,  1339,   381,  1340,  1341,
    1342,  1343,   594,  1799,   595,   187,   187,   884,  1344,  1345,
     540,   541,   545,  1346,  1347,   546,   547,  1348,   548,   619,
     557,  2026,  2059,  2060,  1349,  1350,  2062,  2063,  1351,  1352,
    2065,  2066,  1353,  2465,   628,  1360,   798,  1848,   228,  1365,
    2047,  1370,   228,  1371,  1498,  1372,  2407,  1373,  1374,  1375,
    1380,  1383,   777,  1386,   385,   187,  1387,  1059,  1071,  1388,
     796,  1389,  1068,   791,  1390,  1391,  1395,   885,   893,  1392,
    1393,  1398,  1394,   921,  1072,  1102,  1397,  1069,   922,   187,
    1399,   880,  1400,  1407,  2104,  1408,  1409,  1103,  1410,  1201,
     933,  1156,   228,  1181,  1104,  2117,  1174,   886,   228,  1413,
    1144,  1414,  1934,   765,   934,  1167,  1105,  1417,  1425,  1430,
    1070,  1175,  1074,  1075,   228,   873,   481,  1431,  1076,  2822,
     875,  1432,   879,   887,  1433,  1434,   984,  1106,  1961,  1435,
     778,  1436,   874,   876,  1437,  1438,  1439,  2161,   734,  2163,
    2164,   187,  1107,  1108,  1176,  1446,  1177,  1178,   765,   765,
     765,   765,  1179,   881,   765,   765,   765,   765,   765,   765,
     765,   765,   765,   765,   765,   765,   765,   765,   765,  1100,
     877,   765,   765,   765,   765,   765,   765,   765,   765,   765,
     765,   765,   983,  1101,  1077,  1109,  1110,  1447,  1484,  1448,
     187,  1066,  1111,  1449,  1112,   882,  2872,   883,  1113,   878,
    2231,  1450,  2233,  2234,   187,  1507,  1078,  1079,  1485,  1115,
    1451,   187,  1118,  1454,  1142,   187,  1099,  1455,  1180,   187,
    1154,  1456,  1165,  1457,   351,  1172,  1458,  1459,  1491,  1460,
    1461,  1462,  1463,  1464,  2067,  2319,  2250,  2251,  2252,  2253,
    1182,  1183,  2254,  2255,  2256,  2257,  2258,  2259,  2260,  2261,
    2262,  2263,  2264,  2265,  2266,  2267,  1490,  2269,  2270,  2271,
    2272,  2273,  2274,  2275,  2276,  2277,  2278,  2279,   400,   374,
     385,  1465,   228,   375,   376,   377,   424,   425,  1980,  1981,
    1982,  1983,  1466,   228,  1984,  1985,  1986,  1987,  1988,  1989,
    1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,  1998,  1773,
    1499,  2001,  2002,  2003,  2004,  2005,  2006,  2007,  2008,  2009,
    2010,  2011,  2312,   378,  1467,  1468,   379,  1469,  -302,  1500,
    1501,  1512,  1513,  1801,  1803,   228,  1067,   228,   228,  1516,
    1517,  1520,  1521,  1538,  1539,  2512,   187,  2514,  1540,  1541,
    1542,  1543,  1544,  1545,  1116,   582,  1546,  1547,   591,  1143,
    1548,  1549,  1550,  1551,  1552,  1155,  1553,  1166,  1554,  1555,
    1173,   559,   764,   459,  1556,   615,  1557,   461,  1558,  1559,
    1560,  1561,   418,  1876,  1562,  1563,  1564,  1565,  1566,  1358,
    1567,  1570,  1568,  1569,  1571,   395,  1572,  1573,   228,  1574,
     228,   228,   380,  1575,  2237,  2238,  1578,  1907,  1221,  1579,
    1580,  2242,  2243,  1581,  2245,  2246,  2247,  1582,  2249,  1583,
    1584,  1585,  1035,  1586,   381,  1587,  1588,  1589,  2332,  1621,
    1590,  2031,  2335,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,  2349,  1591,  1740,  2466,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,   424,   425,  1740,
    1592,  1593,  1037,  1038,  1594,  2359,  1595,  1596,  1597,  1975,
     654,  1598,  1599,  1600,  1601,  1602,  1369,  1147,  1148,  1149,
    1150,  1151,   787,   368,   430,  2305,  2371,  1603,  1604,  1605,
    1606,   433,  1607,   604,  1608,  1609,   187,  1610,  2369,  2599,
    1611,  1612,    33,   314,   315,   316,   317,   318,   319,   320,
    1613,   368,  1614,   368,  1615,  1616,   414,  1617,  2022,   321,
    1618,  1619,  1620,  1622,  1623,  1624,   322,  1625,  1626,  1627,
     187,  1628,  2037,  1629,  1630,  1631,  1632,  1633,  1634,  2045,
    1636,  1638,  2627,  2050,   459,  1635,  1637,  2055,   461,  1639,
     560,   323,  1640,  1641,  2399,  1642,  1643,  1644,  1645,   605,
     606,  1032,  1646,   394,  1647,  1648,   395,  2408,  2418,  1649,
     561,  2419,  1650,   607,  2420,  1651,  1652,  2411,  1653,  1654,
    1033,  1034,  1655,  1656,  1657,  1658,   368,  2327,  1659,  1661,
     396,  1662,  1660,   559,  1663,  1032,  1664,  1665,  1667,  1666,
    2331,  1669,  1670,  1672,  2334,  1679,  1680,  1681,   575,  1682,
    1668,  1671,  1308,  1694,  1033,  1034,  1685,   368,  2343,  1688,
    1689,  1690,  1691,  1032,   608,   609,  1695,   566,  1696,  2686,
    2687,  1697,  1700,  2690,  1701,  1702,  1703,   414,  1704,  1705,
     765,  1706,  1033,  1034,  1707,  1363,  1741,  1749,   765,  1308,
    1709,   187,  1708,   228,  1710,   324,   325,  1711,   228,  1712,
    1715,  1745,  2467,  1716,  2173,  1717,  1718,  1719,  1720,  2367,
    1721,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,   610,
    1722,  1481,  1751,   326,   327,   368,  1723,  1724,  1725,  1726,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,  2333,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
    1727,  1728,  1740,   765,    33,  -217,  2398,  1743,  2400,  1753,
    1759,  1760,   368,  1765,  1766,  1768,  2769,  1770,  1755,  1777,
    1778,  1035,  1779,  1781,  1036,  1783,  1785,   368,   328,   329,
    1786,  1793,  1794,  1807,  1810,   368,   187,  2769,    33,  1819,
     368,  1796,  1797,   764,  1822,   368,   765,   765,  1824,  1798,
    2351,  1804,   560,  1825,  1836,  1035,  1837,  1838,  2357,  1806,
    1415,  1037,  1038,  1820,  1039,  1040,  1845,  1041,  1042,  1043,
    1846,  1850,   561,  1860,  1044,  2816,  1859,  1852,  1861,   187,
     187,   187,  1045,  1035,   187,  1865,  1036,  1869,  1873,  1877,
    1890,  2816,  1899,  1891,  2306,  1037,  1038,  2468,  1039,  1040,
    1894,  1041,  1042,  1043,  1169,  1895,   567,  1900,  1878,   187,
    1903,  1892,  1896,  1908,  1916,  1898,  1045,   571,  1901,  1904,
    2845,  1917,  1909,  1037,  1038,  1063,  1039,  1040,  2315,  1041,
    1042,  1919,  1920,  2395,  1923,  1368,  1044,  1914,  1924,  1926,
    1927,  1929,  1931,  1941,  1045,  1942,  1943,  1945,  1949,   765,
    2525,  1950,  1953,   764,   764,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,   368,  2534,  1740,  1954,  1955,  1963,  1956,
    1964,   764,  1966,  1958,  1968,  1970,  2416,  2417,  1971,  1972,
    1979,  1481,  2012,  2014,  2550,  2013,  2015,  2016,  2020,  1497,
    2032,  2034,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,  2036,  2040,  2042,  2051,  2068,  2046,  2069,  2564,  2070,
    2071,  2072,  2073,  2565,  2074,  2075,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,  2076,  2077,  2078,    33,  2358,
    2079,  2080,  2083,   314,   315,   316,   317,   318,   319,   320,
     350,  2084,  2092,  2093,  2089,  2591,  2592,   571,   351,   321,
    2096,  2090,  2091,  2094,  2102,  2107,   322,  2109,  2113,  2431,
    2114,  2593,  2115,  2594,  2116,  2337,  2118,  2119,  2120,  2502,
    2124,  2125,  2126,  2503,  2127,  2128,   368,  2131,  2132,  2133,
    2134,   323,   414,  2135,  2136,   368,  2138,  2139,   352,  2140,
    2141,  2142,  2143,  2144,  2211,  2145,   572,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,  2146,   575,  1481,
    2147,  2148,  2149,  2150,  2151,  2152,  2218,  2153,  2154,   414,
    2632,  2633,  2155,  2635,   765,   765,  2649,  2158,   368,  2160,
    2641,   765,  2175,  2162,  2413,  2166,  2167,  2170,  2181,  2183,
    2184,  2187,  2188,   765,   765,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,  2194,  2189,  1740,  2660,   765,
    2661,   765,  2190,  2195,  2664,  2196,  2197,   187,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,    33,  2199,
    1481,  2200,  2203,   368,  2205,   324,   325,  2208,  2221,  2224,
    2207,  2210,  2685,  2214,  2232,   368,  2215,  2226,  2230,  1256,
     368,  2236,  2689,  1740,  2240,  2323,  2280,  2430,  2289,  2582,
    2300,  2344,  2585,   326,   327,  2588,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,  2299,  2741,  2301,  2307,  2329,
    2308,  2345,  2328,  2330,  2352,  2355,   572,  2346,  2350,  2356,
    2364,  2372,  2394,  2365,  2540,  2541,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  2397,  2750,  1740,  2433,
   -1462,  2405,  2410,  2553,  2554,  2434,  1376,  2623,   328,   329,
    2761,  2762,  2435,  2436,  2439,  2442,  2440,  2443, -1461,  2555,
    2446,  2556,  2445,  2470,  1471,  1472,  1473,  1474,  1475,  1476,
    1477,  1478,  1479,  1480,  2444,  2447,  1481,  2645,  2471,  2789,
    2790,  2472,  2000,  2776,   228,  2496,   765,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,   765,   765,  1481,
     368,  -578,  2498,  2292,  2505,  2507,  2515,  2523,  2526,  2528,
    2666,  2666,  2532,  2530,  1713,  1714,  2533,  2669,  2536,  2798,
    2538,  2547,  2549,  2552,  2557,  2561,  2677,  2830,  2831,  2680,
    2268,  2563,  2567,  2572,  2812,  2573,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,  2574,  2578,  2575,  2579,   571,
    2602,  2590,  2601,  2277,  2583,  2587,  2586,  2589,  2603,  2855,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2529,  2615,  2614,
    2624,  2629,  2846,  2630,  2726,  2616,   765,  2631,  2671,  2636,
    2706,  2638,  2643,  2674,  2703,   765,   765,  2340,  2675,  2678,
    2708,  2709,  2710,  2721,  2750,  2739,  2712,  2739,  2745,  -580,
    2707,  2866,  2727,  2746,  2729,  2730,  2754,  2755,  2765,  1746,
    1497,  1748,  2771,  1497,  2782,  2756,  2792,  2657,  2658,  2774,
    2797,  2801,  2775,  2800,  2804,  1767,  2620,  2757,  2811,  2807,
    2758,  2366,  2763,  -582,  2777,  2827,  2840,  1780,  2810,  1782,
    2759,  2890,  2760,  2766,  2824,  2560,  2832,  2851,  2841,  2852,
    2858,  2864,  2865,  2876,  2781,  2780,  2874,  2795,  2875,  2884,
    2847,  1808,  1809,  2885,  2819,  2886,  2833,  2787,  1821,  2375,
    1823,  2888,  2893,  2791,  1830,  1831,  1832,  1833,  1834,  1835,
      33,  2834,  2850,  1497,  2859,  2842,  2853,  2803,  2868,  2806,
     306,  2887,  2376,  2873,  2878,  1862,  1864,  2891,  2892,  1868,
    2667,  1944,  2882,  2889,  2539,  2217,  2728,  2894,  2546,  1489,
    2863,  1382,  2860,  2799,  2225,  2731,  2732,  2548,  2784,  2229,
    1784,  2404,  2035,  1952,  2043,  2835,  2235,  2108,  2338,  1217,
    2839,  2600,  1364,  1224,  2702,  1228,   566,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,  1874,   572,  1481,
    1925,  2628,   764,  1948,  2053,  1764,  1940,  1424,   571,  1973,
    2157,  1769,  2174,  2856,  2857,  2209,  1951,  2171,  2204,  2198,
    2839,  2206,  1359,  2193,  1905,  1795,  2103,  2023,  2039,  1302,
    2239,  1965,     0,  1967,  1774,  1969,     0,  1385,  1902,  2877,
       0,  2879,     0,  1215,     0,     0,     0,   764,   764,   764,
     764,     0,     0,   764,   764,   764,   764,   764,   764,   764,
     764,   764,   764,   764,   764,   764,   764,   764,     0,     0,
     764,   764,   764,   764,   764,   764,   764,   764,   764,   764,
     764,  1381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2024,  2025,     0,     0,  1497,  1216,     0,     0,  2033,
    2373,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,
    1480,     0,     0,  1481,     0,   418,  2052,    33,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,   351,    33,
       0,     0,  1222,     0,     0,     0,   322,     0,     0,     0,
    2081,  2082,     0,     0,  2087,  2088,     0,     0,     0,     0,
       0,  1226,  2095,     0,  2097,  2098,  2099,  2100,  2101,     0,
       0,   323,     0,     0,    33,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,   567,     0,  1740,     0,     0,
     424,   425,  2129,  2130,    33,  1223,     0,     0,     0,     0,
    2137,     0,  2377,   839,     0,     0,     0,   572,     0,     0,
       0,     0,     0,     0,  1227,     0,     0,   430,     0,     0,
       0,     0,     0,     0,   433,     0,   604,     0,     0,   435,
       0,     0,  1497,     0,     0,     0,     0,     0,     0,  2178,
    2179,  2180,   439,  2182,     0,     0,  2185,  2186,     0,     0,
       0,     0,  2191,  2192,     0,     0,     0,   452,     0,     0,
       0,     0,  1497,  1497,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,   324,     0,   459,     0,     0,
    2222,   461,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    2796,  1739,    33,     0,  1740,     0,     0,     0,     0,     0,
       0,     0,     0,   326,   327,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,     0,   608,  1481,     0,
       0,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,     0,     0,     0,     0,     0,   840,   841,
     842,   843,   610,   844,   845,   846,   847,   848,   849,   850,
     851,   852,   853,   854,   855,   856,   857,   858,   859,   860,
     861,   862,   863,   864,   865,   866,   867,     0,     0,  2024,
    2025,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
    1739,  1497,  1497,  1740,     0,     0,     0,     0,     0,     0,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
       0,     0,     0,     0,     0,     0,   416,   417,   418,     0,
     419,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,
    1480,     0,     0,  1481,     0,     0,     0,     0,     0,   764,
       0,   351,   321,     0,     0,     0,     0,   764,     0,   322,
       0,     0,   420,   421,   422,     0,     0,     0,     0,  2363,
       0,     0,     0,     0,     0,     0,     0,   868,   869,   870,
     423,  2378,   359,   360,   323,     0,     0,     0,     0,     0,
       0,   352,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,   424,   425,   426,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,     0,     0,  1481,     0,
       0,     0,     0,     0,     0,     0,     0,   427,   428,   429,
     430,   431,   764,     0,     0,     0,   432,   433,     0,     0,
     434,     0,   435,   436,   437,   438,  1497,     0,  1497,     0,
       0,     0,     0,     0,     0,   439,   440,   441,   442,   443,
     444,   445,   446,     0,     0,   447,   448,   449,   450,   451,
     452,     0,     0,     0,  1962,   764,   764,     0,     0,   453,
     454,   455,   456,   457,   458,     0,     0,     0,   324,   325,
     459,     0,   460,     0,   461,     0,     0,   366,     0,     0,
     462,     0,   463,  1497,  1497,     0,     0,     0,     0,     0,
     464,     0,     0,     0,     0,   465,   326,   327,     0,     0,
     466,     0,     0,     0,     0,     0,     0,     0,     0,   380,
       0,   467,   468,  1471,  1472,  1473,  1474,  1475,  1476,  1477,
    1478,  1479,  1480,     0,     0,  1481,  2379,   469,     0,     0,
       0,   381,     0,     0,     0,     0,  2650,   470,   471,     0,
       0,   472,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   738,   473,     0,     0,     0,     0,     0,   764,     0,
       0,   328,   329,     0,     0,     0,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,     0,   739,     0,  2374,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
     738,  2380,  1481,     0,     0,     0,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,   740,  1497,  1481,     0,
       0,     0,     0,     0,     0,     0,     0,   741,     0,     0,
       0,     0,     0,     0,     0,     0,   739,     0,     0,   742,
     743,     0,     0,     0,     0,     0,     0,     0,     0,    33,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
       0,     0,  1481,     0,     0,   740,     0,     0,     0,   474,
       0,     0,     0,     0,     0,     0,   741,  2448,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,   742,   743,
    1740,     0,     0,   475,   476,  2409,     0,     0,    33,     0,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
       0,     0,  1481,     0,     0,     0,     0,  1497,     0,  1497,
    1384,     0,     0,     0,     0,     0,     0,     0,  2381,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   477,   478,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,   764,   764,   744,   745,     0,     0,     0,
     764,     0,   746,   747,   748,   749,   750,   751,   752,   753,
     754,   755,   764,   764,     0,   756,     0,     0,     0,   757,
     758,   759,   760,   761,     0,     0,     0,     0,   764,     0,
     764,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1497,   744,   745,     0,     0,     0,     0,
       0,   746,   747,   748,   749,   750,   751,   752,   753,   754,
     755,  2382,     0,     0,   756,     0,     0,     0,   757,   758,
     759,   760,   761,    33,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2383,     0,     0,     0,     0,
    2598,  1497,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,     0,     0,  1481,     0,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,   738,     0,     0,     0,
       0,     0,     0,     0,  1497,  2384,     0,     0,     0,     0,
       0,     0,     0,     0,   305,     0,     0,  1396,     0,     0,
       0,     0,     0,     0,     0,     1,     2,     0,     0,     0,
       0,     0,   739,     0,     0,   764,     0,     3,     4,     5,
       6,     7,     0,  2311,     0,     8,   764,   764,     0,     0,
       0,     0,     0,   762,     0,  1401,     0,  1402,     9,    10,
      11,   740,     0,     0,    12,     0,    13,    14,    15,    16,
      17,     0,   741,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    19,     0,   742,   743,     0,     0,     0,     0,
       0,  1497,  1497,  2688,    33,  1497,     0,     0,    20,    21,
      22,     0,   762,     0,  1401,     0,  1402,    23,     0,    24,
      25,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      33,     0,    26,     0,     0,   764,     0,     0,     0,    27,
       0,     0,     0,     0,   764,   764,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,     0,     0,  1481,     0,
       0,     0,    28,    29,    30,    31,     0,     0,    32,     0,
       0,     0,     0,     0,     0,     0,    33,  2385,     0,  1471,
    1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,
      34,  1481,    35,     0,    36,    37,     0,     0,  1497,    38,
     744,   745,     0,    39,    40,    41,     0,   746,   747,   748,
     749,   750,   751,   752,   753,   754,   755,     0,     0,  1497,
     756,     0,     0,     0,   757,   758,   759,   760,   761,    42,
      43,     0,    44,    45,    46,    47,     0,     0,     0,     0,
       0,    48,     0,     0,     0,    49,    50,     0,     0,     0,
       0,     0,     0,    51,     0,    52,     0,  1497,     0,    53,
       0,     0,     0,     0,     0,    54,    55,    56,    57,    58,
      59,    60,     0,  1497,     0,     0,     0,     0,     0,     0,
    1423,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,  1497,     0,     0,     0,     0,     0,     0,     0,
       0,    61,     0,     0,     0,     0,     0,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    62,     0,     0,     0,
       0,  1426,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2386,     0,     0,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,  2387,     0,     0,     0,     1,     2,
       0,     0,     0,     0,     0,     0,     0,     0,   762,     0,
       3,     4,     5,     6,     7,    82,    83,     0,     8,    84,
      85,    86,    87,    88,    89,    90,    91,     0,     0,     0,
       0,     9,    10,    11,    92,     0,     0,    12,    93,    13,
      14,    15,    16,    17,    94,     0,     0,     0,     0,     0,
      18,     0,     0,     0,     0,    19,     0,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
       0,    20,    21,    22,     0,     0,     0,     0,     0,     0,
      23,   738,    24,    25,     0,     0,     0,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,  1481,
       0,     0,     0,     0,     0,    26,     0,     0,     0,     0,
       0,  1230,    27,     0,     0,     0,     0,   739,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,
    1481,     0,     0,     0,     0,    28,    29,    30,    31,     0,
       0,    32,     0,     0,     0,     0,  1231,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,  1232,     0,     0,
       0,     0,     0,    34,     0,    35,     0,    36,    37,  1233,
    1234,     0,    38,     0,     0,     0,    39,    40,    41,    33,
    1235,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
       0,     0,    42,    43,     0,    44,    45,    46,    47,     0,
       0,     0,     0,     0,    48,   738,     0,     0,    49,    50,
       0,     0,     0,     0,     0,     0,    51,     0,    52,     0,
       0,     0,    53,     0,     0,     0,     0,     0,    54,    55,
      56,    57,    58,    59,    60,  1230,     0,     0,     0,     0,
       0,   739,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,     0,     0,     0,     0,     0,  1428,     0,
    1231,     0,     0,     0,    61,  1236,  1237,     0,     0,     0,
       0,  1232,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,
    1246,  1247,  2388,  1233,  1234,  1248,     0,     0,     0,  1249,
    1250,  1251,     0,    33,  1235,     0,     0,     0,     0,    62,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,  2393,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,   738,     0,    82,    83,
       0,     0,    84,    85,    86,    87,    88,    89,    90,    91,
       0,     0,     0,     0,     0,     0,     0,    92,     0,     0,
       0,    93,  1959,     0,     0,     0,  1230,    94,     0,  1236,
    1237,  2508,   739,     0,     0,     0,  1238,  1239,  1240,  1241,
    1242,  1243,  1244,  1245,  1246,  1247,     0,     0,     0,  1248,
       0,     0,     0,  1249,  1250,  1251,     0,     0,     0,     0,
       0,  1231,     0,     0,     0,     0,     0,     0,     0,    33,
       0,     0,  1232,  2449,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,  1233,  1234,  1740,     0,     0,     0,
       0,     0,     0,     0,    33,  1235,     0,     0,     0,     0,
     738,     0,     0,  1252,     0,     0,     0,     0,  2535,     0,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    1230,     0,     0,     0,     0,     0,   739,     0,     0,     0,
       0,     0,     0,     0,    33,  2403,     0,     0,     0,     0,
       0,     0,     0,     0,   738,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1231,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1232,     0,  1740,     0,
       0,     0,     0,     0,  1230,     0,     0,     0,  1233,  1234,
     739,     0,     0,     0,     0,     0,     0,     0,    33,  1235,
    2747,  2748,     0,     0,     0,     0,     0,  1238,  1239,  1240,
    1241,  1242,  1243,  1244,  1245,  1246,  1247,     0,     0,  1231,
    1248,    33,     0,     0,  1249,  1250,  1251,     0,     0,     0,
    1232,     0,     0,     0,     0,     0,     0,  1252,     0,     0,
       0,     0,  1233,  1234,     0,     0,     0,     0,     0,     0,
       0,     0,    33,  1235,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,    33,     0,
       0,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,     0,  1236,  1237,     0,     0,     0,     0,
       0,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,
    1247,     0,     0,     0,  1248,     0,     0,     0,  1249,  1250,
    1251,     0,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,  1256,  1257,     0,     0,  2749,  1236,  1237,
       0,     0,     0,     0,     0,  1238,  1239,  1240,  1241,  1242,
    1243,  1244,  1245,  1246,  1247,     0,     0,   366,  1248,    33,
       0,  2450,  1249,  1250,  1251,  1504,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,    33,     0,  1252,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,     0,   738,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,  1230,
     738,  2793,     0,     0,     0,   739,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,     0,     0,     0,     0,     0,
    1230,     0,     0,     0,  1231,     0,   739,     0,     0,     0,
       0,     0,     0,     0,     0,  1232,     0,     0,     0,     0,
       0,     0,  1252,     0,     0,  2794,     0,  1233,  1234,     0,
       0,     0,     0,     0,     0,  1231,     0,    33,  1235,     0,
       0,     0,     0,     0,     0,     0,  1232,  2524,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1233,  1234,
    1740,     0,     0,     0,     0,     0,     0,     0,    33,  1235,
       0,     0,     0,     0,     0,     0,  1252,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,     0,     0,
       0,     0,     0,  2504,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,  1258,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,     0,     0,  1740,     0,     0,     0,     0,
       0,     0,     0,  1236,  1237,     0,     0,     0,     0,     0,
    1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,  1247,
       0,     0,     0,  1248,     0,     0,     0,  1249,  1250,  1251,
       0,     0,     0,     0,  1236,  1237,     0,     0,     0,     0,
       0,  1238,  1239,  1240,  1241,  1242,  1243,  1244,  1245,  1246,
    1247,     0,     0,     0,  1248,     0,     0,     0,  1249,  1250,
    1251,     0,   184,   185,     0,     0,     0,     0,     0,   416,
       0,   418,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,     0,  1740,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,   420,   421,   422,   665,   666,
       0,     0,     0,     0,     0,     0,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,   667,   800,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   424,   425,   426,     0,
       0,     0,     0,     0,     0,     0,   668,   669,     0,     0,
    2836,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     427,   428,   429,     0,     0,     0,     0,    33,     0,     0,
       0,   639,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,     0,  1740,     0,   808,     0,  2451,     0,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,  1252,  1740,     0,     0,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,     0,   416,  1740,   418,     0,
       0,     0,     0,   459,   672,     0,   673,   461,   674,   675,
       0,     0,  1252,     0,     0,   463,     0,     0,     0,     0,
       0,     0,     0,   464,     0,   395,     0,     0,     0,     0,
       0,   676,   420,   421,   422,   665,   666,     0,     0,   677,
       0,   678,   380,     0,     0,     0,   366,     0,   679,   396,
     680,     0,     0,     0,     0,  -498,     0,   681,   682,   683,
       0,     0,   667,     0,   381,     0,     0,     0,     0,     0,
     470,   471,     0,   424,   425,   426,   801,     0,   809,     0,
       0,     0,     0,   668,   669,     0,     0,     0,     0,     0,
       0,   416,     0,   418,     0,     0,     0,   427,   428,   429,
       0,     0,     0,     0,   670,     0,     0,     0,   639,  1730,
    1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,
       0,  1740,     0,   671,     0,     0,     0,   420,   421,   422,
     665,   666,     0,     0,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,     0,     0,   667,   800,     0,
     459,   672,     0,   673,   461,   674,   675,  2452,   424,   425,
     426,     0,   463,    33,     0,     0,     0,     0,   668,   669,
     464,     0,   395,     0,     0,  2453,     0,     0,   676,     0,
       0,     0,   427,   428,   429,     0,   677,    33,   678,   380,
    2454,     0,   474,   639,     0,   679,   396,   680,     0,     0,
       0,     0,     0,     0,   681,   682,   683,     0,     0,     0,
       0,   381,     0,     0,     0,     0,     0,   470,   471,     0,
       0,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
    1739,     0,   416,  1740,   418,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,   459,   672,  1740,   673,   461,
     674,   675,  2511,     0,     0,     0,     0,   463,     0,     0,
       0,     0,   366,     0,     0,   464,     0,   395,   420,   421,
     422,   665,   666,   676,     0,     0,     0,     0,     0,     0,
       0,   677,     0,   678,   380,     0,   366,     0,     0,     0,
     679,   396,   680,     0,     0,    33,     0,     0,   667,   681,
     682,   683,     0,     0,     0,     0,   381,     0,     0,   424,
     425,   426,   470,   471,  2455,    33,     0,     0,   801,   668,
     669,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   427,   428,   429,    33,     0,     0,     0,
       0,     0,     0,     0,   639,     0,     0,     0,   435,   474,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      33,     0,     0,     0,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,   366,     0,   459,   672,     0,   673,
     461,   674,   675,     0,     0,     0,     0,     0,   463,     0,
       0,     0,   224,     0,     0,     0,   464,     0,   395,     0,
       0,     0,     0,     0,   676,     0,     0,     0,     0,     0,
       0,     0,   677,     0,   678,   380,  2456,     0,     0,     0,
       0,   679,   396,   680,   474,     0,     0,     0,  2336,     0,
     681,   682,   683,     0,     0,     0,     0,   381,     0,     0,
       0,     0,     0,   470,   471,    33,     0,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,  2543,  1740,
       0,     0,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,  2569,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    33,     0,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    33,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,     0,     0,  1740,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,  2655,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,
    1481,     0,    33,     0,     0,   474,  2656,  1471,  1472,  1473,
    1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,  1481,
    2576,    33,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,     0,  1740,     0,     0,     0,   199,   200,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,     0,     0,     0,     0,     0,     0,   209,
     210,     0,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2457,     0,   225,     0,     0,     0,     0,     0,
       0,    33,     0,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,     0,     0,  1740,     0,     0,     0,     0,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,     0,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      33,     0,     0,     0,     0,     0,     0,     0,     0,  2458,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,     0,     0,     0,     0,     0,   235,   236,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2459,     0,     0,
       0,     0,     0,     0,     0,   249,   250,     0,     0,     0,
       0,     0,     0,     0,     0,  2460,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,   258,   259,  1740,     0,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,     0,     0,
       0,     0,     0,     0,     0,   261,   262,     0,  2461,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,   264,   265,     0,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,   224,    33,  2683,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,     0,     0,  2462,   224,    33,     0,     0,
       0,     0,     0,     0,     0,   286,   287,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    33,     0,     0,     0,
       0,     0,     0,     0,     0,   244,     0,     0,     0,     0,
       0,     0,     0,     0,   652,     0,  1471,  1472,  1473,  1474,
    1475,  1476,  1477,  1478,  1479,  1480,     0,     0,  1481,     0,
       0,     0,     0,   652,  2684,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,     0,     0,  1740,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   366,     0,     0,
      33,  2463,     0,     0,   268,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,     0,   366,  1740,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,
    1481,     0,     0,     0,     0,   366,     0,     0,     0,     0,
       0,     0,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    33,     0,     0,     0,     0,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    33,  2716,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,     0,     0,  1740,     0,     0,
       0,     0,    33,     0,     0,     0,     0,     0,   653,     0,
       0,  2537,     0,     0,     0,     0,     0,     0,     0,     0,
     366,     0,     0,     0,     0,     0,     0,  2362,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    33,     0,     0,
       0,   367,     0,     0,     0,     0,     0,     0,     0,     0,
    2566,     0,     0,     0,     0,     0,    33,     0,     0,     0,
     558,     0,     0,  2570,     0,     0,     0,     0,     0,     0,
       0,     0,   366,     0,     0,     0,     0,     0,     0,   596,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
       0,   730,  1481,     0,     0,     0,     0,     0,     0,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    33,  1471,
    1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,
       0,  1481,     0,     0,     0,     0,   366,     0,     0,     0,
       0,     0,     0,  1772,  1471,  1472,  1473,  1474,  1475,  1476,
    1477,  1478,  1479,  1480,     0,   366,  1481,     0,     0,     0,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    33,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
       0,     0,  1481,     0,     0,     0,     0,   366,     0,     0,
       0,     0,     0,     0,   728,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,   729,     0,     0,     0,
       0,     0,     0,     0,     0,  2571,     0,     0,   366,     0,
       0,     0,     0,     0,     0,   731,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    33,     0,     0,     0,     0,
       0,     0,     0,     0,  2577,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,     0,     0,
     767,     0,     0,     0,     0,     0,     0,     0,     0,  2653,
       0,     0,   366,     0,     0,     0,     0,     0,     0,   768,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,   366,  1740,     0,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,    33,     0,
       0,     0,     0,     0,     0,  2654,     0,     0,     0,     0,
       0,     0,     0,     0,   366,     0,     0,     0,     0,     0,
       0,   779,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,   819,  1740,     0,     0,     0,     0,     0,
       0,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    33,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,     0,     0,     0,     0,   824,     0,     0,
       0,     0,   799,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,     0,   807,     0,     0,     0,
       0,     0,     0,     0,     0,  2663,     0,     0,   829,     0,
       0,     0,     0,     0,     0,   815,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,     0,     0,     0,   816,     0,
       0,     0,     0,     0,     0,     0,     0,  2681,     0,     0,
     836,     0,     0,     0,     0,     0,     0,   820,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,   366,
    1481,     0,     0,     0,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    33,     0,     0,     0,
       0,     0,     0,     0,     0,  2682,     0,     0,     0,     0,
       0,     0,     0,     0,  1534,     0,     0,     0,     0,     0,
       0,   825,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,     0,   366,  1481,     0,     0,     0,     0,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    33,  1471,  1472,
    1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,     0,     0,
    1481,     0,     0,     0,     0,  2303,     0,     0,     0,     0,
       0,     0,   830,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,   837,     0,     0,     0,     0,     0,
       0,     0,     0,  2733,     0,     0,   366,     0,     0,     0,
       0,     0,     0,  1062,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,     0,     0,  1535,     0,
       0,     0,     0,     0,     0,     0,     0,  2785,     0,     0,
     366,     0,     0,     0,     0,     0,     0,  2302,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,   366,
    1740,     0,     0,     0,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,     0,    33,     0,     0,     0,
       0,     0,     0,  2786,     0,     0,     0,     0,     0,     0,
       0,     0,   366,     0,     0,     0,     0,     0,     0,  2304,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,   366,  1740,     0,     0,     0,     0,     0,     0,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    33,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,     0,
    1740,     0,     0,     0,     0,   366,     0,     0,     0,     0,
    2309,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,     0,     0,  2310,     0,     0,     0,     0,     0,
       0,     0,     0,  2808,     0,     0,   366,     0,     0,     0,
       0,     0,     0,  2326,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,  2339,     0,     0,     0,
       0,     0,     0,     0,     0,  2809,     0,     0,   366,     0,
       0,     0,     0,     0,     0,  2370,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,     0,   366,  1740,     0,
       0,     0,     0,     0,     0,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    33,     0,     0,     0,     0,     0,
       0,     0,     0,  2843,     0,     0,     0,     0,     0,     0,
       0,     0,   366,    33,     0,     0,     0,     0,     0,  2402,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,   366,  1740,     0,     0,     0,     0,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2724,    33,     0,     0,     0,     0,     0,
    2412,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    33,     0,
       0,     0,  2414,     0,     0,     0,     0,     0,     0,     0,
       0,  2867,     0,     0,  2737,     0,     0,    33,     0,     0,
       0,  2415,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      33,     0,     0,     0,     0,     0,  2432,     0,     0,     0,
       0,     0,     0,     0,     0,  2881,     0,     0,  2737,    33,
       0,     0,     0,     0,     0,  2659,  2347,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,  2743,     0,  1740,
       0,     0,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,     0,     0,    33,     0,     0,     0,  2725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,  1800,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    33,     0,     0,     0,  2738,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,  1847,  1802,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,     0,     0,    33,     0,
       0,     0,  2742,     0,     0,     0,     0,     0,     0,     0,
    2348,     0,     0,     0,     0,     0,     0,  1921,    33,     0,
       0,  2744,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,     0,  1740,     0,     0,     0,     0,     0,
    1875,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    33,
       0,     0,     0,  1906,  1730,  1731,  1732,  1733,  1734,  1735,
    1736,  1737,  1738,  1739,     0,     0,  1740,     0,     0,     0,
       0,     0,  1974,     0,     0,     0,     0,  2340,  2341,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   224,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      33,     0,     0,     0,     0,     0,  2021,     0,     0,     0,
       0,     0,  2620,  2621,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2044,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,  2248,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    33,     0,     0,     0,     0,
       0,     0,     0,     0,  2679,  2368,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2049,     0,     0,
       0,     0,     0,  2805,     0,     0,     0,    33,     0,     0,
       0,     0,     0,     0,     0,     0,  2054,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2527,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,  2172,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,     0,     0,  1481,     0,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,     0,     0,  1740,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,  2342,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,     0,  1740,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,     0,     0,  1740,     0,     0,     0,     0,
       0,     0,     0,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,  2622,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,     0,  1740,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1479,  1480,     0,     0,  1481,  2542,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,     0,     0,  1740,  2551,
    1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,
       0,     0,  1740,  1730,  1731,  1732,  1733,  1734,  1735,  1736,
    1737,  1738,  1739,     0,     0,  1740,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,     0,     0,  1740,     0,
    2562,     0,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,
    1738,  1739,     0,  2568,  1740,  1730,  1731,  1732,  1733,  1734,
    1735,  1736,  1737,  1738,  1739,     0,  2634,  1740,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,     0,
    1740,  1730,  1731,  1732,  1733,  1734,  1735,  1736,  1737,  1738,
    1739,     0,     0,  1740,  1471,  1472,  1473,  1474,  1475,  1476,
    1477,  1478,  1479,  1480,     0,  2642,  1481,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,     0,     0,  1740,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    33,   224,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  2648,     0,     0,     0,     0,
       0,     0,     0,    33,     0,     0,     0,   224,     0,  2652,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    33,  2662,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  2717,     0,     0,     0,
       0,    33,     0,     0,     0,     0,     0,     0,     0,  2718,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      33,     0,     0,     0,     0,  2723,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2734,     0,
       0,     0,     0,   366,     0,     0,     0,     0,     0,     0,
       0,  2735,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2736,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2783,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2823,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    1855,  1856,  1857,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,  2244,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,  2676,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,  2802
  };

  const short int
  parser::yycheck_[] =
  {
       0,   573,   412,     3,  1360,   200,   303,   195,   196,   287,
     200,   290,   292,    13,   200,   290,   262,   281,   257,    19,
     210,   296,   300,   217,   292,   300,   216,   290,   200,    29,
     290,   292,   220,  1403,   294,   298,    36,    37,    38,   227,
     300,    41,    42,   292,   200,    45,   185,   254,   200,   200,
      50,    51,    52,    53,    54,    55,    56,   223,    58,   247,
     216,   200,   200,   290,   292,   290,   290,   216,   216,  1403,
     270,   290,   272,   300,   274,   300,   300,   281,   281,   292,
     292,   300,   200,   281,    84,   259,   236,   191,   281,   284,
     200,   281,   210,   190,   200,    95,   282,   780,   216,   200,
    1681,   200,   200,   200,   200,   200,   292,   281,   200,   259,
     282,   250,   216,   200,   183,   254,   200,   191,  1815,  1757,
     292,    51,   292,   292,   200,   281,   200,    51,   200,   292,
     281,   292,   281,   281,   210,   292,   210,   290,   311,  2328,
     216,   231,   281,   281,   290,   284,   292,   300,   294,   292,
     296,    51,   298,   292,   300,   216,   200,   200,   200,   290,
     290,   200,   200,   281,   200,    51,   200,  1573,  1574,   300,
     300,    51,    51,  1268,    64,   100,   124,   100,   100,   100,
     281,   243,  2630,   261,   100,   268,   186,   100,   100,   250,
      64,   162,   110,   193,   261,   195,   196,   197,   268,   110,
      36,   201,   202,   203,   204,   281,    51,   281,    31,   281,
     100,   211,   212,   213,   214,   261,   100,   217,    64,   629,
     220,  1316,    64,   110,    51,    43,   100,   227,   476,   189,
     243,   100,    36,   233,   234,   243,   261,   237,   238,   239,
    2614,  1620,  1280,   243,    64,   245,   246,   247,  1389,   475,
    1629,   251,   190,  1632,   100,    59,    60,   243,   100,   243,
     260,    64,   200,   263,  2638,    64,   266,   267,    64,   269,
     230,   271,    49,   273,    94,   275,   276,   243,  1316,   290,
     100,   292,   243,   294,   243,   296,   243,   298,   288,   300,
     100,    64,   243,    64,  1700,   112,    64,   100,    64,    49,
    1679,   100,  1340,    51,   100,   261,   243,   307,   308,   309,
     310,   243,   312,   100,   261,   243,   243,   243,   261,   257,
     138,     3,  2496,    31,    51,    64,   261,   100,  1469,   100,
     261,    13,   100,   349,   100,    49,   261,    19,   155,     8,
     100,    49,    71,    72,    73,    74,    75,    76,    77,    78,
     186,   367,   100,   476,    36,    37,  2530,   175,   261,    41,
      42,   100,   476,    45,   261,   476,   366,   261,    50,    51,
      52,    53,   475,   243,   476,    64,   261,   261,   268,   269,
     415,   475,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   261,   428,   274,    64,   476,  2771,   481,   476,
     261,   479,    84,  2851,   404,    94,  2780,   477,   475,   475,
      79,   100,   412,   479,   476,   261,   261,   475,     8,   261,
      36,   261,   268,   269,   475,    94,   268,   269,   251,   475,
     261,   100,   101,   102,   103,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   416,   417,   274,   268,   269,
     368,   261,   261,   261,   479,   403,   476,   368,   261,   261,
     129,   191,   261,   476,   652,   268,   269,   476,   476,   268,
     269,   140,   268,   269,   251,   476,  2850,   207,   475,   476,
     210,   368,   211,   152,   153,   261,   216,   475,   261,    79,
     476,   664,   476,   162,   163,   268,   269,   268,   269,    64,
     268,   269,   268,   269,   261,   174,   418,   419,   268,   269,
     476,   101,   102,   103,   476,   476,    37,   476,   476,   476,
     261,   477,   475,   261,   254,   476,   261,   261,    51,    94,
     477,   475,   732,   733,   477,   100,  2710,   251,   261,   476,
      61,    62,   477,   251,   476,   261,   477,  2721,   476,   476,
     476,   261,   482,   475,   479,   475,   479,   478,   482,   559,
     476,   561,   562,   476,   261,   475,   566,   567,   568,   659,
     261,   571,   572,   573,   477,   244,   475,   476,  1261,   397,
     477,  1264,   482,   477,   174,  2774,   261,   475,   338,   479,
    1685,   475,   477,    49,   261,   475,   482,   476,   598,   268,
     269,   601,   261,   475,   478,   261,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   477,   261,   475,   288,
     438,   821,   822,   292,   293,   294,   826,   827,   476,   629,
     475,   831,   832,   479,   634,   476,   478,   477,   476,   457,
     458,   476,   258,   259,   165,  2819,   477,  1685,   475,   475,
      49,    51,   652,    92,   244,  2293,   475,   657,  2296,   479,
     660,   261,   261,   663,   414,   475,   416,   417,   477,   477,
     475,   476,   475,   476,   261,   477,   475,   476,   475,   476,
     476,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      38,   477,    49,   476,   251,   476,   162,    22,   476,    65,
     476,   327,   328,   329,   330,   331,   445,    64,    58,    64,
     477,    64,   475,   476,   340,   341,   342,    10,    66,    67,
     730,   347,   348,   185,   350,   351,   477,   258,   259,   477,
     179,    22,   477,   477,   744,   745,    34,    35,   126,    94,
     189,    36,   338,   100,   477,   100,   372,   100,   476,    64,
     421,   477,   762,   162,     9,   426,   427,   477,   429,   128,
     770,   771,   100,    64,   475,   476,    21,   251,    66,   475,
     477,   397,   129,    68,   397,   189,   477,   404,    33,    94,
     229,   478,   792,   140,   162,   100,    97,    98,    99,   251,
     252,   253,   477,    48,   475,   152,   153,   476,    51,   100,
     477,    51,  2509,  1496,   261,   162,   270,   271,   477,   819,
     274,   477,   438,    51,   824,   438,   442,    51,   414,   829,
     416,   417,    51,   477,   834,    64,   836,   450,   451,  2218,
     475,   476,    51,   459,   460,   461,   462,   463,   464,   465,
     466,   467,   468,   469,   470,   471,   472,   473,   474,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     115,   100,   274,   351,   744,   745,    51,   477,   477,   357,
     358,   359,   360,   361,   362,    51,   131,   225,    51,  2470,
     477,    51,   762,    51,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   204,   475,   476,    51,   396,   261,   164,
      51,   268,   269,   268,   269,   268,   269,   477,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,    51,   184,
      51,   288,   421,   422,   423,   292,   293,   294,   295,   296,
    1633,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     475,   476,  2328,   268,   269,   270,   271,   268,   269,   274,
    1663,  1664,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   246,    51,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   478,   261,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,  2441,   477,   274,    51,   268,
     269,   477,   327,   328,   329,   330,   331,   332,   333,   270,
     271,   336,   337,   274,   339,   340,   341,   342,   343,   344,
     345,   346,   347,  1236,  1237,   350,   351,   352,   353,   354,
     355,   356,  2090,  2091,   261,   477,  2094,    51,  1266,  1252,
      28,   477,    30,    51,    36,   475,   476,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,    51,   383,   384,
     385,   386,   387,   388,   389,   475,   476,   392,   393,   394,
     363,   364,   365,   481,   367,   475,   476,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    51,   476,
     274,   478,    51,   480,    47,    51,  1309,    51,   268,   269,
     270,   271,    51,  1282,   274,   363,   364,   365,    51,   367,
    1338,    51,    83,    51,  1342,   261,    87,    88,    89,  1354,
     431,   432,   433,   434,  1354,   475,   476,   475,  1354,  1852,
    1853,   475,   476,    51,   459,   127,  2546,   477,   130,   475,
     476,    51,  1354,   475,   476,   475,   476,  1360,  1378,   141,
      66,    67,  1365,   477,  1298,  1292,   127,  1370,  1354,   130,
     477,  2580,  1354,  1354,  1392,  1395,   475,   476,    51,  1278,
    1398,    51,  2546,  1386,    51,  1354,  1354,  2084,  2085,    51,
      51,    51,    51,   476,  1298,    51,    51,    51,  2607,    51,
    2609,  2610,    51,    51,    51,    51,  1354,   189,   186,  1395,
     477,   189,  1442,  1443,  1354,  1411,  1395,  1395,  1354,    51,
      51,    51,  1425,  1354,  1427,  1354,  1354,  1354,  1354,  1354,
    1378,    51,  1354,    51,    51,   213,  1266,  1354,  1514,  1508,
    1354,  1271,  1272,  2629,   226,  2631,    51,  1395,  1354,    51,
    1354,  1281,  1354,    51,  1284,   198,   199,   200,   201,   202,
    1440,  1395,    51,    51,    51,  1502,    51,   228,    51,    51,
      51,    51,  1378,  1303,  1378,  1305,  1306,  1571,    51,    51,
    1354,  1354,  1354,    51,    51,  1354,  1354,    51,  1354,  1395,
    1354,  1494,  1522,  1523,    51,    51,  1526,  1527,    51,    51,
    1530,  1531,    51,   477,  1395,   261,  1510,  1337,  1338,   261,
    1513,   261,  1342,   477,  2027,    51,  2029,    51,   477,   261,
     477,   476,  1491,   261,  1292,  1355,    51,  1635,  1637,    51,
    1510,    51,  1637,  1502,    51,    51,   261,  1571,  1571,    51,
      51,    51,   477,  1571,  1637,  1655,   477,  1637,  1571,  1379,
     477,  1571,    51,    51,  1572,    51,    51,  1655,    51,  1686,
    1576,  1666,  1392,  1671,  1655,  1583,  1671,  1571,  1398,    51,
    1660,   477,  1402,  1403,  1576,  1668,  1655,   476,   476,    51,
    1637,  1671,  1637,  1637,  1414,  1571,  1354,    51,  1637,  2775,
    1571,    51,  1571,  1571,    51,    51,  1621,  1655,  1428,    51,
    1491,    51,  1571,  1571,    51,    51,    51,  1625,   476,  1627,
    1628,  1441,  1655,  1655,  1671,   260,  1671,  1671,  1448,  1449,
    1450,  1451,  1671,  1571,  1454,  1455,  1456,  1457,  1458,  1459,
    1460,  1461,  1462,  1463,  1464,  1465,  1466,  1467,  1468,  1655,
    1571,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,
    1480,  1481,  1621,  1655,  1637,  1655,  1655,   475,    51,   476,
    1490,  1637,  1655,   476,  1655,  1571,  2852,  1571,  1655,  1571,
    1688,   476,  1690,  1691,  1504,  1505,  1637,  1637,   477,  1655,
     476,  1511,  1655,   476,  1660,  1515,  1655,   476,  1671,  1519,
    1666,   476,  1668,   476,    28,  1671,   476,   476,   261,   476,
     476,   476,   476,   476,  1534,  2218,  1709,  1710,  1711,  1712,
    1671,  1671,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,
    1723,  1724,  1725,  1726,  1727,  1728,   477,  1730,  1731,  1732,
    1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1298,    83,
    1508,   476,  1572,    87,    88,    89,    80,    81,  1448,  1449,
    1450,  1451,   476,  1583,  1454,  1455,  1456,  1457,  1458,  1459,
    1460,  1461,  1462,  1463,  1464,  1465,  1466,  1467,  1468,  1281,
      51,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,
    1480,  1481,  1806,   127,   476,   476,   130,   476,   476,    51,
      51,    51,    51,  1305,  1306,  1625,  1637,  1627,  1628,    51,
      51,    51,    51,    51,    51,  2318,  1636,  2320,    51,    51,
      51,    51,    51,    51,  1655,  1375,    51,    51,  1378,  1660,
      51,    51,    51,    51,    51,  1666,    51,  1668,    51,    51,
    1671,    31,   243,   167,    51,  1395,    51,   171,    51,    51,
      51,    51,     5,  1355,    51,    51,    51,    51,    51,    49,
      51,   477,    51,    51,   261,   189,    51,    51,  1688,    51,
    1690,  1691,   206,    51,  1694,  1695,    51,  1379,  1698,    51,
      51,  1701,  1702,    51,  1704,  1705,  1706,    51,  1708,    51,
      51,    51,   397,    51,   228,    51,    51,    51,  1891,   261,
      51,  2404,  1895,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,  1927,    51,   274,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    80,    81,   274,
      51,    51,   437,   438,    51,  1943,    51,    51,    51,  1441,
    1948,    51,    51,    51,    51,    51,  2338,   452,   453,   454,
     455,   456,  1502,  1773,   107,  1775,  1976,    51,    51,    51,
      51,   114,    51,   116,    51,    51,  1786,    51,  1961,  2472,
      51,    51,   162,    13,    14,    15,    16,    17,    18,    19,
      51,  1801,    51,  1803,    51,    51,  1806,    51,  1490,    29,
      51,    51,    51,   477,    51,    51,    36,    51,    51,    51,
    1820,    51,  1504,    51,    51,    51,    51,    51,    51,  1511,
     477,   477,  2515,  1515,   167,   261,   261,  1519,   171,    51,
     210,    61,    51,    51,  2017,    51,    51,    51,    51,   182,
     183,   217,    51,   186,    51,    51,   189,  2030,  2058,    51,
     230,  2061,    51,   196,  2064,    51,    51,  2040,    51,    51,
     236,   237,   261,   477,    51,    51,  1876,  1877,    51,   477,
     213,    51,   261,    31,    51,   217,    51,    51,   477,   261,
    1890,   477,    51,   477,  1894,    51,    51,    51,  1898,    51,
     261,   261,  2312,   476,   236,   237,    51,  1907,  1908,    51,
      51,    51,    51,   217,   247,   248,   476,    31,   475,  2602,
    2603,   482,    51,  2606,   476,   476,   475,  1927,   482,   476,
    1930,   476,   236,   237,   475,    49,   475,   100,  1938,  2349,
     476,  1941,   482,  1943,   476,   165,   166,   476,  1948,   476,
     476,   482,   477,   476,  1636,   476,   476,   476,   476,  1959,
     476,   264,   265,   266,   267,   268,   269,   270,   271,   302,
     476,   274,   100,   193,   194,  1975,   476,   476,   476,   476,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     476,   476,   274,  2013,   162,   476,  2016,   476,  2018,   100,
     100,   100,  2022,   100,   100,   100,  2709,   100,   478,   100,
     100,   397,   100,   100,   400,   100,   475,  2037,   258,   259,
     476,   100,   100,   100,   100,  2045,  2046,  2730,   162,   100,
    2050,   475,   475,   634,   100,  2055,  2056,  2057,   100,   475,
    1930,   475,   210,   100,   100,   397,   100,   100,  1938,   475,
     651,   437,   438,   476,   440,   441,   100,   443,   444,   445,
     100,   100,   230,   100,   450,  2768,   476,   478,   100,  2089,
    2090,  2091,   458,   397,  2094,   100,   400,   100,   100,   261,
     261,  2784,   100,   261,  1786,   437,   438,  2280,   440,   441,
     261,   443,   444,   445,   446,   261,   230,   100,   475,  2119,
     100,   475,   475,   482,   100,   475,   458,    31,   475,   475,
    2813,   100,   475,   437,   438,   439,   440,   441,  1820,   443,
     444,   100,   100,  2013,   100,    49,   450,   475,   475,   475,
     475,   475,   162,   476,   458,   100,   476,   475,   477,  2159,
    2333,   476,   475,   744,   745,   264,   265,   266,   267,   268,
     269,   270,   271,  2173,  2347,   274,   475,   475,   100,   475,
     100,   762,   100,   475,   100,   100,  2056,  2057,   100,   100,
      51,   274,   475,   100,  2367,   476,   475,   261,   475,   780,
     100,   100,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   475,    51,   475,   100,   100,   476,   100,  2401,   100,
     100,   100,   100,  2406,   100,   100,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   100,   100,   100,   162,  1941,
     100,   100,   100,    13,    14,    15,    16,    17,    18,    19,
      20,   478,   100,   100,   476,  2448,  2449,    31,    28,    29,
     100,   476,   476,   476,   475,   100,    36,   475,   100,  2159,
     100,  2464,   100,  2466,   100,    49,   100,   476,   100,  2299,
     100,   100,   100,  2303,   100,   100,  2306,   100,   100,   100,
     100,    61,  2312,   100,   100,  2315,   100,   100,    68,   100,
     100,   100,   100,   100,   413,   100,   230,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   100,  2338,   274,
     100,   100,   100,   100,   100,   100,   478,   100,   100,  2349,
    2523,  2524,   100,  2526,  2354,  2355,  2544,   475,  2358,   100,
    2533,  2361,   475,   100,  2046,   100,   100,   100,   100,   100,
     100,   100,   100,  2373,  2374,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   475,   100,   274,  2561,  2389,
    2563,  2391,   100,   100,  2567,   100,   100,  2397,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   162,   475,
     274,   100,   100,  2413,   475,   165,   166,   100,   100,   100,
     475,   475,  2595,   475,   100,  2425,   475,   475,   475,   109,
    2430,   475,  2605,   274,   475,   204,   476,  2119,   476,  2439,
     475,   100,  2442,   193,   194,  2445,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   481,  2666,   475,   189,   475,
     477,   100,   261,   261,    51,    51,   230,   477,   477,   475,
     477,   204,   477,   189,  2354,  2355,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   477,  2670,   274,   100,
     274,   475,   475,  2373,  2374,   100,   268,  2507,   258,   259,
    2683,  2684,   475,   475,   261,   261,   477,   477,   482,  2389,
     477,  2391,   261,    51,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   482,   482,   274,  2537,    51,  2739,
    2740,    51,   477,  2716,  2544,   476,  2546,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,  2557,  2558,   274,
    2560,    51,   481,   100,   100,   482,   261,   261,   261,   475,
    2570,  2571,   482,   476,  2747,  2748,    51,  2577,   475,  2752,
     204,   477,   475,   477,   476,    51,  2586,  2787,  2788,  2589,
     477,    51,    51,   477,  2767,   477,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   477,   261,   477,   475,    31,
      51,   110,   475,  2796,   482,   368,   482,   482,    51,  2829,
      51,    51,    51,    51,    51,    51,    51,    49,   100,   476,
     475,   261,  2815,   261,  2644,   481,  2646,   261,   413,   475,
     100,   476,   475,   477,   475,  2655,  2656,   109,   477,   477,
     100,   250,   476,   476,  2837,  2665,   482,  2667,  2668,    51,
     481,  2844,   243,   243,   475,   250,   100,   413,   100,  1260,
    1261,  1262,   476,  1264,   243,   482,   243,  2557,  2558,   261,
      51,   100,   261,   261,   368,  1276,   109,   482,   100,   110,
     482,   477,   475,    51,   475,   243,   261,  1288,   475,  1290,
     482,  2884,   482,   481,   475,  2397,   243,   261,   482,   261,
     261,   368,   110,   100,  2724,   476,   261,   476,   261,   261,
     475,  1312,  1313,   100,   476,   100,   476,  2737,  1319,   477,
    1321,   261,   100,  2743,  1325,  1326,  1327,  1328,  1329,  1330,
     162,   476,   476,  1334,   476,   482,   475,  2757,   475,  2759,
      95,   477,   477,   475,   475,  1346,  1347,   477,   477,  1350,
    2571,  1411,   475,   475,  2353,  1677,  2646,   477,  2361,   772,
    2840,   598,  2837,  2752,  1683,  2655,  2656,  2365,  2730,  1686,
    1292,  2027,  1502,  1418,  1510,  2795,  1692,  1576,  1898,   307,
    2800,  2473,   568,   309,  2611,   310,    31,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,  1354,   230,   274,
    1395,  2516,  1403,  1414,  1518,  1273,  1407,   660,    31,  1440,
    1621,  1278,  1637,  2833,  2834,  1671,  1417,  1635,  1666,  1660,
    2840,  1668,   562,  1655,  1378,  1298,  1571,  1491,  1505,   405,
    1698,  1432,    -1,  1434,  1282,  1436,    -1,   601,  1375,  2859,
      -1,  2861,    -1,    31,    -1,    -1,    -1,  1448,  1449,  1450,
    1451,    -1,    -1,  1454,  1455,  1456,  1457,  1458,  1459,  1460,
    1461,  1462,  1463,  1464,  1465,  1466,  1467,  1468,    -1,    -1,
    1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,  1479,  1480,
    1481,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1492,  1493,    -1,    -1,  1496,    84,    -1,    -1,  1500,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,    -1,    -1,   274,    -1,     5,  1517,   162,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,    28,   162,
      -1,    -1,    31,    -1,    -1,    -1,    36,    -1,    -1,    -1,
    1551,  1552,    -1,    -1,  1555,  1556,    -1,    -1,    -1,    -1,
      -1,    31,  1563,    -1,  1565,  1566,  1567,  1568,  1569,    -1,
      -1,    61,    -1,    -1,   162,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   230,    -1,   274,    -1,    -1,
      80,    81,  1593,  1594,   162,    84,    -1,    -1,    -1,    -1,
    1601,    -1,   477,    93,    -1,    -1,    -1,   230,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,   116,    -1,    -1,   119,
      -1,    -1,  1633,    -1,    -1,    -1,    -1,    -1,    -1,  1640,
    1641,  1642,   132,  1644,    -1,    -1,  1647,  1648,    -1,    -1,
      -1,    -1,  1653,  1654,    -1,    -1,    -1,   147,    -1,    -1,
      -1,    -1,  1663,  1664,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,   165,    -1,   167,    -1,    -1,
    1681,   171,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   162,    -1,   274,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,   194,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,   247,   274,    -1,
      -1,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    -1,    -1,  1840,
    1841,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,  1852,  1853,   274,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,    -1,
       7,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,  1930,
      -1,    28,    29,    -1,    -1,    -1,    -1,  1938,    -1,    36,
      -1,    -1,    39,    40,    41,    -1,    -1,    -1,    -1,  1950,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   447,   448,   449,
      57,   477,    59,    60,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    68,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    80,    81,    82,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,   106,
     107,   108,  2013,    -1,    -1,    -1,   113,   114,    -1,    -1,
     117,    -1,   119,   120,   121,   122,  2027,    -1,  2029,    -1,
      -1,    -1,    -1,    -1,    -1,   132,   133,   134,   135,   136,
     137,   138,   139,    -1,    -1,   142,   143,   144,   145,   146,
     147,    -1,    -1,    -1,   475,  2056,  2057,    -1,    -1,   156,
     157,   158,   159,   160,   161,    -1,    -1,    -1,   165,   166,
     167,    -1,   169,    -1,   171,    -1,    -1,   261,    -1,    -1,
     177,    -1,   179,  2084,  2085,    -1,    -1,    -1,    -1,    -1,
     187,    -1,    -1,    -1,    -1,   192,   193,   194,    -1,    -1,
     197,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   206,
      -1,   208,   209,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,    -1,   274,   477,   224,    -1,    -1,
      -1,   228,    -1,    -1,    -1,    -1,    49,   234,   235,    -1,
      -1,   238,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,   249,    -1,    -1,    -1,    -1,    -1,  2159,    -1,
      -1,   258,   259,    -1,    -1,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,    -1,   100,    -1,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      64,   477,   274,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   129,  2218,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   152,
     153,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,   129,    -1,    -1,    -1,   366,
      -1,    -1,    -1,    -1,    -1,    -1,   140,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   152,   153,
     274,    -1,    -1,   390,   391,   479,    -1,    -1,   162,    -1,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,    -1,    -1,  2318,    -1,  2320,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   435,   436,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,  2354,  2355,   268,   269,    -1,    -1,    -1,
    2361,    -1,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,  2373,  2374,    -1,   288,    -1,    -1,    -1,   292,
     293,   294,   295,   296,    -1,    -1,    -1,    -1,  2389,    -1,
    2391,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2404,   268,   269,    -1,    -1,    -1,    -1,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   477,    -1,    -1,   288,    -1,    -1,    -1,   292,   293,
     294,   295,   296,   162,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,
    2471,  2472,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,    64,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2515,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     0,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    11,    12,    -1,    -1,    -1,
      -1,    -1,   100,    -1,    -1,  2546,    -1,    23,    24,    25,
      26,    27,    -1,   475,    -1,    31,  2557,  2558,    -1,    -1,
      -1,    -1,    -1,   476,    -1,   478,    -1,   480,    44,    45,
      46,   129,    -1,    -1,    50,    -1,    52,    53,    54,    55,
      56,    -1,   140,    -1,    -1,    -1,    -1,    63,    -1,    -1,
      -1,    -1,    68,    -1,   152,   153,    -1,    -1,    -1,    -1,
      -1,  2602,  2603,  2604,   162,  2606,    -1,    -1,    84,    85,
      86,    -1,   476,    -1,   478,    -1,   480,    93,    -1,    95,
      96,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     162,    -1,   118,    -1,    -1,  2646,    -1,    -1,    -1,   125,
      -1,    -1,    -1,    -1,  2655,  2656,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,    -1,
      -1,    -1,   148,   149,   150,   151,    -1,    -1,   154,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,   477,    -1,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,    -1,
     176,   274,   178,    -1,   180,   181,    -1,    -1,  2709,   185,
     268,   269,    -1,   189,   190,   191,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,    -1,  2730,
     288,    -1,    -1,    -1,   292,   293,   294,   295,   296,   215,
     216,    -1,   218,   219,   220,   221,    -1,    -1,    -1,    -1,
      -1,   227,    -1,    -1,    -1,   231,   232,    -1,    -1,    -1,
      -1,    -1,    -1,   239,    -1,   241,    -1,  2768,    -1,   245,
      -1,    -1,    -1,    -1,    -1,   251,   252,   253,   254,   255,
     256,   257,    -1,  2784,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,  2813,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   297,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   332,    -1,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   477,    -1,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,   477,    -1,    -1,    -1,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   476,    -1,
      23,    24,    25,    26,    27,   401,   402,    -1,    31,   405,
     406,   407,   408,   409,   410,   411,   412,    -1,    -1,    -1,
      -1,    44,    45,    46,   420,    -1,    -1,    50,   424,    52,
      53,    54,    55,    56,   430,    -1,    -1,    -1,    -1,    -1,
      63,    -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    85,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      93,    64,    95,    96,    -1,    -1,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    94,   125,    -1,    -1,    -1,    -1,   100,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,    -1,    -1,    -1,    -1,   148,   149,   150,   151,    -1,
      -1,   154,    -1,    -1,    -1,    -1,   129,    -1,    -1,   162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,
      -1,    -1,    -1,   176,    -1,   178,    -1,   180,   181,   152,
     153,    -1,   185,    -1,    -1,    -1,   189,   190,   191,   162,
     163,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      -1,    -1,   215,   216,    -1,   218,   219,   220,   221,    -1,
      -1,    -1,    -1,    -1,   227,    64,    -1,    -1,   231,   232,
      -1,    -1,    -1,    -1,    -1,    -1,   239,    -1,   241,    -1,
      -1,    -1,   245,    -1,    -1,    -1,    -1,    -1,   251,   252,
     253,   254,   255,   256,   257,    94,    -1,    -1,    -1,    -1,
      -1,   100,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,    -1,
     129,    -1,    -1,    -1,   297,   268,   269,    -1,    -1,    -1,
      -1,   140,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   477,   152,   153,   288,    -1,    -1,    -1,   292,
     293,   294,    -1,   162,   163,    -1,    -1,    -1,    -1,   332,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,   477,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    64,    -1,   401,   402,
      -1,    -1,   405,   406,   407,   408,   409,   410,   411,   412,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   420,    -1,    -1,
      -1,   424,   261,    -1,    -1,    -1,    94,   430,    -1,   268,
     269,    49,   100,    -1,    -1,    -1,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,    -1,    -1,    -1,   288,
      -1,    -1,    -1,   292,   293,   294,    -1,    -1,    -1,    -1,
      -1,   129,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,
      -1,    -1,   140,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   152,   153,   274,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,   163,    -1,    -1,    -1,    -1,
      64,    -1,    -1,   476,    -1,    -1,    -1,    -1,    49,    -1,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
      94,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   140,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    94,    -1,    -1,    -1,   152,   153,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,   163,
     268,   269,    -1,    -1,    -1,    -1,    -1,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,    -1,    -1,   129,
     288,   162,    -1,    -1,   292,   293,   294,    -1,    -1,    -1,
     140,    -1,    -1,    -1,    -1,    -1,    -1,   476,    -1,    -1,
      -1,    -1,   152,   153,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,   163,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,   162,    -1,
      -1,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,    -1,   268,   269,    -1,    -1,    -1,    -1,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,   293,
     294,    -1,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   109,   110,    -1,    -1,   425,   268,   269,
      -1,    -1,    -1,    -1,    -1,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,    -1,    -1,   261,   288,   162,
      -1,   477,   292,   293,   294,   478,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,   162,    -1,   476,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    64,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    94,
      64,   425,    -1,    -1,    -1,   100,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,    -1,
      94,    -1,    -1,    -1,   129,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,
      -1,    -1,   476,    -1,    -1,   425,    -1,   152,   153,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,   162,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   140,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   152,   153,
     274,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,   163,
      -1,    -1,    -1,    -1,    -1,    -1,   476,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   268,   269,    -1,    -1,    -1,    -1,    -1,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      -1,    -1,    -1,   288,    -1,    -1,    -1,   292,   293,   294,
      -1,    -1,    -1,    -1,   268,   269,    -1,    -1,    -1,    -1,
      -1,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,    -1,    -1,    -1,   288,    -1,    -1,    -1,   292,   293,
     294,    -1,   475,   476,    -1,    -1,    -1,    -1,    -1,     3,
      -1,     5,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    39,    40,    41,    42,    43,
      -1,    -1,    -1,    -1,    -1,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    90,    91,    -1,    -1,
     425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,   106,    -1,    -1,    -1,    -1,   162,    -1,    -1,
      -1,   115,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,    -1,   130,    -1,   477,    -1,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   476,   274,    -1,    -1,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,     3,   274,     5,    -1,
      -1,    -1,    -1,   167,   168,    -1,   170,   171,   172,   173,
      -1,    -1,   476,    -1,    -1,   179,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   187,    -1,   189,    -1,    -1,    -1,    -1,
      -1,   195,    39,    40,    41,    42,    43,    -1,    -1,   203,
      -1,   205,   206,    -1,    -1,    -1,   261,    -1,   212,   213,
     214,    -1,    -1,    -1,    -1,   475,    -1,   221,   222,   223,
      -1,    -1,    69,    -1,   228,    -1,    -1,    -1,    -1,    -1,
     234,   235,    -1,    80,    81,    82,   240,    -1,   242,    -1,
      -1,    -1,    -1,    90,    91,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,     5,    -1,    -1,    -1,   104,   105,   106,
      -1,    -1,    -1,    -1,   111,    -1,    -1,    -1,   115,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,    -1,
      -1,   274,    -1,   130,    -1,    -1,    -1,    39,    40,    41,
      42,    43,    -1,    -1,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    -1,    -1,    69,    70,    -1,
     167,   168,    -1,   170,   171,   172,   173,   477,    80,    81,
      82,    -1,   179,   162,    -1,    -1,    -1,    -1,    90,    91,
     187,    -1,   189,    -1,    -1,   477,    -1,    -1,   195,    -1,
      -1,    -1,   104,   105,   106,    -1,   203,   162,   205,   206,
     477,    -1,   366,   115,    -1,   212,   213,   214,    -1,    -1,
      -1,    -1,    -1,    -1,   221,   222,   223,    -1,    -1,    -1,
      -1,   228,    -1,    -1,    -1,    -1,    -1,   234,   235,    -1,
      -1,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,    -1,     3,   274,     5,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   167,   168,   274,   170,   171,
     172,   173,   477,    -1,    -1,    -1,    -1,   179,    -1,    -1,
      -1,    -1,   261,    -1,    -1,   187,    -1,   189,    39,    40,
      41,    42,    43,   195,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   203,    -1,   205,   206,    -1,   261,    -1,    -1,    -1,
     212,   213,   214,    -1,    -1,   162,    -1,    -1,    69,   221,
     222,   223,    -1,    -1,    -1,    -1,   228,    -1,    -1,    80,
      81,    82,   234,   235,   477,   162,    -1,    -1,   240,    90,
      91,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   115,    -1,    -1,    -1,   119,   366,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     162,    -1,    -1,    -1,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   261,    -1,   167,   168,    -1,   170,
     171,   172,   173,    -1,    -1,    -1,    -1,    -1,   179,    -1,
      -1,    -1,   204,    -1,    -1,    -1,   187,    -1,   189,    -1,
      -1,    -1,    -1,    -1,   195,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   203,    -1,   205,   206,   477,    -1,    -1,    -1,
      -1,   212,   213,   214,   366,    -1,    -1,    -1,   475,    -1,
     221,   222,   223,    -1,    -1,    -1,    -1,   228,    -1,    -1,
      -1,    -1,    -1,   234,   235,   162,    -1,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    -1,   477,   274,
      -1,    -1,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   477,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   162,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   162,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,    -1,   274,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,    -1,   162,    -1,    -1,   366,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    -1,    -1,   274,
     477,   162,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,    -1,    -1,    -1,   475,   476,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     476,    -1,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   477,    -1,   476,    -1,    -1,    -1,    -1,    -1,
      -1,   162,    -1,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,    -1,   274,    -1,    -1,    -1,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,    -1,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,   475,   476,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   475,   476,   274,    -1,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,    -1,   477,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   204,   162,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,   477,   204,   162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   476,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   476,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,    -1,
      -1,    -1,    -1,   261,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,    -1,   274,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   261,    -1,    -1,
     162,   477,    -1,    -1,   476,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,   261,   274,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,    -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   162,    -1,    -1,    -1,    -1,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   162,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,    -1,   274,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   475,    -1,
      -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     261,    -1,    -1,    -1,    -1,    -1,    -1,   475,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   162,    -1,    -1,
      -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     477,    -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,
     475,    -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   261,   274,    -1,    -1,    -1,    -1,    -1,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   162,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,    -1,
      -1,   274,    -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,   261,   274,    -1,    -1,    -1,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   162,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,    -1,    -1,   261,    -1,    -1,
      -1,    -1,    -1,    -1,   475,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,   261,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,
     475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,
      -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   261,   274,    -1,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,   261,   274,    -1,    -1,    -1,    -1,    -1,
      -1,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   162,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,    -1,    -1,    -1,    -1,   261,    -1,    -1,
      -1,    -1,   475,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,   261,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,   475,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,
     261,    -1,    -1,    -1,    -1,    -1,    -1,   475,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,   261,
     274,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,
      -1,   475,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,   261,   274,    -1,    -1,    -1,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   162,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,    -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,
      -1,    -1,   475,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,    -1,    -1,   261,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,   475,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,
     261,    -1,    -1,    -1,    -1,    -1,    -1,   475,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,   261,
     274,    -1,    -1,    -1,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    -1,   162,    -1,    -1,    -1,
      -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,   475,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   261,   274,    -1,    -1,    -1,    -1,    -1,    -1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   162,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,    -1,    -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,
     475,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,    -1,    -1,   261,    -1,    -1,    -1,
      -1,    -1,    -1,   475,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,   261,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,   261,   274,    -1,
      -1,    -1,    -1,    -1,    -1,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   162,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   477,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   261,   162,    -1,    -1,    -1,    -1,    -1,   475,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,   261,   274,    -1,    -1,    -1,    -1,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   261,   162,    -1,    -1,    -1,    -1,    -1,
     475,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   162,    -1,
      -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   477,    -1,    -1,   261,    -1,    -1,   162,    -1,    -1,
      -1,   475,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     162,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   477,    -1,    -1,   261,   162,
      -1,    -1,    -1,    -1,    -1,   475,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   261,    -1,   274,
      -1,    -1,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,    -1,    -1,   162,    -1,    -1,    -1,   475,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,    -1,    -1,    -1,   475,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   162,    -1,    -1,    -1,   475,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,   100,   475,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,    -1,    -1,   162,    -1,
      -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,    -1,    -1,    -1,    -1,    -1,    -1,   100,   162,    -1,
      -1,   475,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,    -1,    -1,    -1,    -1,    -1,
     475,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   162,
      -1,    -1,    -1,   475,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,    -1,   274,    -1,    -1,    -1,
      -1,    -1,   475,    -1,    -1,    -1,    -1,   109,   110,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   204,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     162,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,    -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   110,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   110,   475,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,
      -1,    -1,    -1,   110,    -1,    -1,    -1,   162,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   475,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,   368,   162,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,   475,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,    -1,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    -1,    -1,   274,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,    -1,   274,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,    -1,   274,   475,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,   475,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
      -1,    -1,   274,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,    -1,    -1,   274,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,    -1,    -1,   274,    -1,
     475,    -1,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,    -1,   475,   274,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,    -1,   475,   274,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    -1,    -1,
     274,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,    -1,    -1,   274,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,    -1,   475,   274,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    -1,    -1,   274,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   162,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   162,   204,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   162,    -1,    -1,    -1,   204,    -1,   475,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   162,   475,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,
      -1,   162,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     162,    -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,
      -1,    -1,    -1,   261,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   475,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   475,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   475,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     475,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     369,   370,   371,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,   368,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,   368,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,   368
  };

  const unsigned short int
  parser::yystos_[] =
  {
       0,    11,    12,    23,    24,    25,    26,    27,    31,    44,
      45,    46,    50,    52,    53,    54,    55,    56,    63,    68,
      84,    85,    86,    93,    95,    96,   118,   125,   148,   149,
     150,   151,   154,   162,   176,   178,   180,   181,   185,   189,
     190,   191,   215,   216,   218,   219,   220,   221,   227,   231,
     232,   239,   241,   245,   251,   252,   253,   254,   255,   256,
     257,   297,   332,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   401,   402,   405,   406,   407,   408,   409,   410,
     411,   412,   420,   424,   430,   484,   485,   486,   487,   488,
     491,   494,   498,   499,   500,   501,   508,   511,   512,   517,
     518,   519,   522,   527,   538,   542,   553,   556,   559,   562,
     566,   569,   572,   575,   578,   581,   592,   598,   601,   608,
     609,   612,   613,   614,   616,   625,   626,   627,   630,   631,
     632,   637,   640,   643,   644,   646,   649,   650,   651,   652,
     653,   654,   657,   661,   664,   665,   670,   671,   672,   676,
     679,   682,   685,   688,   691,   694,   697,   700,   703,   704,
     709,   712,   715,   718,   719,   722,   726,   729,   732,  1030,
     100,   476,   100,   476,   475,   476,   585,  1030,   476,   475,
     476,   476,   475,   476,   100,   476,   476,   475,   476,   475,
     476,   585,   475,   475,   475,   476,   475,   476,   476,   475,
     476,   585,   476,   475,   475,   475,   476,   475,   476,   476,
     476,   476,   475,   476,   204,   476,   658,   660,  1030,   475,
     476,   475,   475,   475,   475,   475,   476,   585,   585,   506,
    1030,    51,   100,   662,   476,   585,   585,   476,   475,   475,
     476,   585,    51,   475,   476,   475,   475,   476,   475,   476,
     585,   475,   476,   585,   475,   476,   585,   585,   476,   503,
    1030,   504,  1030,   505,  1030,   638,   507,  1030,   475,   475,
     475,   476,   476,   475,   476,   476,   475,   476,   585,   475,
     476,   475,   476,   475,   476,   475,   476,   475,   476,   475,
     476,   543,   476,   476,   476,     0,   485,    51,   476,    51,
      51,    51,   482,   475,    13,    14,    15,    16,    17,    18,
      19,    29,    36,    61,   165,   166,   193,   194,   258,   259,
     673,   674,   675,   768,   769,   771,   787,   788,   830,   831,
     835,   836,   853,   854,   855,   856,   857,   858,   859,   475,
      20,    28,    68,   674,   677,   678,   797,   820,   860,    59,
      60,   727,   728,   768,   823,   832,   261,   475,  1030,   185,
     251,   252,   253,   509,    83,    87,    88,    89,   127,   130,
     206,   228,   568,   570,   571,   734,   753,   759,   766,   900,
     901,   902,   903,    30,   186,   189,   213,   716,   717,   739,
     749,   797,   904,   905,   251,   720,   721,  1030,   100,   475,
     658,   658,   520,   521,  1030,    22,     3,     4,     5,     7,
      39,    40,    41,    57,    80,    81,    82,   104,   105,   106,
     107,   108,   113,   114,   117,   119,   120,   121,   122,   132,
     133,   134,   135,   136,   137,   138,   139,   142,   143,   144,
     145,   146,   147,   156,   157,   158,   159,   160,   161,   167,
     169,   171,   177,   179,   187,   192,   197,   208,   209,   224,
     234,   235,   238,   249,   366,   390,   391,   435,   436,   633,
     634,   734,   738,   741,   745,   746,   766,   768,   769,   770,
     771,   787,   788,   789,   790,   791,   792,   793,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
     809,   810,   811,   812,   813,   814,   815,   816,   817,   818,
     819,   820,   821,   822,   823,   825,   826,   830,   831,   832,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     844,   845,   846,   847,   848,   849,   850,   851,   852,   968,
     969,   970,   971,  1014,  1015,  1016,  1017,  1018,   475,    31,
     210,   230,   593,   594,   595,  1030,    31,   230,   602,   603,
    1030,    31,   230,   599,   600,  1030,    10,    92,   179,   229,
     730,   731,   749,   750,   751,   752,    65,   606,   607,   713,
     714,   749,   791,   792,   793,   797,   475,  1030,   523,   524,
    1030,   710,   711,  1030,   116,   182,   183,   196,   247,   248,
     302,   655,   656,   739,   741,   749,   790,   791,   792,   793,
     825,   866,   891,   895,   896,   897,   898,   899,   905,   520,
      22,    58,   658,   126,   528,     9,    21,    33,    48,   115,
     131,   164,   184,   246,   525,   526,   737,   758,   761,   128,
     827,   476,   261,   475,   658,   573,   574,   251,   541,   560,
     641,   642,  1030,   645,  1030,    42,    43,    69,    90,    91,
     111,   130,   168,   170,   172,   173,   195,   203,   205,   212,
     214,   221,   222,   223,   583,   647,   648,   733,   734,   735,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   756,   757,   762,   763,   764,   765,   766,
     770,   791,   792,   793,   824,   828,   829,   840,   841,   844,
     845,   849,   850,   851,   852,   954,   955,  1018,   475,   475,
     261,   475,  1030,   243,   476,   502,   100,   475,    64,   100,
     129,   140,   152,   153,   268,   269,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   288,   292,   293,   294,
     295,   296,   476,   534,   588,  1030,   189,   475,   475,   658,
      31,   251,   539,   540,   541,   707,   708,   768,   905,   475,
     478,   130,   141,   226,   576,   577,   736,   749,   754,   759,
     760,   768,   723,   567,   568,   582,   583,   584,   814,   475,
      70,   240,   583,   668,   669,   843,   963,   475,   130,   242,
     666,   667,   669,   755,  1013,   475,   475,   124,   403,   261,
     475,  1030,   243,   502,   261,   475,  1030,   243,   502,   261,
     475,  1030,   243,   502,   639,  1030,   261,   475,  1030,    93,
     298,   299,   300,   301,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   447,   448,
     449,   705,   706,   741,   768,   769,   771,   787,   788,   790,
     791,   792,   793,   797,   798,   804,   814,   825,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,   872,
     873,   874,   875,   876,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   886,   887,   888,   889,   890,   892,   893,
     894,   895,   896,    37,    61,    62,   165,   610,   611,   767,
     772,   773,   786,   830,   831,   327,   328,   329,   330,   331,
     332,   333,   336,   337,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   350,   351,   352,   353,   354,   355,   356,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     383,   384,   385,   386,   387,   388,   389,   392,   393,   394,
     459,   680,   681,   768,   820,   908,   909,   910,   911,   912,
     913,   914,   915,   916,   917,   918,   919,   920,   921,   922,
     923,   924,   925,   926,   927,   928,   930,   931,   932,   933,
     934,   935,   936,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     976,   404,   217,   236,   237,   397,   400,   437,   438,   440,
     441,   443,   444,   445,   450,   458,   689,   690,   972,   973,
     975,   992,  1000,  1001,  1002,  1005,  1006,  1007,  1008,  1009,
    1010,  1011,   475,   439,   683,   684,   972,   973,   975,   992,
    1000,  1001,  1002,  1004,  1005,  1006,  1007,  1008,  1010,  1011,
     348,   442,   460,   461,   462,   463,   464,   465,   466,   467,
     468,   469,   470,   471,   472,   473,   474,   701,   702,   768,
     830,   831,   908,   909,   910,   911,   912,   918,   919,   920,
     922,   926,   927,   928,   929,   972,   973,   974,   976,   977,
     978,   979,   980,   981,   982,   983,   984,   985,   986,   987,
     988,   989,   990,   991,    43,   138,   175,   457,   698,   699,
     906,   907,   972,   973,   992,   993,   994,   452,   453,   454,
     455,   456,   695,   696,   972,   973,   975,   995,   996,   997,
     998,   999,   451,   692,   693,   972,   973,  1002,  1003,   446,
     686,   687,   972,   973,   975,   992,  1000,  1005,  1006,  1007,
    1008,  1009,  1010,  1011,  1012,   475,   396,   421,   422,   423,
     554,   555,   956,   957,   958,   959,   426,   427,   429,   557,
     558,   956,   960,   961,   962,   431,   432,   433,   434,   579,
     580,   964,   965,   966,   967,    31,    84,   614,  1030,   615,
     796,  1030,    31,    84,   626,  1030,    31,    84,   631,  1030,
      94,   129,   140,   152,   153,   163,   268,   269,   275,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   288,   292,
     293,   294,   476,   513,   588,  1030,   109,   110,   368,  1030,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,   261,   477,    51,    51,    51,   261,   477,
      51,   477,   261,  1030,   477,    51,    51,    51,    51,    51,
      51,    51,   261,   477,    51,    51,    51,    51,   261,   477,
    1030,    49,   721,   261,   475,   477,   477,    49,   521,    51,
     477,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,   261,   477,  1030,  1030,    49,   594,
     261,  1030,  1030,    49,   603,   261,  1030,  1030,    49,   600,
     261,   477,    51,    51,   477,   261,   268,   477,   261,   477,
     477,    49,   524,   476,    49,   711,   261,    51,    51,    51,
      51,    51,    51,    51,   477,   261,    49,   477,    51,   477,
      51,   478,   480,   530,   531,   534,   537,    51,    51,    51,
      51,   261,   477,    51,   477,   588,   658,   476,   261,   477,
    1030,    49,   541,    49,   642,   476,    49,  1030,   261,   513,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
     261,   477,  1030,   243,   502,   502,   260,   475,   476,   476,
     476,   476,   534,   534,   476,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   476,
     534,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   274,   663,   535,    51,   477,  1030,  1030,    49,   540,
     477,   261,   268,   269,   476,   564,   565,   588,   589,    51,
      51,    51,   261,   477,   478,   724,   725,  1030,   261,   477,
     261,   477,    51,    51,   261,   477,    51,    51,   261,   477,
      51,    51,  1030,   243,   502,   502,  1030,   243,   502,   502,
    1030,   243,   502,   502,   261,   475,  1030,  1030,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
     477,   261,    51,    51,    51,    51,   261,   477,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,   261,   477,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,   261,   477,   261,   477,    51,
      51,    51,    51,    51,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,   261,   477,    51,    51,    51,
     261,   477,    51,    51,    51,    51,   261,   477,   261,   477,
      51,   261,   477,   338,   414,   416,   417,   544,   545,    51,
      51,    51,    51,   261,   477,    51,   261,   477,    51,    51,
      51,    51,   261,   477,   476,   476,   475,   482,   261,   477,
      51,   476,   476,   475,   482,   476,   476,   475,   482,   476,
     476,   476,   476,   513,   513,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   476,   476,   476,   513,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     274,   475,   514,   476,   617,   482,   588,   589,   588,   100,
     589,   100,   658,   100,   100,   478,  1020,  1022,  1023,   100,
     100,  1030,  1019,  1030,   675,   100,   100,   588,   100,   678,
     100,  1023,   475,   585,   727,   510,  1030,   100,   100,   100,
     588,   100,   588,   100,   571,   475,   476,    47,   198,   199,
     200,   201,   202,   100,   100,   717,   475,   475,   475,  1030,
     475,   585,   475,   585,   475,   513,   475,   100,   588,   588,
     100,   363,   364,   365,   367,   476,   794,  1020,  1023,   100,
     476,   588,   100,   588,   100,   100,    38,    66,    67,   225,
     588,   588,   588,   588,   588,   588,   100,   100,   100,    94,
     268,   269,   589,   590,   591,   100,   100,   100,  1030,   658,
     100,  1023,   478,  1024,  1025,   369,   370,   371,   658,   476,
     100,   100,   588,    94,   588,   100,    66,    67,   588,   100,
      34,    35,    66,   100,   634,   475,   585,   261,   475,     8,
      79,   101,   102,   103,   174,   244,   513,   516,   596,   605,
     261,   261,   475,   513,   261,   261,   475,   513,   475,   100,
     100,   475,   730,   100,   475,   714,   475,   585,   482,   475,
     100,   268,   269,   587,   475,   513,   100,   100,   587,   100,
     100,   100,   658,   100,   475,   655,   475,   475,   658,   475,
     492,   162,   532,   533,  1030,    49,   531,   537,    51,   475,
     588,   476,   100,   476,   525,   475,   112,   155,   660,   477,
     476,   588,   574,   475,   475,   475,   475,   513,   475,   261,
     513,  1030,   475,   100,   100,   588,   100,   588,   100,   588,
     100,   100,   100,   648,   475,   585,   243,   502,   502,    51,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   587,
     477,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   475,   476,   100,   475,   261,    51,   261,   475,
     475,   475,   585,   707,   588,   588,   513,   475,   479,   261,
     476,   589,   100,   588,   100,   577,   475,   585,    49,   725,
      51,   568,   475,   584,   475,   585,   476,   513,   669,   475,
     585,   100,   588,   667,   475,   585,   496,   495,   243,   502,
     502,   243,   502,   502,   243,   502,   502,  1030,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   588,   588,   100,   478,  1028,  1029,   588,   588,   476,
     476,   476,   100,   100,   476,   588,   100,   588,   588,   588,
     588,   588,   475,   705,   658,   607,   607,   100,   611,   475,
     100,   418,   419,   100,   100,   100,   100,   658,   100,   476,
     100,   162,   416,   417,   100,   100,   100,   100,   100,   588,
     588,   100,   100,   100,   100,   100,   100,   588,   100,   100,
     100,   100,   100,   100,   100,   100,   100,   100,   100,   100,
     100,   100,   100,   100,   100,   100,  1025,   681,   475,   489,
     100,   658,   100,   658,   658,  1025,   100,   100,  1025,   589,
     100,   690,   475,   585,   684,   475,   349,   367,   588,   588,
     588,   100,   588,   100,   100,   588,   588,   100,   100,   100,
     100,   588,   588,   702,   475,   100,   100,   100,   699,   475,
     100,   589,   589,   100,   696,   475,   693,   475,   100,   687,
     475,   413,   415,   428,   475,   475,    49,   545,   478,  1025,
    1027,   100,   588,  1029,   100,   555,   475,  1020,  1023,   558,
     475,   658,   100,   658,   658,   580,   475,  1030,  1030,   796,
     475,   607,  1030,  1030,   368,  1030,  1030,  1030,   110,  1030,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   477,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     476,    97,    98,    99,   628,   629,   780,   781,   782,   476,
     110,   368,   100,   261,  1020,  1021,   261,   479,  1021,   481,
     475,   475,   475,   261,   475,  1030,   585,   189,   477,   475,
     475,   475,   520,   794,   795,   585,    94,    94,   261,   589,
     261,   479,   589,   204,   635,   636,   475,  1030,   261,   475,
     261,  1030,   513,   261,  1030,   513,   475,    49,   599,   475,
     109,   110,   368,  1030,   100,   100,   477,   261,   475,   520,
     477,   534,    51,   261,   479,    51,   475,   534,   585,   658,
     659,   529,   475,   588,   477,   189,   477,  1030,   475,   513,
     475,   502,   204,   261,   261,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   261,
     477,   261,   477,   477,   477,   534,   536,   477,  1030,   513,
    1030,   230,   475,   477,   565,   475,   476,   589,   513,   479,
     475,   513,   475,   585,   475,   475,   534,   534,   502,   502,
     502,   591,   479,   591,   481,   585,   586,   586,   586,   586,
     585,   534,   475,   100,   100,   475,   475,  1025,  1026,   261,
     477,   481,   261,   477,   482,   261,   477,   482,   261,   261,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   261,   477,   261,   477,   513,   515,
      51,    51,    51,   261,   477,    71,    72,    73,    74,    75,
      76,    77,    78,   211,   623,   624,   774,   775,   776,   777,
     778,   779,   783,   784,   785,  1009,   476,   618,   481,  1021,
     479,  1021,  1030,  1030,   477,   100,   561,   482,    49,   261,
     477,   477,   589,   479,   589,   261,   261,   477,   513,   516,
     605,   516,   597,   261,   261,   513,   261,   475,   475,    49,
     476,   619,   482,    51,   513,    49,   475,   477,   204,   533,
     534,   534,   475,   477,   261,   477,   530,   477,   561,   475,
     513,   475,   477,   534,   534,   534,   534,   476,   261,   477,
     585,    51,   475,    51,   513,   513,   477,    51,   475,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   261,   475,
     261,   479,  1030,   482,   607,  1030,   482,   368,  1030,   482,
     110,   513,   513,   513,   513,   261,   477,  1029,   588,   589,
     629,   475,    51,    51,    51,    51,    51,    51,    51,    51,
      51,   261,   477,   628,   476,   100,   481,   100,   261,   475,
     109,   110,   368,  1030,   475,   794,   204,   589,   635,   261,
     261,   261,   513,   513,   475,   513,   475,   628,   476,   110,
     368,   513,   475,   475,   493,  1030,    51,   475,   475,   658,
      49,   475,   475,   477,   477,   261,   261,   534,   534,   475,
     513,   513,   475,   477,   513,   497,  1030,   497,   490,  1030,
     546,   413,   548,  1025,   477,   477,   368,  1030,   477,   110,
    1030,   477,   477,   261,   261,   513,   589,   589,   588,   513,
     589,  1025,   351,   357,   358,   359,   360,   361,   362,   604,
    1025,  1025,   624,   475,   477,   623,   100,   481,   100,   250,
     476,   621,   482,   516,   597,   516,   261,   475,   475,   477,
     623,   476,   620,   475,   261,   475,  1030,   243,   534,   475,
     250,   534,   534,   477,   475,   475,   475,   261,   475,  1030,
     243,   502,   475,   261,   475,  1030,   243,   268,   269,   425,
     513,   550,   551,   552,   100,   413,   482,   482,   482,   482,
     482,   513,   513,   475,   477,   100,   481,   476,   563,   589,
     628,   476,   110,   368,   261,   261,   513,   475,   477,   628,
     476,  1030,   243,   475,   563,   477,   477,  1030,   243,   502,
     502,  1030,   243,   425,   425,   476,   270,    51,   513,   552,
     261,   100,   368,  1030,   368,   110,  1030,   110,   477,   477,
     475,   100,   513,   261,   475,   476,   589,   477,   623,   476,
     622,   605,   516,   475,   475,   477,   623,   243,   475,   243,
     502,   502,   243,   476,   476,  1030,   425,   547,   549,  1030,
     261,   482,   482,   477,   476,   589,   513,   475,   477,   628,
     476,   261,   261,   475,   477,   502,  1030,  1030,   261,   476,
     550,   261,   475,   549,   368,   110,   513,   477,   475,   477,
     623,   597,   516,   475,   261,   261,   100,  1030,   475,  1030,
     475,   477,   475,   477,   261,   100,   100,   477,   261,   475,
     513,   477,   477,   100,   477
  };

  const unsigned short int
  parser::yyr1_[] =
  {
       0,   483,   484,   484,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     485,   485,   485,   486,   486,   487,   489,   488,   490,   490,
     490,   490,   490,   490,   492,   491,   493,   493,   493,   493,
     493,   493,   494,   495,   494,   496,   494,   497,   497,   497,
     497,   497,   497,   497,   497,   497,   497,   497,   497,   498,
     499,   500,   501,   502,   503,   503,   503,   503,   503,   503,
     503,   503,   503,   503,   503,   503,   504,   504,   504,   504,
     504,   504,   504,   504,   504,   504,   504,   504,   505,   505,
     505,   505,   505,   505,   505,   505,   505,   505,   505,   505,
     506,   506,   506,   506,   506,   506,   506,   506,   506,   506,
     506,   506,   507,   507,   507,   508,   509,   509,   509,   509,
     510,   510,   510,   511,   511,   512,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   513,   513,   513,   513,   513,   513,   514,   513,   513,
     513,   513,   513,   513,   513,   513,   515,   515,   516,   516,
     517,   517,   518,   519,   519,   520,   520,   521,   522,   523,
     523,   524,   525,   525,   525,   525,   525,   525,   525,   525,
     525,   525,   526,   526,   528,   527,   529,   527,   530,   530,
     530,   530,   531,   531,   531,   531,   532,   532,   533,   533,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   534,   534,   534,   534,   534,   534,   534,   534,
     534,   534,   535,   534,   534,   534,   534,   534,   534,   534,
     536,   536,   537,   538,   539,   539,   540,   540,   540,   540,
     540,   541,   543,   542,   544,   544,   545,   545,   546,   547,
     545,   545,   545,   548,   548,   549,   549,   550,   550,   551,
     551,   552,   552,   552,   552,   553,   554,   554,   555,   555,
     555,   555,   556,   557,   557,   558,   558,   558,   558,   559,
     560,   560,   561,   561,   561,   561,   561,   561,   562,   563,
     563,   563,   563,   563,   563,   564,   564,   565,   565,   565,
     565,   565,   565,   566,   566,   567,   567,   568,   568,   568,
     568,   568,   568,   568,   569,   569,   570,   570,   571,   571,
     572,   572,   573,   573,   574,   575,   575,   576,   576,   577,
     577,   577,   577,   577,   577,   578,   579,   579,   580,   580,
     580,   580,   581,   581,   581,   581,   582,   582,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   583,   583,   583,
     583,   583,   583,   583,   583,   583,   583,   584,   584,   585,
     585,   585,   586,   586,   587,   587,   587,   588,   588,   589,
     589,   589,   590,   590,   590,   591,   591,   592,   593,   593,
     594,   595,   595,   595,   595,   596,   596,   596,   596,   596,
     597,   597,   597,   597,   598,   598,   598,   599,   599,   600,
     600,   600,   601,   602,   602,   603,   603,   603,   604,   604,
     604,   604,   604,   604,   604,   605,   605,   605,   605,   605,
     605,   605,   606,   607,   607,   608,   609,   610,   610,   611,
     611,   611,   611,   611,   611,   612,   613,   614,   614,   614,
     615,   615,   617,   616,   618,   616,   619,   616,   620,   616,
     621,   616,   622,   616,   623,   623,   624,   624,   624,   624,
     624,   624,   624,   624,   624,   624,   625,   626,   626,   626,
     626,   626,   626,   627,   627,   627,   627,   627,   627,   628,
     628,   629,   629,   629,   630,   631,   631,   631,   631,   631,
     631,   632,   632,   632,   632,   633,   633,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     634,   634,   634,   634,   635,   635,   636,   636,   638,   637,
     639,   639,   639,   640,   641,   641,   642,   643,   644,   645,
     645,   645,   645,   646,   647,   647,   648,   648,   648,   649,
     649,   649,   649,   650,   650,   651,   651,   652,   653,   654,
     654,   655,   655,   656,   656,   656,   656,   656,   656,   656,
     656,   656,   656,   656,   656,   656,   656,   656,   656,   657,
     657,   658,   658,   659,   659,   660,   660,   660,   660,   660,
     660,   662,   663,   661,   664,   664,   664,   664,   665,   665,
     665,   665,   666,   666,   667,   667,   667,   668,   668,   669,
     669,   669,   670,   671,   672,   672,   672,   672,   673,   673,
     673,   673,   673,   673,   673,   674,   674,   674,   674,   674,
     674,   674,   674,   674,   674,   675,   675,   676,   676,   677,
     677,   677,   677,   678,   678,   679,   679,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   680,   680,   680,   680,   680,
     680,   680,   680,   680,   680,   681,   681,   682,   682,   683,
     683,   683,   683,   683,   683,   683,   683,   683,   683,   683,
     683,   683,   683,   684,   684,   685,   685,   686,   686,   686,
     686,   686,   686,   686,   686,   686,   686,   686,   686,   686,
     687,   687,   688,   688,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   690,   690,
     691,   691,   691,   691,   692,   692,   692,   692,   693,   693,
     694,   694,   695,   695,   695,   695,   695,   695,   695,   695,
     696,   696,   697,   697,   698,   698,   698,   698,   698,   698,
     698,   699,   699,   700,   700,   701,   701,   701,   701,   701,
     701,   701,   701,   701,   701,   701,   701,   701,   701,   701,
     701,   701,   701,   701,   701,   701,   701,   701,   701,   701,
     701,   701,   701,   701,   701,   701,   701,   701,   701,   701,
     702,   702,   703,   703,   704,   704,   705,   705,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   706,   706,
     706,   706,   706,   706,   706,   706,   706,   706,   707,   707,
     708,   708,   709,   710,   710,   711,   711,   712,   712,   712,
     712,   713,   713,   714,   714,   714,   714,   714,   715,   716,
     716,   717,   717,   717,   717,   717,   718,   718,   719,   720,
     720,   721,   723,   722,   724,   724,   725,   725,   726,   726,
     726,   726,   727,   727,   728,   728,   728,   729,   729,   730,
     730,   731,   731,   731,   731,   732,   733,   734,   735,   736,
     737,   738,   739,   740,   741,   742,   743,   744,   745,   746,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   756,
     757,   758,   759,   760,   761,   762,   763,   764,   765,   766,
     767,   768,   769,   769,   770,   770,   771,   772,   773,   774,
     775,   776,   777,   778,   779,   780,   781,   782,   783,   784,
     785,   786,   787,   788,   789,   790,   791,   791,   792,   793,
     793,   794,   794,   794,   794,   795,   795,   796,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,   815,   816,   817,
     817,   817,   818,   819,   820,   821,   822,   823,   824,   825,
     826,   827,   827,   828,   829,   830,   831,   832,   833,   834,
     835,   836,   837,   838,   839,   840,   841,   842,   843,   844,
     844,   845,   846,   846,   846,   846,   847,   848,   849,   849,
     849,   850,   851,   852,   853,   854,   855,   856,   857,   858,
     859,   860,   861,   862,   863,   864,   865,   866,   867,   868,
     869,   870,   871,   872,   873,   874,   875,   876,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   891,   891,   892,   893,   894,   895,   896,   897,
     898,   899,   900,   901,   902,   903,   904,   905,   905,   905,
     905,   905,   905,   906,   907,   908,   908,   908,   909,   910,
     911,   912,   913,   914,   915,   916,   917,   917,   917,   918,
     919,   920,   921,   922,   923,   924,   925,   926,   927,   928,
     929,   929,   930,   931,   932,   933,   934,   935,   936,   937,
     938,   939,   940,   941,   942,   943,   944,   945,   946,   947,
     948,   949,   950,   951,   952,   953,   954,   955,   956,   957,
     958,   958,   959,   960,   961,   962,   962,   963,   964,   965,
     966,   966,   967,   967,   968,   969,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,   981,   982,   983,
     984,   985,   986,   987,   988,   989,   990,   991,   992,   993,
     994,   995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,  1007,  1008,  1009,  1009,  1010,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1017,  1017,  1017,  1018,  1019,
    1020,  1021,  1021,  1022,  1022,  1022,  1022,  1023,  1023,  1024,
    1024,  1024,  1024,  1025,  1025,  1026,  1026,  1027,  1027,  1028,
    1028,  1029,  1030,  1030,  1030,  1030,  1030,  1030,  1030,  1030,
    1030,  1030,  1030,  1030,  1030,  1030,  1030,  1030,  1030,  1030,
    1030,  1030
  };

  const unsigned char
  parser::yyr2_[] =
  {
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     4,     3,     0,     9,     2,     3,
       1,     3,     4,     2,     0,     9,     2,     3,     1,     3,
       4,     2,     3,     0,     9,     0,     9,     2,     3,     1,
       3,     4,     2,     3,     4,     2,     4,     5,     3,     3,
       3,     3,     3,     5,     2,     3,     1,     3,     4,     2,
       3,     4,     2,     4,     5,     3,     2,     3,     1,     3,
       4,     2,     3,     4,     2,     4,     5,     3,     2,     3,
       1,     3,     4,     2,     3,     4,     2,     4,     5,     3,
       2,     3,     1,     3,     4,     2,     3,     4,     2,     4,
       5,     3,     2,     3,     1,     6,     1,     1,     1,     1,
       1,     2,     3,     3,     4,     4,     3,     1,     1,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     6,     6,     0,     5,     8,
       4,     8,     4,     4,     1,     1,     1,     3,     0,     1,
       5,     8,     7,     5,     8,     2,     1,     4,     5,     2,
       1,     7,     1,     1,     1,     1,     1,     1,     1,     5,
       1,     5,     3,     1,     0,     6,     0,     9,     2,     2,
       1,     1,     4,     2,     7,     5,     3,     1,     3,     1,
       3,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     7,     2,     2,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       6,     6,     0,     5,     8,     4,     8,     4,     4,     4,
       1,     3,     5,     5,     2,     1,     1,     6,     5,     7,
       7,     9,     0,     6,     2,     1,     5,     3,     0,     0,
      10,     2,     2,     6,     5,     3,     1,     1,     1,     1,
       2,     6,     7,     7,     8,     5,     3,     1,     1,     1,
       1,     1,     5,     3,     1,     1,     1,     1,     1,     5,
       2,     1,     3,     2,     5,     4,     3,     1,     6,     5,
       4,     3,     3,     2,     1,     3,     1,     5,     3,     4,
       2,     3,     1,     2,     5,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     5,     3,     1,     1,     1,
       2,     5,     3,     1,     0,     2,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     5,     3,     1,     1,     1,
       1,     1,     2,     5,     3,     6,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       3,     1,     1,     1,     2,     2,     1,     1,     1,     2,
       2,     1,     2,     2,     1,     1,     1,     5,     2,     1,
       4,     2,     1,     4,     1,     3,     5,     9,     1,     5,
       3,     5,     7,     9,     5,     7,     8,     2,     1,     5,
       7,     4,     5,     2,     1,     7,     9,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     5,     5,     3,     1,     1,
       1,     1,     1,     1,     1,     5,     4,     3,     6,     8,
       3,     1,     0,     8,     0,    10,     0,    11,     0,    13,
       0,    13,     0,    15,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     5,     6,
       8,     8,    10,     7,     9,    10,    12,    12,    14,     3,
       1,     1,     1,     1,     4,     3,     5,     6,     8,     8,
      10,     2,     5,     3,     6,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     1,     3,     0,     4,
       2,     3,     1,     5,     2,     1,     5,     3,     5,     4,
       6,     3,     5,     3,     3,     1,     1,     1,     1,     2,
       5,     3,     6,     5,     6,     5,     6,     5,     5,     2,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       6,     1,     1,     1,     3,     1,     4,     2,     5,     3,
       6,     0,     0,     5,     2,     5,     3,     6,     2,     5,
       3,     6,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     2,     2,     2,     5,     3,     6,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     6,     1,
       1,     1,     1,     3,     1,     3,     6,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     2,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     5,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       2,     5,     3,     6,     1,     1,     1,     1,     3,     1,
       2,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     2,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     2,     5,     2,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       1,     1,     5,     1,     2,     6,     4,     2,     5,     3,
       6,     1,     3,     1,     1,     1,     1,     1,     5,     1,
       3,     1,     1,     1,     1,     1,     3,     8,     5,     1,
       2,     9,     0,     6,     2,     1,     4,     6,     2,     5,
       3,     6,     3,     1,     1,     1,     1,     2,     5,     3,
       1,     1,     1,     1,     1,     2,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     1,     1,     1,     3,     5,
       3,     3,     3,     3,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     1,     3,
       5,     1,     1,     1,     1,     1,     3,     5,     3,     3,
       3,     3,     3,     5,     3,     3,     3,     3,     1,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     3,
       3,     1,     3,     1,     3,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     3,     3,     3,     3,     3,
       1,     1,     1,     1,     3,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     5,     5,     3,     3,     5,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     3,     3,     3,     3,     3,
       1,     1,     3,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     1,     3,     3,
       3,     3,     3,     1,     1,     3,     3,     5,     3,     3,
       3,     1,     3,     1,     1,     1,     1,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     1,     3,     3,     3,     1,     3,     1,     1,
       1,     3,     3,     3,     3,     1,     3,     1,     3,     3,
       3,     1,     1,     3,     3,     3,     3,     3,     3,     3,
       1,     1,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     1,     3,     1,     2,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
  };



  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a yyntokens_, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "$end", "error", "$undefined", "AIM_SOLVER", "ANALYTIC_DERIVATION",
  "AR", "AUTOCORR", "BAYESIAN_IRF", "BETA_PDF", "BLOCK", "USE_CALIBRATION",
  "BVAR_DENSITY", "BVAR_FORECAST", "BVAR_PRIOR_DECAY", "BVAR_PRIOR_FLAT",
  "BVAR_PRIOR_LAMBDA", "BVAR_PRIOR_MU", "BVAR_PRIOR_OMEGA",
  "BVAR_PRIOR_TAU", "BVAR_PRIOR_TRAIN", "BVAR_REPLIC", "BYTECODE",
  "ALL_VALUES_REQUIRED", "CALIB_SMOOTHER", "CHANGE_TYPE", "CHECK",
  "CONDITIONAL_FORECAST", "CONDITIONAL_FORECAST_PATHS", "CONF_SIG",
  "CONSTANT", "CONTROLLED_VAREXO", "CORR", "COVAR", "CUTOFF",
  "CYCLE_REDUCTION", "LOGARITHMIC_REDUCTION", "DATAFILE", "FILE",
  "DOUBLING", "DR_CYCLE_REDUCTION_TOL", "DR_LOGARITHMIC_REDUCTION_TOL",
  "DR_LOGARITHMIC_REDUCTION_MAXITER", "DR_ALGO", "DROP", "DSAMPLE",
  "DYNASAVE", "DYNATYPE", "CALIBRATION", "DIFFERENTIATE_FORWARD_VARS",
  "END", "ENDVAL", "EQUAL", "ESTIMATION", "ESTIMATED_PARAMS",
  "ESTIMATED_PARAMS_BOUNDS", "ESTIMATED_PARAMS_INIT", "EXTENDED_PATH",
  "ENDOGENOUS_PRIOR", "FILENAME", "FILTER_STEP_AHEAD", "FILTERED_VARS",
  "FIRST_OBS", "LAST_OBS", "SET_TIME", "FLOAT_NUMBER", "DATES", "DEFAULT",
  "FIXED_POINT", "FORECAST", "K_ORDER_SOLVER", "INSTRUMENTS", "SHIFT",
  "MEAN", "STDEV", "VARIANCE", "MODE", "INTERVAL", "SHAPE", "DOMAINN",
  "GAMMA_PDF", "GRAPH", "GRAPH_FORMAT",
  "CONDITIONAL_VARIANCE_DECOMPOSITION", "NOCHECK", "STD", "HISTVAL",
  "HOMOTOPY_SETUP", "HOMOTOPY_MODE", "HOMOTOPY_STEPS",
  "HOMOTOPY_FORCE_CONTINUE", "HP_FILTER", "HP_NGRID", "HYBRID",
  "IDENTIFICATION", "INF_CONSTANT", "INITVAL", "INITVAL_FILE", "BOUNDS",
  "JSCALE", "INIT", "INT_NUMBER", "INV_GAMMA_PDF", "INV_GAMMA1_PDF",
  "INV_GAMMA2_PDF", "IRF", "IRF_SHOCKS", "IRF_PLOT_THRESHOLD",
  "KALMAN_ALGO", "KALMAN_TOL", "SUBSAMPLES", "OPTIONS", "TOLF", "LAPLACE",
  "LIK_ALGO", "LIK_INIT", "LINEAR", "LOAD_IDENT_FILES", "LOAD_MH_FILE",
  "LOAD_PARAMS_AND_STEADY_STATE", "LOGLINEAR", "LYAPUNOV",
  "LYAPUNOV_FIXED_POINT_TOL", "LYAPUNOV_DOUBLING_TOL",
  "LYAPUNOV_SQUARE_ROOT_SOLVER_TOL", "LOG_DEFLATOR", "LOG_TREND_VAR",
  "LOG_GROWTH_FACTOR", "MARKOWITZ", "MARGINAL_DENSITY", "MAX", "MAXIT",
  "MFS", "MH_CONF_SIG", "MH_DROP", "MH_INIT_SCALE", "MH_JSCALE", "MH_MODE",
  "MH_NBLOCKS", "MH_REPLIC", "MH_RECOVER", "MIN",
  "MINIMAL_SOLVING_PERIODS", "MODE_CHECK", "MODE_CHECK_NEIGHBOURHOOD_SIZE",
  "MODE_CHECK_SYMMETRIC_PLOTS", "MODE_CHECK_NUMBER_OF_POINTS",
  "MODE_COMPUTE", "MODE_FILE", "MODEL", "MODEL_COMPARISON", "MODEL_INFO",
  "MSHOCKS", "ABS", "SIGN", "MODEL_DIAGNOSTICS", "MODIFIEDHARMONICMEAN",
  "MOMENTS_VARENDO", "DIFFUSE_FILTER", "SUB_DRAWS", "TAPER_STEPS",
  "GEWEKE_INTERVAL", "MCMC_JUMPING_COVARIANCE", "NAME", "NAN_CONSTANT",
  "NO_STATIC", "NOBS", "NOCONSTANT", "NODISPLAY", "NOCORR", "NODIAGNOSTIC",
  "NOFUNCTIONS", "NOGRAPH", "NOMOMENTS", "NOPRINT", "NORMAL_PDF",
  "SAVE_DRAWS", "OBSERVATION_TRENDS", "OPTIM", "OPTIM_WEIGHTS", "ORDER",
  "OSR", "OSR_PARAMS", "MAX_DIM_COVA_GROUP", "ADVANCED",
  "PARALLEL_LOCAL_FILES", "PARAMETERS", "PARAMETER_SET",
  "PARTIAL_INFORMATION", "PERFECT_FORESIGHT", "PERIODS",
  "PLANNER_OBJECTIVE", "PLOT_CONDITIONAL_FORECAST", "PLOT_PRIORS",
  "PREFILTER", "PRESAMPLE", "PRINT", "PRIOR_MC", "PRIOR_TRUNC",
  "PRIOR_MODE", "PRIOR_MEAN", "POSTERIOR_MODE", "POSTERIOR_MEAN",
  "POSTERIOR_MEDIAN", "PRUNING", "QUOTED_STRING", "QZ_CRITERIUM",
  "QZ_ZERO_THRESHOLD", "FULL", "DSGE_VAR", "DSGE_VARLAG",
  "DSGE_PRIOR_WEIGHT", "TRUNCATE", "RELATIVE_IRF", "REPLIC",
  "SIMUL_REPLIC", "RPLOT", "SAVE_PARAMS_AND_STEADY_STATE",
  "PARAMETER_UNCERTAINTY", "SHOCKS", "SHOCK_DECOMPOSITION", "SIGMA_E",
  "SIMUL", "SIMUL_ALGO", "SIMUL_SEED", "SMOOTHER", "SQUARE_ROOT_SOLVER",
  "STACK_SOLVE_ALGO", "STEADY_STATE_MODEL", "SOLVE_ALGO", "SOLVER_PERIODS",
  "STDERR", "STEADY", "STOCH_SIMUL", "SURPRISE", "SYLVESTER",
  "SYLVESTER_FIXED_POINT_TOL", "REGIMES", "REGIME", "TEX", "RAMSEY_POLICY",
  "PLANNER_DISCOUNT", "DISCRETIONARY_POLICY", "DISCRETIONARY_TOL",
  "TEX_NAME", "UNIFORM_PDF", "UNIT_ROOT_VARS", "USE_DLL", "USEAUTOCORR",
  "GSA_SAMPLE_FILE", "USE_UNIVARIATE_FILTERS_IF_SINGULARITY_IS_DETECTED",
  "VALUES", "VAR", "VAREXO", "VAREXO_DET", "VAROBS",
  "PREDETERMINED_VARIABLES", "WRITE_LATEX_DYNAMIC_MODEL",
  "WRITE_LATEX_STATIC_MODEL", "XLS_SHEET", "XLS_RANGE", "LONG_NAME",
  "COMMA", "EQUAL_EQUAL", "EXCLAMATION_EQUAL", "LESS", "GREATER",
  "LESS_EQUAL", "GREATER_EQUAL", "PLUS", "MINUS", "TIMES", "DIVIDE",
  "UMINUS", "UPLUS", "POWER", "EXP", "LOG", "LN", "LOG10", "SIN", "COS",
  "TAN", "ASIN", "ACOS", "ATAN", "SINH", "COSH", "TANH", "ERF", "ASINH",
  "ACOSH", "ATANH", "SQRT", "NORMCDF", "NORMPDF", "STEADY_STATE",
  "EXPECTATION", "DYNARE_SENSITIVITY", "MORRIS", "STAB", "REDFORM",
  "PPRIOR", "PRIOR_RANGE", "PPOST", "ILPTAU", "MORRIS_NLIV", "MORRIS_NTRA",
  "NSAM", "LOAD_REDFORM", "LOAD_RMSE", "LOAD_STAB", "ALPHA2_STAB",
  "KSSTAT", "LOGTRANS_REDFORM", "THRESHOLD_REDFORM", "KSSTAT_REDFORM",
  "ALPHA2_REDFORM", "NAMENDO", "NAMLAGENDO", "NAMEXO", "RMSE", "LIK_ONLY",
  "VAR_RMSE", "PFILT_RMSE", "ISTART_RMSE", "ALPHA_RMSE", "ALPHA2_RMSE",
  "FREQ", "INITIAL_YEAR", "INITIAL_SUBPERIOD", "FINAL_YEAR",
  "FINAL_SUBPERIOD", "DATA", "VLIST", "LOG_VAR", "PERCENT_VAR", "VLISTLOG",
  "VLISTPER", "RESTRICTION", "RESTRICTION_FNAME", "CROSS_RESTRICTIONS",
  "NLAGS", "CONTEMP_REDUCED_FORM", "REAL_PSEUDO_FORECAST", "DUMMY_OBS",
  "NSTATES", "INDXSCALESSTATES", "NO_BAYESIAN_PRIOR", "SPECIFICATION",
  "SIMS_ZHA", "ALPHA", "BETA", "ABAND", "NINV", "CMS", "NCMS", "CNUM",
  "GAMMA", "INV_GAMMA", "INV_GAMMA1", "INV_GAMMA2", "NORMAL", "UNIFORM",
  "EPS", "PDF", "FIG", "DR", "NONE", "PRIOR", "PRIOR_VARIANCE", "HESSIAN",
  "IDENTITY_MATRIX", "GSIG2_LMDM", "Q_DIAG", "FLAT_PRIOR", "NCSK", "NSTD",
  "INDXPARR", "INDXOVR", "INDXAP", "APBAND", "INDXIMF", "IMFBAND",
  "INDXFORE", "FOREBAND", "INDXGFOREHAT", "INDXGIMFHAT", "INDXESTIMA",
  "INDXGDLS", "EQ_MS", "FILTER_COVARIANCE", "FILTER_DECOMPOSITION",
  "EQ_CMS", "TLINDX", "TLNUMBER", "BANACT", "RESTRICTIONS",
  "OUTPUT_FILE_TAG", "DRAWS_NBR_BURN_IN_1", "DRAWS_NBR_BURN_IN_2",
  "HORIZON", "SBVAR", "TREND_VAR", "DEFLATOR", "GROWTH_FACTOR", "MS_IRF",
  "MS_VARIANCE_DECOMPOSITION", "MS_ESTIMATION", "MS_SIMULATION",
  "MS_COMPUTE_MDD", "MS_COMPUTE_PROBABILITIES", "MS_FORECAST",
  "SVAR_IDENTIFICATION", "EQUATION", "EXCLUSION", "LAG", "UPPER_CHOLESKY",
  "LOWER_CHOLESKY", "MONTHLY", "QUARTERLY", "MARKOV_SWITCHING", "CHAIN",
  "DURATION", "NUMBER_OF_REGIMES", "SVAR", "COEFF", "COEFFICIENTS",
  "VARIANCES", "CONSTANTS", "EQUATIONS", "EXTERNAL_FUNCTION",
  "EXT_FUNC_NAME", "EXT_FUNC_NARGS", "FIRST_DERIV_PROVIDED",
  "SECOND_DERIV_PROVIDED", "SELECTED_VARIABLES_ONLY", "COVA_COMPUTE",
  "SIMULATION_FILE_TAG", "FILE_TAG", "NO_ERROR_BANDS",
  "ERROR_BAND_PERCENTILES", "SHOCKS_PER_PARAMETER", "NO_CREATE_INIT",
  "SHOCK_DRAWS", "FREE_PARAMETERS", "MEDIAN", "DATA_OBS_NBR",
  "NEIGHBORHOOD_WIDTH", "PVALUE_KS", "PVALUE_CORR",
  "FILTERED_PROBABILITIES", "REAL_TIME_SMOOTHED", "PROPOSAL_TYPE",
  "PROPOSAL_UPPER_BOUND", "PROPOSAL_LOWER_BOUND", "PROPOSAL_DRAWS",
  "USE_MEAN_CENTER", "ADAPTIVE_MH_DRAWS", "THINNING_FACTOR",
  "COEFFICIENTS_PRIOR_HYPERPARAMETERS", "CONVERGENCE_STARTING_VALUE",
  "CONVERGENCE_ENDING_VALUE", "CONVERGENCE_INCREMENT_VALUE",
  "MAX_ITERATIONS_STARTING_VALUE", "MAX_ITERATIONS_INCREMENT_VALUE",
  "MAX_BLOCK_ITERATIONS", "MAX_REPEATED_OPTIMIZATION_RUNS",
  "FUNCTION_CONVERGENCE_CRITERION", "PARAMETER_CONVERGENCE_CRITERION",
  "NUMBER_OF_LARGE_PERTURBATIONS", "NUMBER_OF_SMALL_PERTURBATIONS",
  "NUMBER_OF_POSTERIOR_DRAWS_AFTER_PERTURBATION", "MAX_NUMBER_OF_STAGES",
  "RANDOM_FUNCTION_CONVERGENCE_CRITERION",
  "RANDOM_PARAMETER_CONVERGENCE_CRITERION", "';'", "'('", "')'", "'['",
  "']'", "'#'", "':'", "'.'", "$accept", "statement_list", "statement",
  "dsample", "rplot", "trend_var", "$@1", "trend_var_list",
  "log_trend_var", "$@2", "log_trend_var_list", "var", "$@3", "$@4",
  "nonstationary_var_list", "varexo", "varexo_det",
  "predetermined_variables", "parameters", "named_var", "var_list",
  "varexo_list", "varexo_det_list", "parameter_list",
  "predetermined_variables_list", "change_type", "change_type_arg",
  "change_type_var_list", "periods", "init_param", "expression", "$@5",
  "comma_expression", "expression_or_empty", "initval", "initval_file",
  "endval", "initval_list", "initval_elem", "histval", "histval_list",
  "histval_elem", "model_options", "model_options_list", "model", "$@6",
  "$@7", "equation_list", "equation", "tags_list", "tag_pair", "hand_side",
  "$@8", "comma_hand_side", "pound_expression", "shocks", "shock_list",
  "shock_elem", "det_shock_elem", "svar_identification", "$@9",
  "svar_identification_list", "svar_identification_elem", "$@10", "$@11",
  "svar_equation_list", "svar_var_list", "restriction_expression",
  "restriction_expression_1", "restriction_elem_expression",
  "markov_switching", "ms_options_list", "ms_options", "svar",
  "svar_options_list", "svar_options", "mshocks", "mshock_list",
  "period_list", "sigma_e", "value_list", "triangular_matrix",
  "triangular_row", "steady", "steady_options_list", "steady_options",
  "check", "check_options_list", "check_options", "model_info",
  "model_info_options_list", "model_info_options", "simul",
  "simul_options_list", "simul_options", "external_function",
  "external_function_options_list", "external_function_options",
  "stoch_simul", "stoch_simul_options_list", "stoch_simul_primary_options",
  "stoch_simul_options", "symbol_list", "symbol_list_ext",
  "signed_integer", "non_negative_number", "signed_number", "signed_inf",
  "signed_number_w_inf", "estimated_params", "estimated_list",
  "estimated_elem", "estimated_elem1", "estimated_elem2",
  "estimated_elem3", "estimated_params_init", "estimated_init_list",
  "estimated_init_elem", "estimated_params_bounds",
  "estimated_bounds_list", "estimated_bounds_elem", "prior_distribution",
  "prior_pdf", "date_str", "date_expr", "set_time", "data",
  "data_options_list", "data_options", "subsamples", "subsamples_eq",
  "subsamples_eq_opt", "subsamples_name_list", "prior", "$@12", "$@13",
  "$@14", "$@15", "$@16", "$@17", "prior_options_list", "prior_options",
  "prior_eq", "prior_eq_opt", "options", "options_options_list",
  "options_options", "options_eq", "options_eq_opt", "estimation",
  "estimation_options_list", "estimation_options", "list_optim_option",
  "optim_options", "varobs", "$@18", "varobs_list", "observation_trends",
  "trend_list", "trend_element", "unit_root_vars", "optim_weights",
  "optim_weights_list", "osr_params", "osr_options_list", "osr_options",
  "osr", "dynatype", "dynasave", "load_params_and_steady_state",
  "save_params_and_steady_state", "identification",
  "identification_options_list", "identification_option",
  "model_comparison", "filename", "parallel_local_filename_list",
  "mc_filename_list", "planner_objective", "$@19", "$@20", "ramsey_policy",
  "discretionary_policy", "discretionary_policy_options_list",
  "discretionary_policy_options", "ramsey_policy_options_list",
  "ramsey_policy_options", "write_latex_dynamic_model",
  "write_latex_static_model", "shock_decomposition", "bvar_prior_option",
  "bvar_common_option", "bvar_density_options_list", "bvar_density",
  "bvar_forecast_option", "bvar_forecast_options_list", "bvar_forecast",
  "sbvar_option", "sbvar_options_list", "sbvar",
  "ms_variance_decomposition_option",
  "ms_variance_decomposition_options_list", "ms_variance_decomposition",
  "ms_forecast_option", "ms_forecast_options_list", "ms_forecast",
  "ms_irf_option", "ms_irf_options_list", "ms_irf",
  "ms_compute_probabilities_option",
  "ms_compute_probabilities_options_list", "ms_compute_probabilities",
  "ms_compute_mdd_option", "ms_compute_mdd_options_list", "ms_compute_mdd",
  "ms_simulation_option", "ms_simulation_options_list", "ms_simulation",
  "ms_estimation_option", "ms_estimation_options_list", "ms_estimation",
  "dynare_sensitivity", "dynare_sensitivity_options_list",
  "dynare_sensitivity_option", "shock_decomposition_options_list",
  "shock_decomposition_option", "homotopy_setup", "homotopy_list",
  "homotopy_item", "forecast", "forecast_options", "forecast_option",
  "conditional_forecast", "conditional_forecast_options",
  "conditional_forecast_option", "plot_conditional_forecast",
  "conditional_forecast_paths", "conditional_forecast_paths_shock_list",
  "conditional_forecast_paths_shock_elem", "steady_state_model", "$@21",
  "steady_state_equation_list", "steady_state_equation", "calib_smoother",
  "calib_smoother_options_list", "calib_smoother_option", "extended_path",
  "extended_path_options_list", "extended_path_option",
  "model_diagnostics", "o_dr_algo", "o_solve_algo", "o_simul_algo",
  "o_stack_solve_algo", "o_linear", "o_order", "o_replic", "o_drop",
  "o_ar", "o_nocorr", "o_nofunctions", "o_nomoments", "o_irf",
  "o_irf_shocks", "o_hp_filter", "o_hp_ngrid", "o_periods",
  "o_solver_periods", "o_extended_path_order", "o_hybrid",
  "o_steady_maxit", "o_simul_maxit", "o_dp_maxit", "o_osr_maxit",
  "o_osr_tolf", "o_cutoff", "o_markowitz", "o_minimal_solving_periods",
  "o_mfs", "o_simul", "o_simul_replic", "o_simul_seed", "o_qz_criterium",
  "o_qz_zero_threshold", "o_file", "o_datafile", "o_nobs",
  "o_conditional_variance_decomposition", "o_first_obs",
  "o_new_estimation_data_first_obs", "o_last_obs", "o_shift", "o_shape",
  "o_mode", "o_mean", "o_truncate", "o_stdev", "o_jscale", "o_init",
  "o_bounds", "o_domain", "o_interval", "o_variance",
  "o_new_estimation_data_nobs", "o_prefilter", "o_presample", "o_lik_algo",
  "o_lik_init", "o_nograph", "o_nodisplay", "o_graph_format",
  "allowed_graph_formats", "list_allowed_graph_formats",
  "o_subsample_name", "o_conf_sig", "o_mh_conf_sig", "o_mh_replic",
  "o_mh_drop", "o_mh_jscale", "o_optim", "o_mh_init_scale", "o_mode_file",
  "o_mode_compute", "o_mode_check", "o_mode_check_neighbourhood_size",
  "o_mode_check_number_of_points", "o_mode_check_symmetric_plots",
  "o_prior_trunc", "o_mh_mode", "o_mh_nblocks", "o_load_mh_file",
  "o_loglinear", "o_nodiagnostic", "o_bayesian_irf", "o_dsge_var",
  "o_dsge_varlag", "o_tex", "o_forecast", "o_smoother",
  "o_moments_varendo", "o_filtered_vars", "o_relative_irf",
  "o_kalman_algo", "o_kalman_tol", "o_marginal_density", "o_print",
  "o_noprint", "o_xls_sheet", "o_xls_range", "o_filter_step_ahead",
  "o_taper_steps", "o_geweke_interval", "o_constant", "o_noconstant",
  "o_mh_recover", "o_diffuse_filter", "o_plot_priors", "o_aim_solver",
  "o_partial_information", "o_sub_draws", "o_planner_discount",
  "o_sylvester", "o_sylvester_fixed_point_tol", "o_lyapunov",
  "o_lyapunov_fixed_point_tol", "o_lyapunov_doubling_tol", "o_dr",
  "o_dr_cycle_reduction_tol", "o_dr_logarithmic_reduction_tol",
  "o_dr_logarithmic_reduction_maxiter", "o_bvar_prior_tau",
  "o_bvar_prior_decay", "o_bvar_prior_lambda", "o_bvar_prior_mu",
  "o_bvar_prior_omega", "o_bvar_prior_flat", "o_bvar_prior_train",
  "o_bvar_replic", "o_gsa_identification", "o_gsa_morris", "o_gsa_stab",
  "o_gsa_redform", "o_gsa_pprior", "o_gsa_prior_range", "o_gsa_ppost",
  "o_gsa_ilptau", "o_gsa_morris_nliv", "o_gsa_morris_ntra", "o_gsa_nsam",
  "o_gsa_load_redform", "o_gsa_load_rmse", "o_gsa_load_stab",
  "o_gsa_alpha2_stab", "o_gsa_ksstat", "o_gsa_logtrans_redform",
  "o_gsa_threshold_redform", "o_gsa_ksstat_redform",
  "o_gsa_alpha2_redform", "o_gsa_namendo", "o_gsa_namlagendo",
  "o_gsa_namexo", "o_gsa_rmse", "o_gsa_lik_only", "o_gsa_var_rmse",
  "o_gsa_pfilt_rmse", "o_gsa_istart_rmse", "o_gsa_alpha_rmse",
  "o_gsa_alpha2_rmse", "o_gsa_sample_file", "o_gsa_neighborhood_width",
  "o_gsa_pvalue_ks", "o_gsa_pvalue_corr", "o_load_ident_files",
  "o_useautocorr", "o_prior_mc", "o_advanced", "o_max_dim_cova_group",
  "o_homotopy_mode", "o_homotopy_steps", "o_homotopy_force_continue",
  "o_nocheck", "o_controlled_varexo", "o_parameter_set", "o_ms_drop",
  "o_ms_mh_replic", "o_freq", "o_initial_year", "o_initial_subperiod",
  "o_final_year", "o_final_subperiod", "o_data", "o_vlist", "o_vlistlog",
  "o_vlistper", "o_restriction_fname", "o_nlags", "o_cross_restrictions",
  "o_contemp_reduced_form", "o_real_pseudo_forecast",
  "o_no_bayesian_prior", "o_dummy_obs", "o_nstates", "o_indxscalesstates",
  "o_alpha", "o_beta", "o_gsig2_lmdm", "o_specification", "o_q_diag",
  "o_flat_prior", "o_ncsk", "o_nstd", "o_ninv", "o_indxparr", "o_indxovr",
  "o_aband", "o_indxap", "o_apband", "o_indximf", "o_indxfore",
  "o_foreband", "o_indxgforhat", "o_indxgimfhat", "o_indxestima",
  "o_indxgdls", "o_eq_ms", "o_cms", "o_ncms", "o_eq_cms", "o_tlindx",
  "o_tlnumber", "o_cnum", "o_k_order_solver", "o_pruning", "o_chain",
  "o_restrictions", "o_duration", "o_number_of_regimes", "o_coefficients",
  "o_variances", "o_equations", "o_instruments", "o_ext_func_name",
  "o_ext_func_nargs", "o_first_deriv_provided", "o_second_deriv_provided",
  "o_filter_covariance", "o_filter_decomposition",
  "o_selected_variables_only", "o_cova_compute", "o_output_file_tag",
  "o_file_tag", "o_no_create_init", "o_simulation_file_tag",
  "o_coefficients_prior_hyperparameters", "o_convergence_starting_value",
  "o_convergence_ending_value", "o_convergence_increment_value",
  "o_max_iterations_starting_value", "o_max_iterations_increment_value",
  "o_max_block_iterations", "o_max_repeated_optimization_runs",
  "o_function_convergence_criterion", "o_parameter_convergence_criterion",
  "o_number_of_large_perturbations", "o_number_of_small_perturbations",
  "o_number_of_posterior_draws_after_perturbation",
  "o_max_number_of_stages", "o_random_function_convergence_criterion",
  "o_random_parameter_convergence_criterion", "o_thinning_factor",
  "o_adaptive_mh_draws", "o_save_draws", "o_proposal_draws",
  "o_use_mean_center", "o_proposal_type", "o_proposal_lower_bound",
  "o_proposal_upper_bound", "o_parameter_uncertainty", "o_horizon",
  "o_filtered_probabilities", "o_real_time_smoothed", "o_no_error_bands",
  "o_error_band_percentiles", "o_shock_draws", "o_shocks_per_parameter",
  "o_free_parameters", "o_median", "o_regimes", "o_regime",
  "o_data_obs_nbr", "o_discretionary_tol", "o_analytic_derivation",
  "o_endogenous_prior",
  "o_use_univariate_filters_if_singularity_is_detected",
  "o_mcmc_jumping_covariance", "o_irf_plot_threshold", "range",
  "vec_int_number", "vec_int_elem", "vec_int_1", "vec_int", "vec_value_1",
  "vec_value", "vec_value_list", "vec_of_vec_value", "vec_value_1_w_inf",
  "vec_value_w_inf", "symbol", YY_NULLPTR
  };

#if YYDEBUG
  const unsigned short int
  parser::yyrline_[] =
  {
       0,   190,   190,   191,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   275,   277,   281,   283,   283,   287,   289,
     291,   293,   295,   297,   301,   301,   305,   307,   309,   311,
     313,   315,   319,   320,   320,   322,   322,   326,   328,   330,
     332,   334,   336,   338,   340,   342,   344,   346,   348,   352,
     354,   356,   358,   360,   364,   366,   368,   370,   372,   374,
     376,   378,   380,   382,   384,   386,   390,   392,   394,   396,
     398,   400,   402,   404,   406,   408,   410,   412,   416,   418,
     420,   422,   424,   426,   428,   430,   432,   434,   436,   438,
     442,   444,   446,   448,   450,   452,   454,   456,   458,   460,
     462,   464,   468,   470,   472,   476,   480,   482,   484,   486,
     490,   492,   494,   498,   500,   504,   506,   508,   510,   512,
     514,   516,   518,   520,   522,   524,   526,   528,   530,   532,
     534,   536,   538,   540,   542,   544,   546,   548,   550,   552,
     554,   556,   558,   560,   562,   564,   566,   568,   568,   570,
     572,   574,   576,   578,   580,   582,   586,   588,   592,   593,
     596,   598,   602,   606,   608,   612,   613,   616,   618,   620,
     621,   624,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   638,   639,   642,   642,   644,   644,   648,   649,
     650,   651,   654,   656,   658,   660,   664,   665,   668,   670,
     674,   676,   678,   680,   682,   684,   686,   688,   690,   692,
     694,   696,   698,   700,   702,   704,   706,   708,   710,   712,
     714,   716,   718,   720,   722,   724,   726,   728,   730,   732,
     734,   736,   738,   738,   740,   742,   744,   746,   748,   750,
     754,   756,   760,   763,   765,   766,   769,   770,   772,   774,
     776,   780,   784,   784,   788,   789,   792,   794,   797,   799,
     796,   801,   803,   807,   809,   813,   815,   819,   820,   823,
     824,   827,   829,   831,   833,   837,   841,   842,   845,   846,
     847,   848,   851,   855,   856,   859,   860,   861,   862,   865,
     867,   868,   871,   873,   875,   877,   879,   881,   885,   887,
     889,   891,   893,   895,   897,   901,   903,   907,   909,   911,
     913,   915,   917,   921,   923,   927,   928,   931,   932,   933,
     934,   935,   936,   937,   940,   942,   946,   947,   950,   951,
     954,   956,   960,   961,   963,   965,   967,   971,   972,   975,
     976,   977,   978,   979,   980,   983,   987,   988,   991,   992,
     993,   994,   997,   999,  1001,  1003,  1007,  1008,  1011,  1012,
    1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1024,  1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,  1046,  1047,  1048,  1049,  1052,  1053,  1056,
    1058,  1060,  1064,  1065,  1072,  1074,  1076,  1079,  1080,  1083,
    1085,  1087,  1090,  1092,  1094,  1098,  1099,  1102,  1104,  1106,
    1110,  1112,  1118,  1124,  1132,  1139,  1143,  1148,  1155,  1159,
    1167,  1172,  1178,  1185,  1195,  1197,  1199,  1203,  1205,  1209,
    1216,  1225,  1234,  1237,  1239,  1243,  1251,  1261,  1271,  1273,
    1275,  1277,  1279,  1281,  1283,  1287,  1289,  1291,  1293,  1295,
    1297,  1299,  1303,  1305,  1307,  1311,  1315,  1319,  1320,  1323,
    1324,  1325,  1326,  1327,  1328,  1331,  1335,  1343,  1349,  1355,
    1363,  1364,  1367,  1367,  1369,  1369,  1371,  1371,  1373,  1373,
    1375,  1375,  1377,  1377,  1381,  1382,  1385,  1386,  1387,  1388,
    1389,  1390,  1391,  1392,  1393,  1394,  1397,  1406,  1414,  1422,
    1430,  1438,  1446,  1456,  1458,  1460,  1462,  1464,  1466,  1470,
    1471,  1474,  1475,  1476,  1479,  1488,  1496,  1504,  1512,  1520,
    1528,  1538,  1540,  1542,  1544,  1548,  1549,  1552,  1553,  1554,
    1555,  1556,  1557,  1558,  1559,  1560,  1561,  1562,  1563,  1564,
    1565,  1566,  1567,  1568,  1569,  1570,  1571,  1572,  1573,  1574,
    1575,  1576,  1577,  1578,  1579,  1580,  1581,  1582,  1583,  1584,
    1585,  1586,  1587,  1588,  1589,  1590,  1591,  1592,  1593,  1594,
    1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,
    1605,  1606,  1607,  1608,  1609,  1610,  1611,  1612,  1613,  1614,
    1615,  1616,  1617,  1618,  1619,  1620,  1621,  1622,  1623,  1624,
    1625,  1626,  1627,  1628,  1631,  1633,  1637,  1638,  1641,  1641,
    1643,  1645,  1647,  1651,  1653,  1654,  1657,  1659,  1661,  1663,
    1665,  1667,  1669,  1673,  1676,  1677,  1680,  1681,  1682,  1685,
    1687,  1689,  1691,  1695,  1697,  1701,  1703,  1707,  1711,  1715,
    1717,  1721,  1722,  1725,  1726,  1727,  1728,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1743,
    1745,  1749,  1750,  1753,  1755,  1759,  1761,  1763,  1765,  1767,
    1769,  1773,  1774,  1773,  1776,  1778,  1780,  1782,  1786,  1788,
    1790,  1792,  1796,  1797,  1800,  1801,  1802,  1805,  1806,  1809,
    1810,  1811,  1814,  1818,  1822,  1824,  1826,  1828,  1832,  1833,
    1834,  1835,  1836,  1837,  1838,  1841,  1842,  1843,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1853,  1854,  1857,  1859,  1863,
    1864,  1865,  1866,  1869,  1870,  1873,  1875,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,  1901,
    1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,  1911,
    1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,  1921,
    1922,  1923,  1924,  1925,  1926,  1929,  1930,  1933,  1935,  1939,
    1940,  1941,  1942,  1943,  1944,  1945,  1946,  1947,  1948,  1949,
    1950,  1951,  1952,  1955,  1956,  1959,  1961,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972,  1973,  1974,  1975,  1976,  1977,
    1980,  1981,  1984,  1986,  1990,  1991,  1992,  1993,  1994,  1995,
    1996,  1997,  1998,  1999,  2000,  2001,  2002,  2003,  2006,  2007,
    2010,  2012,  2014,  2016,  2020,  2021,  2022,  2023,  2026,  2027,
    2030,  2032,  2036,  2037,  2038,  2039,  2040,  2041,  2042,  2043,
    2046,  2047,  2050,  2052,  2056,  2057,  2058,  2059,  2060,  2061,
    2062,  2065,  2066,  2069,  2071,  2075,  2076,  2077,  2078,  2079,
    2080,  2081,  2082,  2083,  2084,  2085,  2086,  2087,  2088,  2089,
    2090,  2091,  2092,  2093,  2094,  2095,  2096,  2097,  2098,  2099,
    2100,  2101,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2109,
    2112,  2113,  2116,  2118,  2122,  2124,  2128,  2129,  2132,  2133,
    2134,  2135,  2136,  2137,  2138,  2139,  2140,  2141,  2142,  2143,
    2144,  2145,  2146,  2147,  2148,  2149,  2150,  2151,  2152,  2153,
    2154,  2155,  2156,  2157,  2158,  2159,  2160,  2161,  2162,  2163,
    2164,  2165,  2166,  2167,  2168,  2169,  2170,  2171,  2172,  2173,
    2174,  2175,  2176,  2177,  2178,  2179,  2180,  2181,  2184,  2185,
    2188,  2189,  2192,  2195,  2196,  2199,  2201,  2205,  2206,  2207,
    2208,  2211,  2212,  2215,  2216,  2217,  2218,  2219,  2222,  2226,
    2227,  2230,  2231,  2232,  2233,  2234,  2237,  2239,  2243,  2247,
    2248,  2251,  2255,  2255,  2259,  2260,  2263,  2265,  2269,  2271,
    2273,  2275,  2279,  2280,  2283,  2284,  2285,  2288,  2290,  2294,
    2295,  2298,  2299,  2300,  2301,  2304,  2308,  2314,  2315,  2321,
    2322,  2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,
    2332,  2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,
    2342,  2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,
    2352,  2353,  2354,  2356,  2359,  2361,  2364,  2365,  2368,  2371,
    2372,  2373,  2374,  2375,  2376,  2377,  2378,  2379,  2380,  2381,
    2382,  2383,  2384,  2385,  2386,  2387,  2388,  2390,  2393,  2394,
    2396,  2399,  2401,  2403,  2405,  2408,  2409,  2412,  2415,  2416,
    2417,  2418,  2419,  2420,  2421,  2422,  2423,  2424,  2425,  2426,
    2427,  2428,  2429,  2430,  2431,  2432,  2433,  2434,  2435,  2436,
    2438,  2440,  2443,  2444,  2445,  2446,  2447,  2448,  2449,  2450,
    2451,  2452,  2454,  2457,  2458,  2459,  2460,  2461,  2462,  2463,
    2464,  2465,  2466,  2467,  2468,  2469,  2470,  2471,  2472,  2473,
    2474,  2475,  2476,  2477,  2478,  2479,  2480,  2481,  2482,  2483,
    2484,  2485,  2486,  2487,  2489,  2490,  2491,  2492,  2493,  2494,
    2495,  2496,  2498,  2499,  2500,  2501,  2502,  2503,  2504,  2505,
    2506,  2507,  2508,  2509,  2510,  2511,  2512,  2513,  2514,  2515,
    2516,  2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,
    2526,  2527,  2528,  2530,  2533,  2534,  2535,  2536,  2537,  2538,
    2539,  2540,  2542,  2543,  2544,  2545,  2547,  2548,  2550,  2552,
    2554,  2556,  2558,  2561,  2562,  2563,  2565,  2567,  2570,  2571,
    2572,  2573,  2574,  2575,  2576,  2577,  2578,  2583,  2588,  2594,
    2595,  2596,  2597,  2598,  2599,  2600,  2601,  2602,  2603,  2604,
    2605,  2607,  2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,
    2618,  2619,  2620,  2621,  2622,  2623,  2624,  2625,  2626,  2627,
    2628,  2629,  2630,  2631,  2632,  2633,  2634,  2635,  2636,  2637,
    2640,  2642,  2645,  2646,  2647,  2648,  2650,  2654,  2656,  2657,
    2658,  2660,  2663,  2665,  2668,  2671,  2674,  2677,  2680,  2681,
    2682,  2683,  2684,  2686,  2688,  2690,  2692,  2694,  2696,  2698,
    2700,  2702,  2704,  2706,  2708,  2710,  2712,  2714,  2716,  2717,
    2718,  2719,  2720,  2721,  2722,  2723,  2724,  2725,  2726,  2727,
    2728,  2729,  2730,  2731,  2732,  2733,  2734,  2735,  2736,  2737,
    2738,  2739,  2740,  2741,  2742,  2743,  2745,  2747,  2750,  2752,
    2760,  2762,  2763,  2773,  2775,  2777,  2785,  2795,  2797,  2801,
    2802,  2803,  2810,  2819,  2820,  2823,  2830,  2834,  2835,  2837,
    2839,  2848,  2850,  2851,  2852,  2853,  2854,  2855,  2856,  2857,
    2858,  2859,  2860,  2861,  2862,  2863,  2864,  2865,  2866,  2867,
    2868,  2869
  };

  // Print the state stack on the debug stream.
  void
  parser::yystack_print_ ()
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << i->state;
    *yycdebug_ << std::endl;
  }

  // Report on the debug stream that the rule \a yyrule is going to be reduced.
  void
  parser::yy_reduce_print_ (int yyrule)
  {
    unsigned int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):" << std::endl;
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG

  // Symbol number corresponding to token number t.
  inline
  parser::token_number_type
  parser::yytranslate_ (int t)
  {
    static
    const token_number_type
    translate_table[] =
    {
     0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,   480,     2,     2,     2,     2,
     476,   477,     2,     2,     2,     2,   482,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   481,   475,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   478,     2,   479,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474
    };
    const unsigned int user_token_number_max_ = 729;
    const token_number_type undef_token_ = 2;

    if (static_cast<int>(t) <= yyeof_)
      return yyeof_;
    else if (static_cast<unsigned int> (t) <= user_token_number_max_)
      return translate_table[t];
    else
      return undef_token_;
  }


} // Dynare
#line 9790 "DynareBison.cc" // lalr1.cc:1155
#line 2871 "DynareBison.yy" // lalr1.cc:1156


void
Dynare::parser::error(const Dynare::parser::location_type &l,
                      const string &m)
{
  driver.error(l, m);
}
